'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: Tuesday, January 25, 2005
'=============================================
'Public Enum AnimationPlayStyle
'    PlayOnce
'    [Loop]
'End Enum

'Public Class AnimationTrackKey
'    Public Time As Single
'    Public Value As Single
'    Friend mstrAnimation As String
'    Friend mstrTrack As String

'    Public ReadOnly Property Animation() As String
'        Get
'            Return mstrAnimation
'        End Get
'    End Property

'    Public ReadOnly Property Track() As String
'        Get
'            Return mstrTrack
'        End Get
'    End Property
'End Class

'Friend Structure AnimationTrack
'    Public Keys() As Single ' Collections.ArrayList
'    Public Enabled As Boolean

'    Friend Function GetNextKey(Optional ByVal PlayStyle As AnimationPlayStyle = AnimationPlayStyle.PlayOnce) As AnimationTrackKey
'        If Me.CurrenKey = -1 Then Return Nothing

'        Dim V As AnimationTrackKey
'        Select Case PlayStyle
'            Case AnimationPlayStyle.PlayOnce
'                If Me.CurrenKey = Me.Keys.Count - 1 Then Return Nothing
'                Return DirectCast(Me.Keys(Me.CurrenKey + 1), AnimationTrackKey)

'            Case AnimationPlayStyle.Loop
'                If Me.CurrenKey = Me.Keys.Count - 1 Then
'                    Return DirectCast(Me.Keys(Me.Keys.Count - 1), AnimationTrackKey)
'                Else
'                    Return DirectCast(Me.Keys(Me.CurrenKey + 1), AnimationTrackKey)
'                End If
'        End Select

'        Return Nothing
'    End Function
'End Structure



Public Module Animate
    Public mobjAnimations As New Collections.Hashtable()

    Public Function SetTrackBaseTime(ByVal Animation As String, ByVal Track As String, ByVal Value As Long) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            DirectCast(.mobjTracks(Track), Track).mlngBaseTime = Value
        End With

        Return True
    End Function

    Public Function GetTrackBaseTime(ByVal Animation As String, ByVal Track As String, ByRef Value As Long) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Value = DirectCast(.mobjTracks(Track), Track).mlngBaseTime
        End With

        Return True
    End Function

    Public Function IsTrackDonePlaying(ByVal Animation As String, ByVal Track As String, ByRef Value As Boolean) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Value = DirectCast(.mobjTracks(Track), Track).EndOfTrack
        End With

        Return True
    End Function

    Public Function RestartAnimation(ByVal Animation As String, ByVal CurrentTime As Long) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            With .mobjTracks.GetEnumerator
                .Reset()
                While .MoveNext
                    With DirectCast(.Value, Track)
                        .CurrentKeyIndex = 0
                        .BaseTime = CurrentTime
                    End With
                End While
            End With

        End With

        Return True
    End Function

    Public Function CheckIfAllTracksDonePlaying(ByVal Animation As String, ByRef Value As Boolean) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            Value = True
            With .mobjTracks.GetEnumerator
                .Reset()
                While .MoveNext
                    With DirectCast(.Value, Track)
                        If .EndOfTrack = False Then
                            Value = False
                            Exit While
                        End If
                    End With
                End While
            End With

        End With

        Return True
    End Function

    Public Function IsTrackAtStart(ByVal Animation As String, ByVal Track As String, ByRef Value As Boolean) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Value = DirectCast(.mobjTracks(Track), Track).StartOfTrack
        End With

        Return True
    End Function

    Public Function GetTrackNames(ByVal Animation As String, ByRef Names() As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            Erase Names
            ReDim Names(.mobjTracks.Count - 1)
            .mobjTracks.Keys.CopyTo(Names, 0)
        End With

        Return True
    End Function

    Public Function GetAnimationNames(ByRef Names() As String) As Boolean
        Erase Names
        ReDim Names(mobjAnimations.Count - 1)
        mobjAnimations.Keys.CopyTo(Names, 0)

        Return True
    End Function

    Public Function GetNumberOfKeys(ByVal Animation As String, ByVal Track As String, ByRef Value As Integer) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Value = DirectCast(.mobjTracks(Track), Track).Count
        End With

        Return True
    End Function

    Public Function SetTrackPlayStyle(ByVal Animation As String, ByVal Track As String, ByVal Value As TrackPlayStyle) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            DirectCast(.mobjTracks(Track), Track).mintPlayStyle = Value
        End With

        Return True
    End Function

    Public Function SetTrackPlayStyle(ByVal Animation As String, ByVal Tracks() As String, ByVal Value As TrackPlayStyle) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            Dim Tmp As String
            For Each Tmp In Tracks
                If .mobjTracks.ContainsKey(Tmp) = False Then Return False
                DirectCast(.mobjTracks(Tmp), Track).mintPlayStyle = Value
            Next
        End With

        Return True
    End Function

    Public Function GetTrackPlayStyle(ByVal Animation As String, ByVal Track As String, ByRef Value As TrackPlayStyle) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Value = DirectCast(.mobjTracks(Track), Track).mintPlayStyle
        End With

        Return True
    End Function

    Public Function AddTrackKey(ByVal Animation As String, ByVal Track As String, ByVal KeyTime As Long, ByVal KeyValue As Single, Optional ByRef Index As Integer = -1) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            With DirectCast(.mobjTracks(Track), Track)
                Index = .DoAdd(New Key(KeyTime, KeyValue))
            End With
        End With

        Return True
    End Function

    Public Function AddTrackKey(ByVal Animation As String, ByVal Track As String, ByVal KeyTimes() As Long, _
    ByVal KeyValues() As Single, Optional ByRef Indexes() As Integer = Nothing) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        If Track Is Nothing Then Return False
        If KeyTimes Is Nothing Then Return False
        If KeyValues Is Nothing Then Return False
        If KeyTimes.Length <> KeyValues.Length Then Return False

        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False

            With DirectCast(.mobjTracks(Track), Track)
                Dim idx As Integer
                ReDim Indexes(KeyTimes.Length - 1)
                For idx = 0 To KeyTimes.Length - 1
                    Indexes(idx) = .DoAdd(New Key(KeyTimes(idx), KeyValues(idx)))
                Next
            End With

        End With

        Return True
    End Function

    Public Function RemoveTrackKey(ByVal Animation As String, ByVal Track As String, ByVal Index As Integer) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) Then Return False
            With DirectCast(.mobjTracks(Track), Track)
                If Index < 0 Then Return False
                If Index > .Count - 1 Then Return False
                .RemoveAt(Index)
            End With
        End With

        Return True
    End Function

    Public Function GetTrackKey(ByVal Animation As String, ByRef Track As String, ByVal Index As Integer, ByRef KeyTime As Long, ByRef KeyValue As Single) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) Then Return False
            With DirectCast(.mobjTracks(Track), Track)
                If Index < 0 Then Return False
                If Index > .Count - 1 Then Return False
                KeyTime = .DoItem(Index).Time
                KeyValue = .DoItem(Index).Value
            End With
        End With

        Return True
    End Function

    Public Function GetTrackKey(ByVal Animation As String, ByRef Track As String, ByVal Indexes() As Integer, ByRef KeyTimes() As Long, ByRef KeyValues() As Single) As Boolean
        If Animation Is Nothing Then Return False
        If Indexes Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) Then Return False
            With DirectCast(.mobjTracks(Track), Track)
                Dim idx As Integer
                ReDim KeyTimes(Indexes.Length - 1)
                ReDim KeyValues(Indexes.Length - 1)
                For idx = 0 To Indexes.Length - 1
                    If Indexes(idx) < 0 Then Return False
                    If Indexes(idx) > .Count - 1 Then Return False
                    KeyTimes(idx) = .DoItem(Indexes(idx)).Time
                    KeyValues(idx) = .DoItem(Indexes(idx)).Value
                Next
            End With
        End With

        Return True
    End Function

    Public Function GetTrackKeyTime(ByVal Animation As String, ByRef Track As String, ByVal Index As Integer, ByRef KeyTime As Long) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) Then Return False
            With DirectCast(.mobjTracks(Track), Track)
                If Index < 0 Then Return False
                If Index > .Count - 1 Then Return False
                KeyTime = .DoItem(Index).Time
            End With
        End With

        Return True
    End Function

    Public Function GetTrackKeyValue(ByVal Animation As String, ByRef Track As String, ByVal Index As Integer, ByRef KeyValue As Single) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) Then Return False
            With DirectCast(.mobjTracks(Track), Track)
                If Index < 0 Then Return False
                If Index > .Count - 1 Then Return False
                KeyValue = .DoItem(Index).Value
            End With
        End With

        Return True
    End Function

    '#Region " GetTrackValues overloads ... "
    '    Public Function GetTrackValue(ByVal Animation As String, ByVal Track As Integer, ByRef Value As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If Track < 0 Then Return False
    '            If Track > .mintTrackCount - 1 Then Return False
    '            Value = .Tracks(Track, .mintCurrentFrame)
    '        End With
    '        Return True
    '    End Function

    '    Public Function GetTrackValue(ByVal Animation As String, ByVal Track As String, ByRef Value As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = Track Then
    '                    Value = .Tracks(Index, .mintCurrentFrame)
    '                    Return True
    '                End If

    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function SetTrackValue(ByVal Animation As String, ByVal Track As Integer, ByVal Value As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If Track < 0 Then Return False
    '            If Track > .mintTrackCount - 1 Then Return False
    '            .Tracks(Track, .mintCurrentFrame) = Value
    '        End With
    '        Return True
    '    End Function

    '    Public Function SetTrackValue(ByVal Animation As String, ByVal Track As String, ByVal Value As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = Track Then
    '                    .Tracks(Index, .mintCurrentFrame) = Value
    '                    Return True
    '                End If

    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function SetTrackValue(ByVal Animation As String, ByVal Track As Integer, ByVal Frame As Integer, ByVal Value As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If Track < 0 Then Return False
    '            If Track > .mintTrackCount - 1 Then Return False
    '            If Frame < 0 Then Return False
    '            If Frame > .mintLength - 1 Then Return False
    '            .Tracks(Track, Frame) = Value
    '        End With
    '        Return True
    '    End Function

    '    Public Function SetTrackValue(ByVal Animation As String, ByVal Track As String, ByVal Frame As Integer, ByVal Value As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If Frame < 0 Then Return False
    '            If Frame > .mintLength - 1 Then Return False
    '            Dim Index As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = Track Then
    '                    .Tracks(Index, Frame) = Value
    '                    Return True
    '                End If

    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal Tracks() As Integer, ByRef Values() As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        Dim Ani As Animation = DirectCast(mobjAnimations(Animation), Animation)
    '        Dim idx As Integer
    '        ReDim Values(Tracks.Length - 1)
    '        While idx <= Tracks.Length - 1
    '            If Tracks(idx) < 0 Then Return False
    '            If Tracks(idx) > Ani.mintTrackCount - 1 Then Return False
    '            Values(idx) = Ani.Tracks(Tracks(idx), Ani.mintCurrentFrame)
    '            idx += 1
    '        End While
    '        Return True
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal Tracks() As String, ByRef Values() As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            Dim idx As Integer
    '            ReDim Values(Tracks.Length - 1)
    '            While idx <= Tracks.Length - 1
    '                Index = 0
    '                While Index <= .mintTrackCount - 1
    '                    If .TrackNames(Index) = Tracks(idx) Then
    '                        Values(idx) = .Tracks(Index, .mintCurrentFrame)
    '                        Count += 1
    '                    End If

    '                    If Count = Tracks.Length Then Return True
    '                    Index += 1
    '                End While
    '                idx += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function SetTrackValues(ByVal Animation As String, ByVal Tracks() As Integer, ByVal Values() As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        If Tracks Is Nothing Then Return False
    '        If Values Is Nothing Then Return False
    '        If Tracks.Length <> Values.Length Then Return False
    '        Dim Ani As Animation = DirectCast(mobjAnimations(Animation), Animation)
    '        Dim idx As Integer
    '        While idx <= Tracks.Length - 1
    '            If Tracks(idx) < 0 Then Return False
    '            If Tracks(idx) > Ani.mintTrackCount - 1 Then Return False
    '            Ani.Tracks(Tracks(idx), Ani.mintCurrentFrame) = Values(idx)
    '            idx += 1
    '        End While
    '        Return True
    '    End Function

    '    Public Function SetTrackValues(ByVal Animation As String, ByVal Tracks() As String, ByVal Values() As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        If Tracks Is Nothing Then Return False
    '        If Values Is Nothing Then Return False
    '        If Tracks.Length <> Values.Length Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            Dim idx As Integer
    '            While idx <= Tracks.Length - 1
    '                Index = 0
    '                While Index <= .mintTrackCount - 1
    '                    If .TrackNames(Index) = Tracks(idx) Then
    '                        .Tracks(Index, .mintCurrentFrame) = Values(idx)
    '                        Count += 1
    '                    End If

    '                    If Count = Tracks.Length Then Return True
    '                    Index += 1
    '                End While
    '                idx += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function SetTrackValues(ByVal Animation As String, ByVal Frame As Integer, ByVal Tracks() As Integer, ByVal Values() As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        If Tracks Is Nothing Then Return False
    '        If Values Is Nothing Then Return False
    '        If Tracks.Length <> Values.Length Then Return False
    '        Dim Ani As Animation = DirectCast(mobjAnimations(Animation), Animation)
    '        If Frame < 0 Then Return False
    '        If Frame > Ani.mintLength - 1 Then Return False
    '        Dim idx As Integer
    '        While idx <= Tracks.Length - 1
    '            If Tracks(idx) < 0 Then Return False
    '            If Tracks(idx) > Ani.mintTrackCount - 1 Then Return False
    '            Ani.Tracks(Tracks(idx), Frame) = Values(idx)
    '            idx += 1
    '        End While
    '        Return True
    '    End Function

    '    Public Function SetTrackValues(ByVal Animation As String, ByVal Frame As Integer, ByVal Tracks() As String, ByVal Values() As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        If Tracks Is Nothing Then Return False
    '        If Values Is Nothing Then Return False
    '        If Tracks.Length <> Values.Length Then Return False
    '        If Frame < 0 Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If Frame > .mintLength - 1 Then Return False
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            Dim idx As Integer
    '            While idx <= Tracks.Length - 1
    '                Index = 0
    '                While Index <= .mintTrackCount - 1
    '                    If .TrackNames(Index) = Tracks(idx) Then
    '                        .Tracks(Index, Frame) = Values(idx)
    '                        Count += 1
    '                        Exit While
    '                    End If

    '                    Index += 1
    '                End While
    '                If Count = Tracks.Length Then Return True
    '                idx += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackX As Integer, ByVal TrackY As Integer, ByRef ValueX As Single, ByRef ValueY As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If TrackX < 0 Then Return False
    '            If TrackX > .mintTrackCount - 1 Then Return False
    '            If TrackY < 0 Then Return False
    '            If TrackY > .mintTrackCount - 1 Then Return False
    '            ValueX = .Tracks(TrackX, .mintCurrentFrame)
    '            ValueY = .Tracks(TrackY, .mintCurrentFrame)
    '        End With
    '        Return True
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackX As String, ByVal TrackY As String, ByRef ValueX As Single, ByRef ValueY As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = TrackX Then
    '                    ValueX = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If
    '                If .TrackNames(Index) = TrackY Then
    '                    ValueY = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If


    '                If Count = 2 Then Return True
    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackX As Integer, ByVal TrackY As Integer, ByVal TrackZ As Integer, ByRef ValueX As Single, ByRef ValueY As Single, ByRef ValueZ As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If TrackX < 0 Then Return False
    '            If TrackX > .mintTrackCount - 1 Then Return False
    '            If TrackY < 0 Then Return False
    '            If TrackY > .mintTrackCount - 1 Then Return False
    '            If TrackZ < 0 Then Return False
    '            If TrackZ > .mintTrackCount - 1 Then Return False
    '            ValueX = .Tracks(TrackX, .mintCurrentFrame)
    '            ValueY = .Tracks(TrackY, .mintCurrentFrame)
    '            ValueZ = .Tracks(TrackZ, .mintCurrentFrame)
    '        End With
    '        Return True
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackX As String, ByVal TrackY As String, ByVal TrackZ As String, ByRef ValueX As Single, ByRef ValueY As Single, ByRef ValueZ As Single) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = TrackX Then
    '                    ValueX = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If
    '                If .TrackNames(Index) = TrackY Then
    '                    ValueY = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If
    '                If .TrackNames(Index) = TrackZ Then
    '                    ValueZ = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If

    '                If Count = 3 Then Return True
    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackX As Integer, ByVal TrackY As Integer, ByVal TrackZ As Integer, ByRef Value As Vector3) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If TrackX < 0 Then Return False
    '            If TrackX > .mintTrackCount - 1 Then Return False
    '            If TrackY < 0 Then Return False
    '            If TrackY > .mintTrackCount - 1 Then Return False
    '            If TrackZ < 0 Then Return False
    '            If TrackZ > .mintTrackCount - 1 Then Return False
    '            Value.X = .Tracks(TrackX, .mintCurrentFrame)
    '            Value.Y = .Tracks(TrackY, .mintCurrentFrame)
    '            Value.Z = .Tracks(TrackZ, .mintCurrentFrame)
    '        End With
    '        Return True
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackX As String, ByVal TrackY As String, ByVal TrackZ As String, ByRef Value As Vector3) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = TrackX Then
    '                    Value.X = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If
    '                If .TrackNames(Index) = TrackY Then
    '                    Value.Y = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If
    '                If .TrackNames(Index) = TrackZ Then
    '                    Value.Z = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If

    '                If Count = 3 Then Return True
    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackLeft As Integer, ByVal TrackTop As Integer, ByVal TrackWidth As Integer, ByVal TrackHeight As Integer, ByRef Value As RectangleF) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            If TrackLeft < 0 Then Return False
    '            If TrackLeft > .mintTrackCount - 1 Then Return False
    '            If TrackTop < 0 Then Return False
    '            If TrackTop > .mintTrackCount - 1 Then Return False
    '            If TrackWidth < 0 Then Return False
    '            If TrackWidth > .mintTrackCount - 1 Then Return False
    '            Value.X = .Tracks(TrackLeft, .mintCurrentFrame)
    '            Value.Y = .Tracks(TrackTop, .mintCurrentFrame)
    '            Value.Width = .Tracks(TrackWidth, .mintCurrentFrame)
    '            Value.Height = .Tracks(TrackHeight, .mintCurrentFrame)
    '        End With
    '        Return True
    '    End Function

    '    Public Function GetTrackValues(ByVal Animation As String, ByVal TrackLeft As String, ByVal TrackTop As String, ByVal TrackWidth As String, ByVal TrackHeight As String, ByRef Value As RectangleF) As Boolean
    '        If Animation Is Nothing Then Return False
    '        If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '        With DirectCast(mobjAnimations(Animation), Animation)
    '            Dim Index As Integer = 0
    '            Dim Count As Integer = 0
    '            While Index <= .mintTrackCount - 1
    '                If .TrackNames(Index) = TrackLeft Then
    '                    Value.X = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                    Index += 1
    '                End If
    '                If .TrackNames(Index) = TrackTop Then
    '                    Value.Y = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                    Index += 1
    '                End If
    '                If .TrackNames(Index) = TrackWidth Then
    '                    Value.Width = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                    Index += 1
    '                End If
    '                If .TrackNames(Index) = TrackHeight Then
    '                    Value.Height = .Tracks(Index, .mintCurrentFrame)
    '                    Count += 1
    '                End If

    '                If Count = 4 Then Return True

    '                Index += 1
    '            End While
    '        End With

    '        Return False
    '    End Function
    '#End Region

    'Friend Function UpdateTrack(ByVal Animation As String, ByVal Track As String, ByVal CurrentTime As Long, ByRef Value As Single) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    Dim Ani As Animation
    '    Ani = DirectCast(mobjAnimations(Animation), Animation)
    '    Dim Trk As AnimationTrack
    '    Trk = DirectCast(Ani.Tracks(Track), AnimationTrack)

    '    If CurrentTime > Ani.StartTime + T.GetNextKey.Time Then T.CurrentKeyIndex += 1

    '    If T.CurrentKeyIndex > T.Track.Count - 1 Then
    '        If T.PlayType = DX9Tools.PlayStyle.Once Then
    '            T.CurrentKeyIndex = T.Track.Count - 1
    '            Return 0
    '        Else
    '            T.CurrentKeyIndex = 0
    '            T.BaseTime = CurrentTime
    '            CurrentTime = CurrentTime - T.GetLastKey.Time ' T.Track(T.Track.Count - 1).Time
    '        End If
    '    End If

    '    ' calc ammount of transition
    '    Dim S As Double

    '    S = (CurrentTime - (T.BaseTime + T.GetCurrentKey.Time)) / (T.GetNextKey.Time - T.GetCurrentKey.Time)
    '    If S.IsNaN(S) Then S = 0
    '    If S < 0 Then S = 0
    '    If S > 1 Then S = 1

    '    Return CSng(S)
    'End Function

    'Public Shared Sub UpdateTrack(ByVal T As DX9Tools.Animation.TrackReference, ByVal CurrentTime As Long, ByRef Value As Single)
    '    If T.Track Is Nothing Then
    '        Value = Nothing
    '        Exit Sub
    '    End If
    '    If T.Track.Count = 0 Then
    '        Value = Nothing
    '        Exit Sub
    '    End If
    '    If T.Track.Count = 1 Then
    '        GetKeyValue(T.GetCurrentKey, Value)
    '        Exit Sub
    '    End If
    '    If T.PlayType = DX9Tools.PlayStyle.Once Then
    '        If T.CurrentKeyIndex = T.Track.Count - 1 Then
    '            GetKeyValue(T.GetLastKey, Value)
    '            Exit Sub
    '        End If
    '    End If

    '    Dim S As Single
    '    S = UpdateTrack(T, CurrentTime)

    '    ' finnaly return vector
    '    Dim V1, V2 As Single
    '    GetKeyValue(T.GetCurrentKey, V1)
    '    GetKeyValue(T.GetNextKey, V2)
    '    Value = V1 + (S * (V2 - V1))
    'End Sub

    'Public Function UpdateAnimation(ByVal Animation As String, ByVal CurrentTime As Long) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    Dim Ani As Animation
    '    Ani = DirectCast(mobjAnimations(Animation), Animation)

    '    Dim MaxTrackLength As Integer

    '    With Ani.Tracks.GetEnumerator()
    '        While .MoveNext
    '            With DirectCast(.Value, AnimationTrack)
    '                If MaxTrackLength < .Keys.Count Then MaxTrackLength = .Keys.Count

    '                If .Enabled And .Keys.Count <> 0 And .CurrenKey <> -1 Then

    '                End If
    '            End With
    '        End While
    '    End With

    '    Return True
    'End Function

    'Public Function UpdateAnimation(ByVal CurrentTime As Long) As Boolean
    '    If mobjAnimations.Count = 0 Then Return False

    '    With mobjAnimations.GetEnumerator
    '        While .MoveNext
    '            UpdateAnimation(CStr(.Key), CurrentTime)
    '        End While
    '    End With

    '    Return True
    'End Function

    '------------------------------------------------------------------------
    '========================== Animation methods ===========================
    '------------------------------------------------------------------------

    'Public Function ResetAnimation(ByVal Animation As String) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    Dim Ani As Animation
    '    Ani = DirectCast(mobjAnimations(Animation), Animation)
    '    If Ani.mintTrackCount = 0 Then Return False
    '    If Ani.mintLength = 0 Then Return False

    '    Ani.mintCurrentFrame = 0

    '    Return True
    'End Function

    Public Function GetNumberOfAnimations() As Integer
        Return mobjAnimations.Count
    End Function

    Public Function GetNumberOfTracks(ByVal Animation As String, ByRef Value As Integer) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        Value = DirectCast(mobjAnimations(Animation), Animation).mobjTracks.Count
        Return True
    End Function

    'Public Function UpdateAnimation(ByVal Animation As String, ByVal CurrentTime As Long, ByVal Frequency As Long) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    DirectCast(mobjAnimations(Animation), Animation).Update(CurrentTime, Frequency)
    '    Return True
    'End Function

    'Public Function UpdateAllAnimations(ByVal CurrentTime As Long, ByVal Frequency As Long) As Boolean
    '    If mobjAnimations.Count = 0 Then Return False

    '    With mobjAnimations.GetEnumerator
    '        While .MoveNext
    '            DirectCast(.Value, Animation).Update(CurrentTime, Frequency)
    '        End While
    '    End With

    '    Return True
    'End Function

    'Public Function SetNumberOfTracks(ByVal Animation As String, ByVal Value As Integer) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    DirectCast(mobjAnimations(Animation), Animation).TrackCount = Value
    '    Return True
    'End Function

    'Public Function GetAnimationLength(ByVal Animation As String, ByRef Value As Integer) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    Value = DirectCast(mobjAnimations(Animation), Animation).mintLength
    '    Return True
    'End Function

    'Public Function SetAnimationLength(ByVal Animation As String, ByVal Value As Integer) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    DirectCast(mobjAnimations(Animation), Animation).Length = Value
    '    Return True
    'End Function

    Public Sub RemoveAllAnimations()
        With mobjAnimations.GetEnumerator
            While .MoveNext
                With DirectCast(.Value, Animation)
                    .mobjTracks.Clear()
                    .mobjTracks = Nothing
                End With
            End While
        End With

        mobjAnimations.Clear()
    End Sub

    Public Function RemoveAllTracks(ByVal Animation As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            .mobjTracks.Clear()
        End With
        Return True
    End Function

    Public Function RemoveAnimation(ByVal Animation As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        'With DirectCast(mobjAnimations(Animation), Animation)
        '    Erase .Tracks
        '    Erase .TrackNames
        '    Erase .TrackEnabled
        'End With
        mobjAnimations.Remove(Animation)
        Return True
    End Function

    Public Function AddAnimation(ByVal Name As String) As Boolean
        If Name Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Name) Then Return False
        mobjAnimations.Add(Name, New Animation())
        Return True
    End Function

    'Public Function AddAnimation(ByVal Name As String, ByVal Animation As Animation) As Boolean
    '    If Name Is Nothing Then Return False
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Name) Then Return False
    '    mobjAnimations.Add(Name, Animation)
    '    Return True
    'End Function

    'Public Function GetAnimation(ByVal Name As String, ByRef Value As Animation) As Boolean
    '    If Name Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Name) = False Then Return False
    '    Value = DirectCast(mobjAnimations(Name), Animation)
    '    Return True
    'End Function

    Public Function AddTrack(ByVal Animation As String, ByVal Name As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Name) Then Return False
            .mobjTracks.Add(Name, New Track())
        End With
        Return True
    End Function

    Public Function AddTrack(ByVal Animation As String, ByVal Names() As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        Dim Tmp As String
        With DirectCast(mobjAnimations(Animation), Animation)
            'check to make sure all names being added have not already been added
            For Each Tmp In Names
                If .mobjTracks.ContainsKey(Tmp) Then
                    SpecifyError("DXTools.Animate.AddTrack", "Track with name '" & Tmp & "' already exists!")
                    Return False
                End If
            Next

            For Each Tmp In Names
                .mobjTracks.Add(Tmp, New Track())
            Next
        End With
        Return True
    End Function

    Public Function RemoveTrack(ByVal Animation As String, ByVal Track As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            .mobjTracks.Remove(Track)
        End With
        Return True
    End Function

    Public Function EnableAnimation(ByVal Name As String, ByVal Enabled As Boolean) As Boolean
        If Name Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Name) = False Then Return False
        DirectCast(mobjAnimations(Name), Animation).Enabled = Enabled
        Return True
    End Function

    Public Function IsAnimationEnabled(ByVal Name As String, ByRef Enabled As Boolean) As Boolean
        If Name Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Name) = False Then Return False
        Enabled = DirectCast(mobjAnimations(Name), Animation).Enabled
        Return True
    End Function

    'Public Function GetTrackIndex(ByVal Animation As String, ByVal Track As String, ByRef Value As Integer) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    With DirectCast(mobjAnimations(Animation), Animation)
    '        If .mobjTracks.ContainsKey(Track) = False Then Return False
    '        If .mobjTracks(Track) = Track Then
    '            Value = Index
    '            Return True
    '        End If

    '        Index += 1
    '        End While
    '    End With

    '    Return False
    'End Function

    Public Function TrackExists(ByVal Animation As String, ByVal Track As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            Return .mobjTracks.ContainsKey(Track)
        End With
        Return False
    End Function

    Public Function TrackExists(ByVal Animation As String, ByVal Tracks() As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            Dim Tmp As String
            For Each Tmp In Tracks
                If .mobjTracks.ContainsKey(Tmp) = False Then Return False
            Next
        End With
        Return True
    End Function

    Public Function AnimationExists(ByVal Animation As String) As Boolean
        Return mobjAnimations.ContainsKey(Animation)
    End Function

    Public Function AnimationExists(ByVal Animations() As String) As Boolean
        Dim Tmp As String
        For Each Tmp In Animations
            If mobjAnimations.ContainsKey(Tmp) = False Then Return False
        Next
        Return True
    End Function

    'Public Function SetTrackName(ByVal Animation As String, ByVal Track As Integer, ByVal Name As String) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    With DirectCast(mobjAnimations(Animation), Animation)
    '        If Track < 0 Then Return False
    '        If Track > .Count - 1 Then Return False
    '        .Item(Track).Name = Name
    '    End With
    '    Return True
    'End Function

    Public Function ChangeAnimationName(ByVal Animation As String, ByVal Name As String) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        If mobjAnimations.ContainsKey(Name) Then Return False
        Dim Item As Object
        Item = mobjAnimations(Animation)
        mobjAnimations.Remove(Animation)
        mobjAnimations.Add(Name, Item)
        Return True
    End Function

    Public Function ChangeTrackName(ByVal Animation As String, ByVal Track As String, ByVal Name As String) As Boolean

        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            If .mobjTracks.ContainsKey(Name) Then Return False ' already contains a key with that name
            Dim Item As Object
            Item = .mobjTracks(Track)
            .mobjTracks.Remove(Track)
            .mobjTracks.Add(Name, Item)
        End With

        Return False
    End Function

    Public Function IsTrackEnabled(ByVal Animation As String, ByVal Track As String, ByRef Value As Boolean) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Value = DirectCast(.mobjTracks(Track), Track).mblnEnabled
        End With
        Return True
    End Function

    'Public Function IsTrackEnabled(ByVal Animation As String, ByVal Track As String, ByRef Value As Boolean) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    With DirectCast(mobjAnimations(Animation), Animation)
    '        Dim Index As Integer = 0
    '        While Index <= .Count - 1
    '            If .Item(Index).Name = Track Then
    '                Value = .Item(Index).mblnEnabled
    '                Return True
    '            End If

    '            Index += 1
    '        End While
    '    End With

    '    Return False
    'End Function

    Public Function EnableTrack(ByVal Animation As String, ByVal Track As String, ByVal Value As Boolean) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            DirectCast(.mobjTracks(Track), Track).mblnEnabled = Value
        End With
        Return True
    End Function
End Module
