'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================
Imports Microsoft.DirectX

''' <summary>
''' The BaseExample object provides a base set of functionality common to all of the example code.
''' </summary>
Public MustInherit Class BaseExample
    Protected Friend mobjForm As Form
 
    Protected Friend Overridable Function LoadResource(ByVal ResourceName As String, _
    Optional ByVal PrePend As String = "DX9Tools_Tester.") As IO.MemoryStream
        Dim ResourceStream As IO.Stream
        Dim Asm As Reflection.Assembly
        For Each Asm In AppDomain.CurrentDomain.GetAssemblies
            ResourceStream = Asm.GetManifestResourceStream(PrePend & ResourceName)
            If ResourceStream Is Nothing = False Then Exit For
        Next
        If ResourceStream Is Nothing Then Return Nothing

        Dim byts(CInt(ResourceStream.Length - 1)) As Byte
        Dim Len As Integer = ResourceStream.Read(byts, 0, CInt(ResourceStream.Length))

        Dim MemStream As New IO.MemoryStream(byts, 0, Len)
        Return MemStream
    End Function

    Protected Friend Overridable Function LoadResourceImage(ByVal ResourceImageName As String, Optional ByVal PrePend As String = "DX9Tools_Tester.") As Direct3D.Texture
        Dim Mem As IO.MemoryStream
        Mem = LoadResource(ResourceImageName, PrePend)
        If Mem Is Nothing Then Return Nothing

        ' attempt to load/create image we saved to memory stream
        Dim Tex As Direct3D.Texture
        Tex = Direct3D.TextureLoader.FromStream(GetD3DDevice, Mem, 0, 0, 0, 0, Direct3D.Format.Unknown, Direct3D.Pool.Managed, Direct3D.Filter.Linear, Direct3D.Filter.Linear, 0)

        ' done with varibles
        Mem.Close()
        Mem = Nothing

        ' return reference to texture
        Return Tex
    End Function

    Protected Friend Overridable Function LoadResourceImage(ByVal ResourceImageName As String, ByVal ColorKey As Color, Optional ByVal PrePend As String = "DX9Tools_Tester.") As Direct3D.Texture
        Dim Mem As IO.MemoryStream
        Mem = LoadResource(ResourceImageName, PrePend)
        If Mem Is Nothing Then Return Nothing

        ' attempt to load/create image we saved to memory stream
        Dim Tex As Direct3D.Texture
        Tex = Direct3D.TextureLoader.FromStream(GetD3DDevice, Mem, 0, 0, 0, 0, _
                                         Direct3D.Format.Unknown, Direct3D.Pool.Managed, _
                                         Direct3D.Filter.Linear, Direct3D.Filter.Linear, _
                                         ColorKey.ToArgb)

        ' done with varibles
        Mem.Close()
        Mem = Nothing

        ' return reference to texture
        Return Tex
    End Function

    Protected Friend Overridable Sub DoCleanUp()
        ShutdownGraphics()
        RemoveAllStoredResources(True)
        If mobjForm Is Nothing = False Then
            mobjForm.Close()
            mobjForm.Dispose()
        End If
        mobjForm = Nothing
    End Sub

    Protected Overridable Sub DoInit(Optional ByVal Windowed As Boolean = True)
        mobjForm = New Form()
        mobjForm.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        mobjForm.ClientSize = New System.Drawing.Size(622, 466)
        mobjForm.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        mobjForm.MaximizeBox = False
        mobjForm.MinimizeBox = False
        mobjForm.StartPosition = FormStartPosition.CenterScreen
        mobjForm.Name = "Main"
        mobjForm.Text = "DX9Tools Example App"

        mobjForm.Show()
        mobjForm.Focus()
        InitGraphics(mobjForm, Windowed)
        With GetD3DDevice()
            .RenderState.AlphaBlendEnable = True
            .RenderState.SourceBlend = Direct3D.Blend.SourceAlpha
            .RenderState.DestinationBlend = Direct3D.Blend.InvSourceAlpha
        End With
    End Sub
End Class