'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================

Imports Microsoft.DirectX.DirectInput.CooperativeLevelFlags
Imports Microsoft.DirectX.Direct3D.Geometry

Public Class CameraRotate
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Private mobjMouse As DirectInput.Device

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        Dim Msg As String
        Dim Rotation As Vector3

        DoInit()


        Msg = "Left/Right mouse buttons rotate the camera" & vbCrLf
        Msg &= "W/S Move forward and backward" & vbCrLf
        Msg &= "A/D Strafe left and right" & vbCrLf
        Msg &= "Z/X Strafe up and down" & vbCrLf
        While mobjForm.Created

            BeginScene()

            ' render sky
            SetWorldMatrix(Matrix.Multiply(Matrix.Identity, Matrix.Translation(0, -500, 0)))
            DrawMesh("Sky")

            Dim M As Matrix
            M = Matrix.Multiply(Matrix.Identity, Matrix.RotationX(Math.PI / 2))
            M.Multiply(Matrix.Translation(0, -25, 0))
            SetWorldMatrix(M)
            DrawVertexBuffer("Plane", "Dirt")



            ' mobjSky.Render(mobjGraphics.Device, mobjTextures)

            ' render ground
            ' RenderGeometry(mobjGraphics.Device, Verts, mobjTextures)

            ' Msg &= "Values from the cameras GetRotation method" & vbCrLf
            ' Msg &= mobjCameras(0).GetRotation.ToString

            Dim MS As DirectInput.MouseState
            MS = mobjMouse.CurrentMouseState
            If MS.X <> 0 Then Rotation.X += MS.X
            If MS.Y <> 0 Then Rotation.Y += MS.Y
            ' limit up/down rotation to 89 degrees
            If Rotation.Y < -89 Then Rotation.Y = -89
            If Rotation.Y > 89 Then Rotation.Y = 89
            If MS.GetMouseButtons(0) <> 0 And (MS.X <> 0 Or MS.Y <> 0) Then
                RotateCamera(DegreeToRadian(Rotation.X), DegreeToRadian(Rotation.Y), 0)

            ElseIf mobjMouse.CurrentMouseState.GetMouseButtons(1) <> 0 Then

            End If

            DrawText(Msg, 0, 0) 'mobjForm.ClientRectangle,  Left Or Top, Color.Yellow)
            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        'mobjFont.Dispose()
        'mobjFont = Nothing
        'Verts = Nothing
        'mobjTextures.Dispose()
        'mobjTextures = Nothing
        'mobjCameras.Dispose()
        'mobjCameras = Nothing
        'mobjDXE.Mouse.DoneMouse()
        'mobjDXE.Dispose()
        'mobjDXE = Nothing

        mobjMouse.Dispose()
        mobjMouse = Nothing
        ' RemoveHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        mobjForm.Text = "Camera Rotate Example"
        'AddHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

        mobjMouse = New DirectInput.Device(DirectInput.SystemGuid.Mouse)
        mobjMouse.SetCooperativeLevel(mobjForm, NonExclusive Or Background) ' Exclusive Or Foreground)
        mobjMouse.Acquire()
        'mobjTextures = New DX9Tools.Collections.TextureCollection()
        'mobjTextures.DisposeOnClear = True
        'mobjTextures.Add(LoadResourceImage(Me.GetType.Namespace & ".Dirt.png"))

        AddTexture("Dirt", LoadResourceImage("Dirt.png"))
        'AddTexture("NegativeX", LoadResourceImage(GetImageResourceName(DirectX.Direct3D.CubeMapFace.NegativeX)))
        'AddTexture("NegativeY", LoadResourceImage(GetImageResourceName(DirectX.Direct3D.CubeMapFace.NegativeY)))
        'AddTexture("NegativeZ", LoadResourceImage(GetImageResourceName(DirectX.Direct3D.CubeMapFace.NegativeZ)))
        'AddTexture("PositiveX", LoadResourceImage(GetImageResourceName(DirectX.Direct3D.CubeMapFace.PositiveX)))
        'AddTexture("PositiveY", LoadResourceImage(GetImageResourceName(DirectX.Direct3D.CubeMapFace.PositiveY)))
        'AddTexture("PositiveZ", LoadResourceImage(GetImageResourceName(DirectX.Direct3D.CubeMapFace.PositiveZ)))

        'mobjCameras = New DX9Tools.Collections.CameraCollection()
        'mobjCameras.Add(New DX9Tools.Camera(mobjGraphics))
        AddCamera("Cam1", 0, 0, -25, 0, 0, -24, 0, 1, 0, Math.PI / 2, 0, 10000, True)
        'With mobjCameras(0)
        '    .ViewWorldLock = False ' setting it to true would set the world transform rather than view transform
        '    .SetPosition(0, 10, 0)
        '    .SetLookAt(0, 10, 1)
        '    .FarPlane = 10000
        'End With

        ' create font
        'mobjFont = New Direct3D.Font(mobjGraphics.Device, New Font(mobjForm.Font.FontFamily, 16, FontStyle.Bold, GraphicsUnit.Pixel))

        ' no lighting
        'mobjGraphics.Device.RenderState.Lighting = False

        SetCullMode(DirectX.Direct3D.Cull.None)
        ' mobjSky = New SkyBox(10000)
        
        'Dim vFmt As Direct3D.VertexFormats = Direct3D.CustomVertex.PositionTextured.Format
        'AddHandler GetEvents.LoadMesh, AddressOf LoadMeshHandler
        'LoadMesh("Sky", LoadResource("SkyBox.X"), vFmt, DirectX.Direct3D.MeshFlags.Managed)
        'RemoveHandler GetEvents.LoadMesh, AddressOf LoadMeshHandler

        Dim Mesh As New Mesh()
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("SkyBox.X"), Direct3D.MeshFlags.Managed, GetD3DDevice)
        Mesh.Materials.Add("White")
        Mesh.Textures.Add("Back")
        AddMesh("Sky", Mesh)

        AddMaterial("White", Color.White, Color.White, True)

        AddTexture("Back", LoadResourceImage("Bluespotlite.png"))

        ' mobjDXE = New DX9Tools.DXEliminator.DXE()
        ' mobjDXE.Mouse.InitMouse()
        ' mobjDXE.Mouse.AquireMouse()

        ' setup geometry
        SetupGeo()
    End Sub

    'Private Sub LoadMeshHandler(ByVal MeshName As String, ByVal TextureFilename As String, ByRef Texture As Direct3D.Texture, ByRef TextureName As String)
    '    Dim TexPath As String = IO.Path.GetFileName(TextureFilename)
    '    If AddTexture(TexPath, LoadResourceImage(TexPath)) = False Then
    '        ' error
    '    Else
    '        GetTexture(TexPath, Texture)
    '        TextureName = TexPath
    '    End If
    'End Sub

    'Private Function GetImageResourceName(ByVal Index As Direct3D.CubeMapFace) As String
    '    Return GetImageResourceName(Index)
    'End Function

    'Private Function GetImageResourceName(ByVal Index As Integer) As String
    '    Select Case Index
    '        Case Direct3D.CubeMapFace.PositiveZ
    '            Return "skybox_front.png"

    '        Case Direct3D.CubeMapFace.PositiveX
    '            Return "skybox_right.png"

    '        Case Direct3D.CubeMapFace.NegativeZ
    '            Return "skybox_back.png"

    '        Case Direct3D.CubeMapFace.NegativeX
    '            Return "skybox_left.png"

    '        Case Direct3D.CubeMapFace.PositiveY
    '            Return "skybox_top.png"

    '        Case Direct3D.CubeMapFace.NegativeY
    '            Return "skybox_bottom.png"
    '    End Select
    'End Function

    Private Sub SetupGeo()
        Dim Tex(), V() As Vector3
        Dim idx As Integer

        'create ground
        V = CreatePlane(New Rectangle(-500, -500, 1000, 1000), 1, 1)
        'create uv cords for ground
        Tex = CreatePlane(New Rectangle(0, 0, 10, 10), 1, 1)
        ' rotate ground 90 along x axis

        'V = DX9Tools.GeoHelpers.VectorSwap(V, DX9Tools.Orientation.ZY)

        ' populate mesh data
        Dim Verts() As Direct3D.CustomVertex.PositionTextured
        ReDim Verts(V.Length - 1)
        For idx = 0 To V.Length - 1
            Verts(idx) = New Direct3D.CustomVertex.PositionTextured(V(idx), Tex(idx).X, Tex(idx).Y)
        Next

        Dim VB As New VertexBuffer()
        ' this does not seem to work for some reason ...
        'VB.Buffer = New Direct3D.VertexBuffer(GetD3DDevice , Verts.Length * Verts(0).StrideSize, 0, Verts(0).Format, DirectX.Direct3D.Pool.Managed)
        ' ... but this line of code does??? 
        VB.Buffer = New Direct3D.VertexBuffer(Verts(0).GetType, Verts.Length, GetD3DDevice, 0, Verts(0).Format, DirectX.Direct3D.Pool.Managed)
        VB.Buffer.SetData(Verts, 0, Direct3D.LockFlags.None)
        VB.PrimitiveCount = GetPrimitiveCount(Direct3D.PrimitiveType.TriangleList, Verts.Length)
        VB.PrimitiveType = Direct3D.PrimitiveType.TriangleList
        AddVertexBuffer("Plane", VB)

        '' setup skybox
        'For idx = 0 To 5
        '    Dim Ret As Integer
        '    Dim Blend As DX9Tools.IndexedTextureBlendingItem

        '    Ret = mobjTextures.Add(LoadResourceImage(GetImageResourceName(idx)))
        '    Blend = New DX9Tools.IndexedTextureBlendingItem(mobjGraphics.Device.TextureState(0), Ret)
        '    mobjSky.Vertexes(idx).Blending = Blend
        '    mobjSky.TextureIndex(idx) = Ret
        'Next
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        'Dim Cam As DX9Tools.Camera = mobjCameras(0)

        Select Case e.KeyCode
            Case Keys.Escape
                mobjForm.Close()

            Case Keys.W
                'GoForward(4)
                MoveCameraForward(8)
                'Dim Pos, Tar As Vector3
                'GetCameraPosition(Pos.X, Pos.Y, Pos.Z)
                'GetCameraLookAt(Tar.X, Tar.Y, Tar.Z)
                'Dim Rot As Single
                'Rot = GetRotationInRadians(Pos.X, Pos.Z, Tar.X, Tar.Z)

                'Displacement(Pos.X, Pos.Z, 1, Rot, Pos.X, Pos.Z)
                'SetCameraLookAt(Pos.X, Pos.Y, Pos.Z)



            Case Keys.S
                'GoBackward(4)
                MoveCameraBackward(8)
               
            Case Keys.A
                ' Cam.HStrafe(4)
                PanCameraHorizontally(8)

            Case Keys.D
                ' Cam.HStrafe(-4)
                PanCameraHorizontally(-8)

            Case Keys.Z
                ' Cam.VStrafe(4)
                PanCameraVertically(4)

            Case Keys.X
                'Cam.VStrafe(-4)
                PanCameraVertically(-4)
        End Select
    End Sub

    '' distance parameter is not yet implemented
    'Private Sub GoBackward(ByVal Distance As Single)
    '    Dim Cam As DX9Tools.Camera = mobjCameras(0)
    '    Dim V As Vector3
    '    V = Vector3.Subtract(Cam.Position, Cam.LookAt)
    '    Cam.Position = Vector3.Add(Cam.Position, V)
    '    Cam.LookAt = Vector3.Add(Cam.LookAt, V)
    'End Sub

    '' distance parameter is not yet implemented
    'Private Sub GoForward(ByVal Distance As Single)
    '    Dim Cam As DX9Tools.Camera = mobjCameras(0)
    '    Dim V As Vector3
    '    V = Vector3.Subtract(Cam.Position, Cam.LookAt)
    '    Cam.Position = Vector3.Subtract(Cam.Position, V)
    '    Cam.LookAt = Vector3.Subtract(Cam.LookAt, V)
    'End Sub

    'Private Sub Form_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
    '    Static Rotation As Vector3

    '    Select Case e.Button
    '        Case MouseButtons.Left
    '            mobjDXE.Mouse.GetMouseState()
    '            Dim Pos As Vector3
    '            Pos = mobjDXE.Mouse.GetMousePosition

    '            Rotation.X += Pos.X
    '            Rotation.Y += Pos.Y
    '            ' limit up/down rotation to 89 degrees
    '            If Rotation.Y < -89 Then Rotation.Y = -89
    '            If Rotation.Y > 89 Then Rotation.Y = 89

    '            ' tell camera to rotate
    '            mobjCameras(0).Rotate(DegreeToRadian(Rotation.X), DegreeToRadian(Rotation.Y), DegreeToRadian(Rotation.Z), 4.0F)

    '        Case MouseButtons.Right
    '            Rotation.Z = DegreeToRadian(e.X)
    '            mobjCameras(0).Rotate(Rotation.X, Rotation.Y, Rotation.Z, 4.0F)
    '    End Select
    'End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Mostly complete but still a work in progress... Checkout the skybox!"
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "CameraRotate.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Camera Rotate"
    End Function
End Class