'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================

Public Class D3DFullscreen
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample


    Public Sub Run() Implements DXTTesterExt.IExample.Run

        DoInit()

        While mobjForm.Created
            If GraphicsDeviceIsLost() Then Exit While
            BeginScene()

            DrawText("Click or press any key to exit...", 50, 50)

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        '   MyBase.DoInit(False)

        mobjForm = New Form()
        With mobjForm
            .AutoScaleBaseSize = New System.Drawing.Size(5, 13)
            .ClientSize = New System.Drawing.Size(622, 466)
            .FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
            .MaximizeBox = False
            .MinimizeBox = False
            .StartPosition = FormStartPosition.CenterScreen
            .Name = "Main"
            .Text = "DX9Tools Example App"

            .Show()
            .Focus()

            .Text = "D3D Fullscreen Example"
            .FormBorderStyle = FormBorderStyle.None
            .Location = New Point()
            .Size = New Size(640, 480)

        End With

        ' check if display modes ara availible
        Dim Fmt As Direct3D.Format
        If ModeAvailible(0, 640, 480, Direct3D.Format.X8R8G8B8) Then
            Fmt = Direct3D.Format.X8R8G8B8 ' found availible 32bit mode
        ElseIf ModeAvailible(0, 640, 480, Direct3D.Format.A8R8G8B8) Then
            Fmt = Direct3D.Format.A8B8G8R8 ' found availible 32bit mode
        ElseIf ModeAvailible(0, 640, 480, Direct3D.Format.R8G8B8) Then
            Fmt = Direct3D.Format.R8G8B8  ' found availible 16bit mode
        Else
            MsgBox("Error: A 640x480 diaplay format does not appear to be availible.")
            MyBase.DoCleanUp()
            Exit Sub
        End If

        InitGraphics(mobjForm, False, 640, 480, Fmt)
        With GetD3DDevice()
            .RenderState.AlphaBlendEnable = True
            .RenderState.SourceBlend = Direct3D.Blend.SourceAlpha
            .RenderState.DestinationBlend = Direct3D.Blend.InvSourceAlpha
            .Viewport = CreateViewport(0, 0, mobjForm.ClientSize.Width, mobjForm.ClientSize.Height, .Viewport.MinZ, .Viewport.MaxZ)
        End With

        SetCurrentViewport(DEFAULTVIEWPORT)
        SetViewportBackgroundColor(CURRENTVIEWPORT, Color.DarkGray)

        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates a basic D3D fullscreen app."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "D3DFullScreen.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "D3D Fullscreen"
    End Function
End Class