'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: December 23, 2004
'=============================================

Public Class Effect
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Private FX As Direct3D.Effect

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        DoInit()

        Dim rot As Single
        Dim LastTime As Long
        Dim Dev As Direct3D.Device = GetD3DDevice()
        Dim Aspect As Single = CSng(mobjForm.ClientSize.Width / mobjForm.ClientSize.Height)
        Dim projMatrix As Matrix = Matrix.PerspectiveFovLH(Math.PI / 4, Aspect, 1.0F, 10000.0F)
        Dim viewMatrix As Matrix = Matrix.LookAtLH(New Vector3(0, 500, -500.0F), New Vector3(0, 500, 0), New Vector3(0, 1, 0))
        While mobjForm.Created
            BeginScene()


            ' rotate every 10 milli secs
            If Now.Ticks > LastTime + TimeSpan.FromMilliseconds(10).Ticks Then
                rot += 0.01F
                LastTime = Now.Ticks
            End If

            Dim worldMatrix As Matrix = Matrix.Identity
            worldMatrix.Multiply(Matrix.RotationYawPitchRoll(rot, CSng(Math.Sin(rot)) / 2, 0))
            worldMatrix.Multiply(Matrix.Translation(0, 0, 0))


            Dim worldViewProj As Matrix = Matrix.Identity
            worldViewProj.Multiply(worldMatrix)
            worldViewProj.Multiply(viewMatrix)
            worldViewProj.Multiply(projMatrix)
            FX.SetValue(Direct3D.EffectHandle.FromString("WorldViewProj"), worldViewProj)


            'Render out skybox using the effect
            Dim Passes As Integer = FX.Begin(0)
            Dim idx As Integer
            For idx = 0 To Passes - 1
                FX.Pass(idx)

                DrawMesh("Sky")

            Next
            FX.End()

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        If FX Is Nothing = False Then FX.Dispose()
        FX = Nothing
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit()

        ' load sky sphere
        Dim Dev As Direct3D.Device = GetD3DDevice()

        Dim Mesh As New Mesh()
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("SkyBox.X"), Direct3D.MeshFlags.Managed, Dev)
        Mesh.Materials.Add("White")
        Mesh.Textures.Add("Back")
        AddMesh("Sky", Mesh)

        AddMaterial("White", Color.White, Color.White, True)

        AddTexture("Back", LoadResourceImage("Back.png"))

        Dim ErrMsg As String
        Try
            FX = Direct3D.Effect.FromStream(Dev, LoadResource("Simple.fx"), Nothing, Direct3D.ShaderFlags.None, Nothing, ErrMsg)
            FX.Technique = FX.GetTechnique("TransformTexture")

        Catch ex As Exception
            Throw New DirectXException(ErrMsg, ex)
        End Try

        mobjForm.Text = "D3D Effect Example"
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates loading and using *.FX effect files."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "Effect.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "D3D Effect Files"
    End Function
End Class