'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: November 27, 2003
'=============================================
Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX

Public Class ModeDetect
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Private Message As String

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        DoInit()

        While mobjForm.Created
            BeginScene()

            SetDrawColor(Color.Yellow)
            DrawText(Message, 50, 50)

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit()
        mobjForm.Text = "Mode Detect Example"

        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

        Message = TestMode(640, 480, Direct3D.Format.X8R8G8B8) & vbCrLf
        Message &= TestMode(640, 480, Direct3D.Format.A8R8G8B8) & vbCrLf
        Message &= TestMode(640, 480, Direct3D.Format.R5G6B5) & vbCrLf
        Message &= TestMode(640, 480, Direct3D.Format.R8G8B8) & vbCrLf

        Message &= TestMode(800, 600, Direct3D.Format.X8R8G8B8) & vbCrLf
        Message &= TestMode(800, 600, Direct3D.Format.A8R8G8B8) & vbCrLf
        Message &= TestMode(800, 600, Direct3D.Format.R5G6B5) & vbCrLf
        Message &= TestMode(800, 600, Direct3D.Format.R8G8B8) & vbCrLf

        Message &= TestMode(1024, 768, Direct3D.Format.X8R8G8B8) & vbCrLf
        Message &= TestMode(1024, 768, Direct3D.Format.A8R8G8B8) & vbCrLf
        Message &= TestMode(1024, 768, Direct3D.Format.R5G6B5) & vbCrLf
        Message &= TestMode(1024, 768, Direct3D.Format.R8G8B8) & vbCrLf
    End Sub

    Private Function TestMode(ByVal W As Integer, ByVal H As Integer, ByVal Fmt As Direct3D.Format) As String
        Dim Msg As String

        Msg = W.ToString & ", " & H.ToString & ", " & Fmt.ToString
        If ModeAvailible(0, W, H, Fmt) Then
            Return Msg & " Is avalible."
        Else
            Return Msg & " Is not avalible."
        End If
    End Function

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates code that uses the ModeAvailible method to dertermin availible display modes."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "ModeDetect.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Mode Detect"
    End Function
End Class
