'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 17, 2004
'=============================================

' We import this name space so we can call MilliToTicks
Imports CBX.Libs.DX9Tools.GeneralHelpers

Public Class CreateIBSpeedTest
    Inherits BaseExample
    Implements IExample

    Private Const Iterations As Integer = 100000

    Protected Overrides Sub DoInit()
        MyBase.DoInit()
        With mobjForm
            .Text = "Create IndexBuffer Speed Test Example"
            .ControlBox = False
            .MinimizeBox = False
            .MaximizeBox = False

            Dim L As New Label()
            L.Name = "lblDesc"
            L.Text = "Please wait while test is running..."
            L.AutoSize = True
            .Controls.Add(L)
        End With

        Application.DoEvents()
    End Sub

    Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        Dim StartTime, EndTime, TotalTime As Long
        Dim idx As Integer
        Dim IB As Direct3D.IndexBuffer
        Dim Indexes(4999) As Integer

        DoInit()

RunTestAgain:
        StartTime = Now.Ticks
        For idx = 1 To Iterations
            IB = New Direct3D.IndexBuffer(mobjGraphics.Device, Indexes.Length * 4, 0, DirectX.Direct3D.Pool.Managed, True)
            IB.SetData(Indexes, 0, DirectX.Direct3D.LockFlags.None)
            IB.Dispose()
            IB = Nothing
        Next
        EndTime = Now.Ticks
        TotalTime = EndTime - StartTime

        Dim Msg As String
        Msg = "Start time: " & TicksToMilli(StartTime).ToString & " - " & StartTime.ToString & vbCrLf
        Msg &= "End time: " & TicksToMilli(EndTime).ToString & " - " & EndTime.ToString & vbCrLf
        Msg &= "Total time: " & TicksToMilli(TotalTime).ToString & " - " & TotalTime.ToString & vbCrLf
        Msg &= "Total Iterations: " & Iterations.ToString & vbCrLf
        Msg &= "--------------------------" & vbCrLf
        Msg &= "Your system is capable of creating and destroying " & Str(Iterations / TicksToMilli(TotalTime)) & " Index Buffers every 1 millisecond." & vbCrLf
        Msg &= "Would you like to run the test again?"
        If MsgBox(Msg, MsgBoxStyle.YesNo Or MsgBoxStyle.Information) = MsgBoxResult.Yes Then GoTo RunTestAgain

        DoCleanUp()
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Calculates how long it takes to create and destroy " & Iterations.ToString & " index buffers and populate them."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return New Bitmap(Me.GetType, "IBSpeedTest.png")
    End Function

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "Create Index Buffer Speed Test"
    End Function
End Class

