'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================

Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX.Direct3D.Geometry
Imports CBX.Libs.DX9Tools.GeneralHelpers
Imports CBX.Libs
Imports Microsoft.DirectX

Public Class CreateShape
    Inherits BaseExample
    Implements IExample

    Private Verts As DX9Tools.PCGeometry
    Private Rotation As Vector3
    Private mobjFont As Direct3D.Font
    Private mintShape As MeshShape = MeshShape.Box
    Private mobjCameras As DX9Tools.Collections.CameraCollection
    Private mintRows As Integer = 4
    Private mintColumns As Integer = 4
    Private mintStacks As Integer = 4

    Private Enum MeshShape
        Plane = 1
        Box = 2
        Donut = 3
    End Enum

    Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        Dim Msg As String

        Me.DoInit()

        While mobjForm.Created
            mobjGraphics.BeginScene()

            mobjCameras(0).UpdateVP()
            
            ' setup rotation matrix
            SetupRotation()

            ' render wireframe
            ' mobjGraphics.Device.RenderState.FillMode = DirectX.Direct3D.FillMode.WireFrame
            RenderGeometry(mobjGraphics.Device, Verts)


            Msg = "Left/Right/Middle mouse buttons rotate the shape" & vbCrLf
            If mintShape = MeshShape.Box Or mintShape = mintShape.Plane Then Msg &= "Q/W Set row count" & vbCrLf
            If mintShape = MeshShape.Box Or mintShape = mintShape.Plane Then Msg &= "A/S Set column count" & vbCrLf
            If mintShape = MeshShape.Box Then Msg &= "Z/X Set stack count" & vbCrLf
            If mintShape = MeshShape.Donut Then Msg &= "Q/W Sets start degree" & vbCrLf
            If mintShape = MeshShape.Donut Then Msg &= "A/S Sets end degree" & vbCrLf
            If mintShape = MeshShape.Donut Then Msg &= "Z/X Sets ring count" & vbCrLf
            Msg &= "F Toggles fill mode" & vbCrLf
            Msg &= "C Toggles culling" & vbCrLf
            Msg &= "Spacebar changes shape" & vbCrLf
            If mintShape = MeshShape.Donut Then
                Msg &= "StartDeg: " & mintRows.ToString & " DegPerRing: " & mintColumns.ToString & " RingCount: " & mintStacks.ToString & vbCrLf
            Else
                Msg &= "Rows: " & mintRows.ToString & " Columns: " & mintColumns.ToString & " Stacks: " & mintStacks.ToString & vbCrLf
            End If

            Msg &= "Shape: " & mintShape.ToString

            mobjFont.DrawText(Msg, mobjForm.ClientRectangle, Left Or Top, Color.Yellow)

            mobjGraphics.EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Private Sub SetupRotation()
        Dim M As Matrix = Matrix.Identity
        Dim HalfSize, Center As Vector3

        Center = New Vector3(mobjForm.ClientSize.Width \ 2, mobjForm.ClientSize.Height \ 2, 0)

        M.RotateYawPitchRoll(DegreeToRadian(Rotation.X), DegreeToRadian(Rotation.Y), DegreeToRadian(Rotation.Z))
        mobjGraphics.Device.SetTransform(DirectX.Direct3D.TransformType.World, M)
    End Sub

    Protected Overrides Sub DoCleanUp()
        mobjFont.Dispose()
        mobjFont = Nothing
        Verts = Nothing
        mobjCameras.Dispose()
        mobjCameras = Nothing
         RemoveHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
         MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit()
        MyBase.DoInit()

        mintRows = 4
        mintColumns = 4
         Rotation = New Vector3()
        mobjForm.Text = "Create Shape Example"
        AddHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
      
         ' create fonst
        mobjFont = New Direct3D.Font(mobjGraphics.Device, New Font(mobjForm.Font.FontFamily, 12, FontStyle.Bold, GraphicsUnit.Pixel))

        mobjGraphics.Device.RenderState.Lighting = False
        mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.None

        mobjCameras = New DX9Tools.Collections.CameraCollection()
        mobjCameras.Add(New DX9Tools.Camera(mobjGraphics))

        Verts = New DX9Tools.PCGeometry(DirectX.Direct3D.PrimitiveType.TriangleList)

        ' setup geometry
        SetupGeo()
    End Sub

    Private Sub SetupGeo()
        Dim V() As Vector3

        Select Case mintShape
            Case MeshShape.Donut
                V = DX9Tools.GeoHelpers.CreateDonut(New RectangleF(-50, -50, 100, 100), 25, 75, mintRows, mintColumns, mintStacks)
           
            Case MeshShape.Box
                V = DX9Tools.GeoHelpers.CreateBox(New Vector3(), New Vector3(50, 75, 25), mintRows, mintColumns, mintStacks)
           
            Case MeshShape.Plane
                V = DX9Tools.GeoHelpers.CreatePlane(New RectangleF(-50, -50, 100, 100), mintRows, mintColumns)
         End Select

        Dim idx As Integer
        Verts.VertexCount = V.Length
        For idx = 0 To V.Length - 1
            Verts.SetVertex(idx, V(idx), Color.White)
        Next
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Space
                If mintShape = MeshShape.Box Then
                    mintShape = MeshShape.Plane
                    mintRows = 4
                    mintColumns = 4
                    mintStacks = 4
                ElseIf mintShape = MeshShape.Plane Then
                    mintShape = MeshShape.Donut
                    mintRows = 0
                    mintColumns = 45
                    mintStacks = 4
                ElseIf mintShape = MeshShape.Donut Then
                    mintShape = MeshShape.Box
                    mintRows = 4
                    mintColumns = 4
                    mintStacks = 4
                End If
                SetupGeo()

            Case Keys.Q
                mintRows -= 1
                If mintRows < 1 Then mintRows = 1
                SetupGeo()

            Case Keys.W
                mintRows += 1
                If mintShape = MeshShape.Donut Then
                    If mintRows > 500 Then mintRows = 500
                Else
                    If mintRows > 20 Then mintRows = 20
                End If
                SetupGeo()

            Case Keys.A
                mintColumns -= 1
                If mintColumns < 1 Then mintColumns = 1
                SetupGeo()

            Case Keys.S
                mintColumns += 1
                If mintShape = MeshShape.Donut Then
                    If mintColumns > 500 Then mintColumns = 500
                Else
                    If mintColumns > 20 Then mintColumns = 20
                End If
                SetupGeo()

            Case Keys.Z
                mintStacks -= 1
                If mintShape = MeshShape.Donut Then
                    If mintStacks < 2 Then mintStacks = 2
                Else
                    If mintStacks < 1 Then mintStacks = 1
                End If
                SetupGeo()

            Case Keys.X
                mintStacks += 1
                If mintShape = MeshShape.Donut Then
                    If mintStacks > 500 Then mintStacks = 500
                Else
                    If mintStacks > 20 Then mintStacks = 20
                End If
                SetupGeo()

            Case Keys.C
                    If mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.None Then
                        mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.CounterClockwise
                    Else
                        mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.None
                    End If

            Case Keys.F
                    If mobjGraphics.Device.RenderState.FillMode = DirectX.Direct3D.FillMode.Solid Then
                        mobjGraphics.Device.RenderState.FillMode = DirectX.Direct3D.FillMode.WireFrame
                    Else
                        mobjGraphics.Device.RenderState.FillMode = DirectX.Direct3D.FillMode.Solid
                    End If

        End Select
    End Sub

    Private Sub Form_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Select Case e.Button
            Case MouseButtons.Left
                Rotation.X = e.X
                If Rotation.X < 0 Then Rotation.X = 0
                If Rotation.X > 359 Then Rotation.X = 359

            Case MouseButtons.Right
                Rotation.Y = e.X
                If Rotation.Y < 0 Then Rotation.Y = 0
                If Rotation.Y > 359 Then Rotation.Y = 359

            Case MouseButtons.Middle
                Rotation.Z = e.X
                If Rotation.Z < 0 Then Rotation.Z = 0
                If Rotation.Z > 359 Then Rotation.Z = 359
        End Select
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Demonstrates code that uses the CreateDonut, CreateBox, CreatePlane methods to generate geometry."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return New Bitmap(Me.GetType, "CreateShape.png")
    End Function

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "Create Shape"
    End Function
End Class