'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================

Imports CBX.Libs.DX9Tools.GeneralHelpers
Imports Microsoft
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D.Cull
Imports Microsoft.DirectX.Direct3D.FillMode
Imports Microsoft.DirectX.Direct3D.ShadeMode
Imports Microsoft.DirectX.Direct3D.TransformType
Imports Microsoft.DirectX.Direct3D.PrimitiveType
Imports Microsoft.DirectX.Direct3D.Geometry
Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX.DirectInput.CooperativeLevelFlags
Imports CBX.Libs

Public Class CubeMapping
    Inherits BaseExample
    Implements IExample

    Private mobjTextures As DX9Tools.Collections.TextureCollection
    Private mobjCameras As DX9Tools.Collections.CameraCollection
    Private Verts As DX9Tools.PCTGeometry
    Private CubeVerts As DX9Tools.PCTGeometry
    Private mobjFont As Direct3D.Font
    Private mobjSky As SkyBox
    Private mobjDXE As DX9Tools.DXEliminator.DXE
    Private mobjCubeMap As Direct3D.CubeTexture
    Private mobjCubeMapRender As Direct3D.RenderToEnvironmentMap
    Private mobjEffect As Direct3D.Effect
    Private effectString As String() = {"texture texCubeMap;" + ControlChars.Lf, "texture texSphereMap;" + ControlChars.Lf, "matrix matWorld;" + ControlChars.Lf, "matrix matView;" + ControlChars.Lf, "matrix matProject;" + ControlChars.Lf, "matrix matWorldView;" + ControlChars.Lf, "technique Cube" + ControlChars.Lf, "{" + ControlChars.Lf, "pass P0" + ControlChars.Lf, "{" + ControlChars.Lf, "VertexShader = null;" + ControlChars.Lf, "WorldTransform[0] = <matWorld>;" + ControlChars.Lf, "ViewTransform = <matView>;" + ControlChars.Lf, "ProjectionTransform = <matProject>;" + ControlChars.Lf, "Texture[0] = <texCubeMap>;" + ControlChars.Lf, "MinFilter[0] = Linear;" + ControlChars.Lf, "MagFilter[0] = Linear;" + ControlChars.Lf, "AddressU[0] = Clamp;" + ControlChars.Lf, "AddressV[0] = Clamp;" + ControlChars.Lf, "AddressW[0] = Clamp;" + ControlChars.Lf, "ColorOp[0] = SelectArg1;" + ControlChars.Lf, "ColorArg1[0] = Texture;" + ControlChars.Lf, "TexCoordIndex[0] = CameraSpaceReflectionVector;" + ControlChars.Lf, "TextureTransformFlags[0] = Count3;" + ControlChars.Lf, "}" + ControlChars.Lf, "}" + ControlChars.Lf, "technique Sphere" + ControlChars.Lf, "{" + ControlChars.Lf, "pass P0" + ControlChars.Lf, "{" + ControlChars.Lf, "VertexShader =" + ControlChars.Lf, "decl" + ControlChars.Lf, "{" + ControlChars.Lf, "}" + ControlChars.Lf, "asm" + ControlChars.Lf, "{" + ControlChars.Lf, "vs.1.1" + ControlChars.Lf, "def c64, 0.25f, 0.5f, 1.0f, -1.0f" + ControlChars.Lf, "dcl_position v0" + ControlChars.Lf, "dcl_normal v1" + ControlChars.Lf, "m4x4 r0, v0, c0" + ControlChars.Lf, "m3x3 r1.xyz, v1, c0" + ControlChars.Lf, "mov r1.w, c64.z" + ControlChars.Lf, "mov r2, -r0" + ControlChars.Lf, "dp3 r3, r2, r2" + ControlChars.Lf, "rsq r3, r3.w" + ControlChars.Lf, "mul r2, r2, r3" + ControlChars.Lf, "dp3 r3, r1, r2" + ControlChars.Lf, "mul r1, r1, r3" + ControlChars.Lf, "add r1, r1, r1" + ControlChars.Lf, "add r3, r1, -r2" + ControlChars.Lf, "mad r4.w, -r3.z, c64.y, c64.y" + ControlChars.Lf, "rsq r4, r4.w" + ControlChars.Lf, "mul r4, r3, r4" + ControlChars.Lf, "mad r4, r4, c64.x, c64.y" + ControlChars.Lf, "m4x4 oPos, r0, c4" + ControlChars.Lf, "mul oT0.xy, r4.xy, c64.zw" + ControlChars.Lf, "mov oT0.zw, c64.z" + ControlChars.Lf, "};" + ControlChars.Lf, "VertexShaderConstant4[0] = <matWorldView>;" + ControlChars.Lf, "VertexShaderConstant4[4] = <matProject>;" + ControlChars.Lf, "Texture[0] = <texSphereMap>;" + ControlChars.Lf, "AddressU[0] = Wrap;" + ControlChars.Lf, "AddressV[0] = Wrap;" + ControlChars.Lf, "MinFilter[0] = Linear;" + ControlChars.Lf, "MagFilter[0] = Linear;" + ControlChars.Lf, "ColorOp[0] = SelectArg1;" + ControlChars.Lf, "ColorArg1[0] = Texture;" + ControlChars.Lf, "}" + ControlChars.Lf, "}" + ControlChars.Lf}
    Private mblnRenderCube As Boolean


    Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        Dim Msg As String

        MsgBox("Still a work in progress...")
        Exit Sub

        DoInit()

        ' if cube maps if nothing then it was not created so we can run example.
        If mobjCubeMap Is Nothing Then
            Me.DoCleanUp()
            Exit Sub
        End If

        While mobjForm.Created
            mobjGraphics.BeginScene()

            ' render the cubemap
            RenderCubeMap()

            ' update user camera
            mobjCameras(0).UpdateVP()

            ' render scene
            RenderScene()

            Msg = "Left/Right mouse buttons rotate the camera" & vbCrLf
            Msg &= "W/S Move forward and backward" & vbCrLf
            Msg &= "A/D Strafe left and right" & vbCrLf
            Msg &= "Z/X Strafe up and down" & vbCrLf
            Msg &= "Values from the cameras GetRotation method" & vbCrLf
            Msg &= mobjCameras(0).GetRotation.ToString

            mobjFont.DrawText(Msg, mobjForm.ClientRectangle, Left Or Top, Color.Yellow)

            mobjGraphics.EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Private Sub RenderScene()
        ' render sky
        mobjSky.Render(mobjGraphics.Device, mobjTextures)

        ' render ground
        RenderGeometry(mobjGraphics.Device, Verts, mobjTextures)
    End Sub

    Private Sub RenderCubeMap()
        Dim idx As Integer

        ' stare rendering cubemap
        mobjCubeMapRender.BeginCube(mobjCubeMap)

        ' render each face of the cube map
        For idx = 0 To 5
            ' begin rendering cube face
            mobjCubeMapRender.Face(CType(idx, Direct3D.CubeMapFace), 1)

            ' update camera
            mobjCameras(1 + idx).UpdateVP()

            ' Render the scene 
            RenderScene()
        Next

        ' end the scene for the cube map
        mobjCubeMapRender.End(1)
     End Sub

    Private Sub RenderTheCube()
        '' Render the environment-mapped ShinyTeapot
        'If mblnRenderCube Then
        '    ' Set transform state
        '    If Not (mobjCubeMap Is Nothing) Then
        '        mobjEffect.SetValue(EffectHandle.FromString("matWorld"), worldMatrix)
        '        mobjEffect.SetValue(EffectHandle.FromString("matView"), View)
        '    Else
        '        Dim matWorldView As Matrix = Matrix.Multiply(worldMatrix, View)
        '        mobjEffect.SetValue(EffectHandle.FromString("matWorldView"), matWorldView)
        '    End If

        '    mobjEffect.SetValue(EffectHandle.FromString("matProject"), Project)


        '    ' Draw teapot
        '    Dim pVB As VertexBuffer = shinyTeapotMesh.LocalVertexBuffer
        '    Dim pIB As IndexBuffer = shinyTeapotMesh.LocalIndexBuffer
        '    Dim numVert As Integer = shinyTeapotMesh.LocalMesh.NumberVertices
        '    Dim numFace As Integer = shinyTeapotMesh.LocalMesh.NumberFaces

        '    Device.SetStreamSource(0, pVB, 0, DXHelp.GetTypeSize(GetType(EnvMappedVertex)))
        '    Device.VertexFormat = EnvMappedVertex.Format
        '    Device.Indices = pIB

        '    Dim Passes As Integer = mobjEffect.Begin(0)

        '    Dim iPass As Integer
        '    For iPass = 0 To Passes - 1
        '        mobjEffect.Pass(iPass)

        '        Device.DrawIndexedPrimitives(PrimitiveType.TriangleList, 0, 0, numVert, 0, numFace)
        '    Next iPass


        '    mobjEffect.End()
        'End If
    End Sub

    Protected Overrides Sub DoCleanUp()
        mobjCubeMap.Dispose()
        mobjCubeMap = Nothing
        mobjCubeMapRender.Dispose()
        mobjCubeMapRender = Nothing
        mobjFont.Dispose()
        mobjFont = Nothing
        Verts = Nothing
        mobjTextures.Dispose()
        mobjTextures = Nothing
        mobjCameras.Dispose()
        mobjCameras = Nothing
        mobjDXE.Mouse.DoneMouse()
        mobjDXE.Dispose()
        mobjDXE = Nothing
        RemoveHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit()
        MyBase.DoInit()

        '//Check cube texture requirements.
        Dim tr As Direct3D.CubeTextureRequirements = New Direct3D.CubeTextureRequirements()

        tr.Format = Direct3D.Format.A8R8G8B8

        Direct3D.TextureLoader.CheckCubeTextureRequirements(mobjGraphics.Device, 0, Direct3D.Pool.SystemMemory, tr)

        mobjForm.Text = "Camera Rotate Example"
        AddHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

        mobjTextures = New DX9Tools.Collections.TextureCollection()
        mobjTextures.DisposeOnClear = True
        mobjTextures.Add(LoadResourceImage(Me.GetType.Namespace & ".Dirt.png"))

        mobjCameras = New DX9Tools.Collections.CameraCollection()

        ' setup cameras
        CreateCameras()

        ' create font
        mobjFont = New Direct3D.Font(mobjGraphics.Device, New Font(mobjForm.Font.FontFamily, 16, FontStyle.Bold, GraphicsUnit.Pixel))

        ' no lighting
        mobjGraphics.Device.RenderState.Lighting = False

        mobjSky = New SkyBox(10000)

        ' Create the cubemap, with a format that matches the backbuffer
        If mobjGraphics.Device.DeviceCaps.TextureCaps.SupportsCubeMap Then
            Try
                mobjCubeMap = New Direct3D.CubeTexture(mobjGraphics.Device, 256, 1, Direct3D.Usage.RenderTarget, mobjGraphics.Device.PresentationParameters.BackBufferFormat, Direct3D.Pool.Default)
            Catch
                Try
                    mobjCubeMap = New Direct3D.CubeTexture(mobjGraphics.Device, 256, 1, 0, mobjGraphics.Device.PresentationParameters.BackBufferFormat, Direct3D.Pool.Default)
                Catch
                    mobjCubeMap = Nothing
                End Try
            End Try
        End If

        ' create render for cub map
        mobjCubeMapRender = New Direct3D.RenderToEnvironmentMap(mobjGraphics.Device, 256, 1, _
                                                   mobjGraphics.Device.PresentationParameters.BackBufferFormat, _
                                                   True, _
                                                   Direct3D.DepthFormat.D16)


        ' setup effect
        Dim sEffect As String = Nothing
        Dim i As Integer
        For i = 0 To effectString.Length - 1
            sEffect += effectString(i)
        Next i
        mobjEffect = mobjEffect.FromString(mobjGraphics.Device, sEffect, Nothing, 0, Nothing)

        ' Initialize effect
        mobjEffect.SetValue(Direct3D.EffectHandle.FromString("texCubeMap"), mobjCubeMap)

        If Not mobjCubeMap Is Nothing Then
            mobjEffect.Technique = Direct3D.EffectHandle.FromString("Cube")
        Else
            mobjEffect.Technique = Direct3D.EffectHandle.FromString("Sphere")
        End If


        ' setup mouse handling
        mobjDXE = New DX9Tools.DXEliminator.DXE()
        mobjDXE.Mouse.InitMouse()
        mobjDXE.Mouse.AquireMouse()


        ' setup geometry
        SetupGeo()
    End Sub

    Private Sub CreateCameras()
        ' Create user view camera
        Dim Cam As DX9Tools.Camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(0, 10, 1)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)

        ' create right cubemap camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(1, 10, 0)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)

        ' create left cubemap camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(-1, 10, 0)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)

        ' create top cubemap camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(0, 11, 0.00001)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)

        ' create bottom cubemap camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(1, 9, 0.00001)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)

        ' create front cubemap camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(0, 10, 1)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)

        ' create back cubemap camera
        Cam = New DX9Tools.Camera(mobjGraphics)
        With Cam
            .SetPosition(0, 10, 0)
            .SetLookAt(0, 10, -1)
            .FarPlane = 10000
        End With
        mobjCameras.Add(Cam)
    End Sub

    Private Function GetImageResourceName(ByVal Index As Direct3D.CubeMapFace) As String
        Return GetImageResourceName(Index)
    End Function

    Private Function GetImageResourceName(ByVal Index As Integer) As String
        Select Case Index
            Case Direct3D.CubeMapFace.PositiveZ
                Return Me.GetType.Namespace & ".skybox_front.png"

            Case Direct3D.CubeMapFace.PositiveX
                Return Me.GetType.Namespace & ".skybox_right.png"

            Case Direct3D.CubeMapFace.NegativeZ
                Return Me.GetType.Namespace & ".skybox_back.png"

            Case Direct3D.CubeMapFace.NegativeX
                Return Me.GetType.Namespace & ".skybox_left.png"

            Case Direct3D.CubeMapFace.PositiveY
                Return Me.GetType.Namespace & ".skybox_top.png"

            Case Direct3D.CubeMapFace.NegativeY
                Return Me.GetType.Namespace & ".skybox_bottom.png"
        End Select
    End Function

    Private Sub SetupGeo()
        Dim Tex(), V() As Vector3
        Dim idx As Integer

        'create ground
        V = DX9Tools.GeoHelpers.CreatePlane(New Rectangle(-500, -500, 1000, 1000), 10, 10)
        'create uv cords for ground
        Tex = DX9Tools.GeoHelpers.CreatePlane(New Rectangle(0, 0, 10, 10), 10, 10)
        ' rotate ground 90 along x axis
        V = DX9Tools.GeoHelpers.VectorSwap(V, DX9Tools.Orientation.ZY)

        ' populate mesh data
        Verts = Nothing
        Verts = New DX9Tools.PCTGeometry(Direct3D.PrimitiveType.TriangleList, V.Length, _
                                         New DX9Tools.IndexedTextureBlendingItem(mobjGraphics.Device.TextureState(0), 0))
        For idx = 0 To V.Length - 1
            Verts.SetVertex(idx, New Direct3D.CustomVertex.PositionColoredTextured(V(idx), Color.White.ToArgb, Tex(idx).X, Tex(idx).Y))
        Next

        ' setup skybox
        For idx = 0 To 5
            Dim Ret As Integer
            Dim Blend As DX9Tools.IndexedTextureBlendingItem

            Ret = mobjTextures.Add(LoadResourceImage(GetImageResourceName(idx)))
            Blend = New DX9Tools.IndexedTextureBlendingItem(mobjGraphics.Device.TextureState(0), Ret)
            mobjSky.Vertexes(idx).Blending = Blend
            mobjSky.TextureIndex(idx) = Ret
        Next

        ' create cube
        CubeVerts = New DX9Tools.PCTGeometry(DirectX.Direct3D.PrimitiveType.TriangleList)

        V = DX9Tools.GeoHelpers.CreateBox(New Vector3(), New Vector3(50, 50, 50), 1, 1, 1)
        CubeVerts.VertexCount = V.Length
        For idx = 0 To V.Length - 1
            CubeVerts.SetVertex(idx, V(idx), Color.White)
        Next
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Dim Cam As DX9Tools.Camera = mobjCameras(0)

        Select Case e.KeyCode
            Case Keys.W
                GoForward(4)

            Case Keys.S
                GoBackward(4)

            Case Keys.A
                Cam.HStrafe(4)

            Case Keys.D
                Cam.HStrafe(-4)

            Case Keys.Z
                Cam.VStrafe(4)

            Case Keys.X
                Cam.VStrafe(-4)
        End Select
    End Sub

    ' distance parameter is not yet implemented
    Private Sub GoBackward(ByVal Distance As Single)
        Dim Cam As DX9Tools.Camera = mobjCameras(0)
        Dim V As Vector3
        V = Vector3.Subtract(Cam.Position, Cam.LookAt)
        Cam.Position = Vector3.Add(Cam.Position, V)
        Cam.LookAt = Vector3.Add(Cam.LookAt, V)
    End Sub

    ' distance parameter is not yet implemented
    Private Sub GoForward(ByVal Distance As Single)
        Dim Cam As DX9Tools.Camera = mobjCameras(0)
        Dim V As Vector3
        V = Vector3.Subtract(Cam.Position, Cam.LookAt)
        Cam.Position = Vector3.Subtract(Cam.Position, V)
        Cam.LookAt = Vector3.Subtract(Cam.LookAt, V)
    End Sub

    Private Sub Form_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Static Rotation As Vector3

        Select Case e.Button
            Case MouseButtons.Left
                mobjDXE.Mouse.GetMouseState()
                Dim Pos As Vector3
                Pos = mobjDXE.Mouse.GetMousePosition

                Rotation.X += Pos.X
                Rotation.Y += Pos.Y
                ' limit up/down rotation to 89 degrees
                If Rotation.Y < -89 Then Rotation.Y = -89
                If Rotation.Y > 89 Then Rotation.Y = 89

                ' tell camera to rotate
                mobjCameras(0).Rotate(DegreeToRadian(Rotation.X), DegreeToRadian(Rotation.Y), DegreeToRadian(Rotation.Z), 4.0F)

            Case MouseButtons.Right
                Rotation.Z = DegreeToRadian(e.X)
                mobjCameras(0).Rotate(Rotation.X, Rotation.Y, Rotation.Z, 4.0F)
        End Select
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Still a work in progress..."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return Nothing 'New Bitmap(Me.GetType, "CameraRotate.png")
    End Function

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "Cube Mapping"
    End Function
End Class