'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: October 26, 2003
'=============================================

Imports CBX.Libs.DX9Tools.GeneralHelpers
Imports CBX.Libs
Imports Microsoft.DirectX

Public Class GraphicFont
    Inherits BaseExample
    Implements IExample

    Private mobjFont As DX9Tools.D3DGraphicFont
    Private mobjTextures As DX9Tools.Collections.TextureCollection
   

    Protected Overrides Sub DoCleanUp()
        mobjFont.Dispose()
        mobjFont = Nothing
        mobjTextures.Clear()
        mobjTextures = Nothing
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit()
        MyBase.DoInit()
        mobjForm.Text = "Graphic Font Example"

        mobjTextures = New DX9Tools.Collections.TextureCollection()
        mobjTextures.Add(LoadResourceImage(Me.GetType.Namespace & ".Font.png", Color.White))

        mobjGraphics.Device.RenderState.Lighting = False
        mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.None

        ' create font
        mobjFont = New DX9Tools.D3DGraphicFont(True, 0)

        ' setup font
        SetupFont()
    End Sub

    Private Sub SetupFont()
        Dim idx, XPos, YPos As Integer

        ' setup font chars manually. Obviously it's best to load this data from a file
        With mobjFont
            XPos = 0
            YPos = 0
            ' setup chars
            For idx = Asc("A") To Asc("Z")
                .Chars(idx) = New Rectangle(XPos, YPos, XPos + 31, YPos + 31)
                XPos += 32
                If XPos >= 256 Then
                    XPos = 0
                    YPos += 32
                End If
            Next

            ' setup numbers
            YPos += 32
            XPos = 0
            For idx = Asc("0") To Asc("9")
                .Chars(idx) = New Rectangle(XPos, YPos, XPos + 31, YPos + 31)
                XPos += 32
                If XPos >= 256 Then
                    XPos = 0
                    YPos += 32
                End If
            Next

            ' space 
            XPos += 32
            .Chars(Asc(" ")) = New Rectangle(XPos, YPos, XPos + 31, YPos + 31)
            ' We set the vbcr character the same as the space character because if the text begins with a vbcr or vbcrlf
            ' the DrawGraphicFont method will not print out the text as expected. This is because DrawGraphicFont calculates
            ' the height of the line it's drawing checking the height of each character it prints out. And if the text starts
            ' with a carrage return character vbcr then it will think the line height is 0 high and will print the next line
            ' starting at 0.
            .Chars(Asc(vbCr)) = .Chars(Asc(" "))

            ' setup chars 
            XPos = Asc("A")
            For idx = Asc("a") To Asc("z")
                .Chars(idx) = .Chars(XPos)
                XPos += 1
            Next
        End With
    End Sub

    Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        Dim Msg As String
        Msg = "This is a test ..." & vbCrLf
        Msg &= "ABCDEFGHIJKLMNOPQR" & vbCrLf
        Msg &= "STUVWXYZabcdefghij" & vbCrLf
        Msg &= "klmnopqrstuvwxyz" & vbCrLf
        Msg &= "0123456789" & vbCrLf
        Msg &= "!@#$%^&*()_+-=[]{}" & vbCrLf
        Msg &= "\|/?.>,<;:'""`~"

        DoInit()

        While mobjForm.Created
            mobjGraphics.BeginScene()

            ' Render here
            DrawGraphicFont(mobjGraphics.Device, mobjFont, Msg, 0, 0, mobjTextures)

            mobjGraphics.EndScene()
            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Demonstrates code that uses the DX9Tools.D3DGraphicFont object."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return New Bitmap(Me.GetType, "GraphicFont.png")
    End Function

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "Graphic Font"
    End Function
End Class