'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: October 26, 2003
'=============================================
Imports CBX.Libs.DX9Tools.GeneralHelpers
Imports CBX.Libs
Imports Microsoft.DirectX

Public Class GraphicFontAnimated
    Inherits BaseExample
    Implements IExample

    Private mobjFont As DX9Tools.D3DGraphicFontAnimated
    Private mobjTextures As DX9Tools.Collections.TextureCollection


    Protected Overrides Sub DoCleanUp()
        mobjFont.Dispose()
        mobjFont = Nothing
        mobjTextures.Clear()
        mobjTextures = Nothing
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit()
        MyBase.DoInit()
        mobjForm.Text = "Graphic Font Animated Example"

        mobjTextures = New DX9Tools.Collections.TextureCollection()
        mobjTextures.Add(LoadResourceImage(Me.GetType.Namespace & ".Font.png", Color.White))

        mobjGraphics.Device.RenderState.Lighting = False
        mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.None

        ' create font
        mobjFont = New DX9Tools.D3DGraphicFontAnimated(True, 0)

        ' setup font
        SetupFont()
    End Sub

    Private Sub SetupFont()
        Dim idx, XPos, YPos As Integer
        Dim TheTime As Long

        ' setup font chars manually. obviously best to load this data from a file
        With mobjFont
            XPos = 0
            YPos = 0
            ' setup chars
            For idx = Asc("a") To Asc("z")
                Dim idy As Integer
                For idy = 0 To 10
                    Dim RandX, RandY As Integer
                    Randomize(Now.Ticks)
                    RandX = CInt(Rnd() * 4)
                    RandY = CInt(Rnd() * 4)
                    .Chars(idx).Add(New DX9Tools.Animation.AnimatedStripItem(100 + CInt(Rnd() * 50), TheTime, New Rectangle(XPos + RandX, YPos + RandY, XPos + RandX + 31, YPos + RandY + 31)))
                Next
                .Chars(idx).CurrentItem = 0
                XPos += 32
                If XPos >= 256 Then
                    XPos = 0
                    YPos += 32
                End If
            Next

            ' setup numbers
            YPos += 32
            XPos = 0
            For idx = Asc("0") To Asc("9")
                .Chars(idx).Add(New DX9Tools.Animation.AnimatedStripItem(150, TheTime, New Rectangle(XPos, YPos, XPos + 31, YPos + 31)))
                .Chars(idx).CurrentItem = 0

                'add animated chars. (animated chars ar just the next number after it.)
                If True Then
                    Dim idy, XPosB, YPosB As Integer
                    XPosB = XPos
                    YPosB = YPos
                    idy = idx + 1
                    If idy > Asc("9") Then idy = Asc("0")
                    While idy <> idx
                        .Chars(idx).Add(New DX9Tools.Animation.AnimatedStripItem(150, TheTime, New Rectangle(XPosB, YPosB, XPosB + 31, YPosB + 31)))
                        XPosB += 32
                        If XPosB >= 256 Then
                            XPosB = 0
                            YPosB += 32
                        End If
                        idy += 1
                        If idy > Asc("9") Then idy = Asc("0")

                    End While
                End If

                XPos += 32
                If XPos >= 256 Then
                    XPos = 0
                    YPos += 32
                End If
            Next

            ' space 
            XPos += 32
            .Chars(Asc(" ")).Add(New DX9Tools.Animation.AnimatedStripItem(100, TheTime, New Rectangle(XPos, YPos, XPos + 31, YPos + 31)))
            .Chars(Asc(" ")).CurrentItem = 0
        End With
    End Sub

    Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        MsgBox("Still a work in progress...")
        Exit Sub

        Dim Msg As String
        Msg = "This is a test ..." & vbCrLf
        Msg &= "ABCDEFGHIJKLMNOPQR" & vbCrLf
        Msg &= "STUVWXYZabcdefghij" & vbCrLf
        Msg &= "klmnopqrstuvwxyz" & vbCrLf
        Msg &= "0123456789" & vbCrLf
        Msg &= "!@#$%^&*()_+-=[]{}" & vbCrLf
        Msg &= "\|/?.>,<;:'""`~"

        DoInit()

        While mobjForm.Created
            mobjGraphics.BeginScene()

            ' Render here
            ' DrawGraphicFont(mobjGraphics.Device, mobjFont, Msg, 0, 0, mobjTextures)

            mobjGraphics.EndScene()
            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Still a work in progress..."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return Nothing 'New Bitmap(Me.GetType, "OrthoProject.png")
    End Function

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "Graphic Font Animated"
    End Function


    'Private Sub DrawString(ByVal Text As String, ByVal Translation As Vector2)
    '    Dim idx, MaxHeight As Integer
    '    Dim V As Vector2 = Translation
    '    Dim R As Rectangle
    '    Dim C As String

    '    For idx = 0 To Text.Length - 1
    '        C = Text.ToLower.Chars(idx)

    '        Select Case C.ToString
    '            Case vbCr
    '                V = New Vector2(Translation.X, V.Y + MaxHeight)
    '                MaxHeight = 0

    '            Case Space(1)
    '                V.X += R.Width - R.Left

    '            Case Else
    '                Dim TheTime As Long = Now.Ticks
    '                If mobjFont.Chars(Asc(C)).Count > 0 Then
    '                    With mobjFont.Chars(Asc(C))
    '                        If TheTime > .Item(.CurrentItem).LastTime + MilliToTicks(.Item(.CurrentItem).Time) Then
    '                            If .CurrentItem = .Count - 1 Then .CurrentItem = 0 Else .CurrentItem += 1

    '                            .Item(.CurrentItem).LastTime = TheTime
    '                        End If

    '                        R = .Item(.CurrentItem).SourceRectangle
    '                    End With

    '                    If MaxHeight < R.Height Then MaxHeight = R.Height
    '                    mobjSprite.Draw(mobjFont.Texture, R, V)
    '                    V.X += R.Width - R.Left
    '                End If
    '        End Select
    '    Next
    'End Sub

End Class