'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: December 23, 2004
'=============================================

Public Class LavaEffect
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Private FX As Direct3D.Effect

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        DoInit()


        Dim Dev As Direct3D.Device = GetD3DDevice()
        While mobjForm.Created
            BeginScene()

            Dim Aspect As Single = CSng(mobjForm.ClientSize.Width / mobjForm.ClientSize.Height)

            Static rot As Single
            rot += 0.01F
            Dim worldMatrix As Matrix = Matrix.Identity
            worldMatrix.Multiply(Matrix.RotationYawPitchRoll(rot, CSng(Math.Sin(rot)) / 2, 0))
            worldMatrix.Multiply(Matrix.Translation(0, 0, 0))
            Dim projMatrix As Matrix = Matrix.PerspectiveFovLH(Math.PI / 4, Aspect, 1.0F, 10000.0F)
            Dim viewMatrix As Matrix = Matrix.LookAtLH(New Vector3(0, 500, -500.0F), New Vector3(0, 500, 0), New Vector3(0, 1, 0))


            Dim worldViewProj As Matrix = Matrix.Identity
            worldViewProj.Multiply(worldMatrix)
            worldViewProj.Multiply(viewMatrix)
            worldViewProj.Multiply(projMatrix)
            Dev.Transform.World = worldMatrix
            Dev.Transform.View = viewMatrix
            Dev.Transform.Projection = projMatrix
            ' FX.SetValue(Direct3D.EffectHandle.FromString("WorldViewProj"), worldViewProj)



            Dim Passes As Integer = FX.Begin(0)
            Dim idx As Integer
            Dim M As Mesh
            GetMesh("Sky", M)
            For idx = 0 To Passes - 1
                FX.Pass(idx)

                M.Mesh.DrawSubset(0)
                ' DrawMesh("Sky")

            Next
            FX.End()

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        If FX Is Nothing = False Then FX.Dispose()
        FX = Nothing
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit()

        ' load sky sphere
        Dim Dev As Direct3D.Device = GetD3DDevice()

        Dim Mesh As New Mesh()
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("SkyBox.X"), Direct3D.MeshFlags.Managed, Dev)
        Mesh.Materials.Add("White")
        ' Mesh.Textures.Add("Back")
        AddMesh("Sky", Mesh)

        AddMaterial("White", Color.White, Color.White, True)

        '  AddTexture("Back", LoadResourceImage("Back.png"))
        ' AddTexture("Dirt", LoadResourceImage("Dirt.png"))
        '  Dim Tex As Direct3D.Texture
        ' Tex = LoadResourceImage("Flame.tga")
        ' AddTexture("Flame", tex)

        Dim ErrMsg As String
        Try
            FX = Direct3D.Effect.FromStream(Dev, LoadResource("Lava.fx"), Nothing, Direct3D.ShaderFlags.None, Nothing, ErrMsg)
            ' FX = Direct3D.Effect.FromFile(Dev, "..\Media\Lava.fx", Nothing, Direct3D.ShaderFlags.None, Nothing, ErrMsg)
            FX.Technique = FX.GetTechnique("Lava")
            'FX.SetValue(Direct3D.EffectHandle.FromString("Flame_Tex"), Tex)
            'With FX.GetValueTexture(Direct3D.EffectHandle.FromString("Flame_Tex"))

            'End With

        Catch ex As Exception
            Throw New DirectXException(ErrMsg, ex)
        End Try

        'FX.Technique = "TransformInverseTexture"

        'FX.Technique = "Ocean"
        Dim Aspect As Single = CSng(mobjForm.ClientSize.Width / mobjForm.ClientSize.Height)
        ' FX.SetValue("view_proj_matrix", Matrix.PerspectiveFovLH(Math.PI / 2, Aspect, 1, 10000))
        '  FX.SetValue("view_position", New Vector4(0, 0, -10, 1))

        Dim elements() As Direct3D.VertexElement = { _
                New Direct3D.VertexElement(0, 0, Direct3D.DeclarationType.Float3, _
                Direct3D.DeclarationMethod.Default, _
                Direct3D.DeclarationUsage.Position, 0), _
                Direct3D.VertexElement.VertexDeclarationEnd}

        Dim decl As New Direct3D.VertexDeclaration(Dev, elements)
        Dev.VertexDeclaration = decl

        mobjForm.Text = "D3D Lava Effect Example"
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates loading and using *.FX effect files."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return Nothing ' New Bitmap(Me.GetType, "OrthoProject.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Lava Effect"
    End Function
End Class