'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================
Imports Microsoft.DirectX.Direct3D.Geometry

Public Class MeshEx
    Inherits BaseExample
    Implements IExample

    
    Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        Dim Msg As String

        DoInit()
         While mobjForm.Created
            BeginScene()
            UpdateActiveLights()

            ' setup rotation matrix
            Static Rot As Single
            Rot += 0.1F
            GetD3DDevice.Transform.World = Matrix.RotationYawPitchRoll(DegreeToRadian(Rot), DegreeToRadian(Rot), DegreeToRadian(Rot))

            ' render mesh
            ' SetTexture(0, "Cube")
            DrawMesh("Cube")

            Msg = "Use L key to toggle lighting." & vbCrLf & "Lighting enabled: " & IsLightingEnabled.ToString
            DrawText(Msg, 0, 0)

            EndScene()
            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit()
        MyBase.DoInit()
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

        EnableLighting(False)
        GetCurrentViewport.BackgroundColor = Color.SteelBlue

        mobjForm.Text = "Mesh Example"
       
        Dim LightX As New Light
        LightX.Light.Direction = New Vector3
        LightX.Light.Position = New Vector3(0, 0, -500)
        LightX.Light.Range = 10000
        'LightX.Light.Enabled = True
        LightX.Light.Type = Direct3D.LightType.Directional
        AddLight("Light1", LightX)
        LightX.SetActive(True)

        LightX = New Light
        LightX.Light.Direction = New Vector3
        LightX.Light.Position = New Vector3(0, 0, 500)
        LightX.Light.Range = 10000
        'LightX.Light.Enabled = True
        LightX.Light.Type = Direct3D.LightType.Directional
        AddLight("Light2", LightX)
        LightX.SetActive(True)

        AddCamera(New Vector3(0, 0, -15), New Vector3, New Vector3(0, 1, 0), Math.PI / 2, 1, 10000, True)
       
        ' setup geometry
         Dim Mesh As New Mesh
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("Cube3.X"), Direct3D.MeshFlags.Managed, GetD3DDevice)
        Mesh.Textures.Add("Cube")
        Mesh.Materials.Add("White")
        AddMesh("Cube", Mesh)

        ' load textures
        AddTexture("Cube", LoadResourceImage("Cube.png"))

        ' load materials
        Dim Mat As New Material
        Mat.Material.Ambient = Color.White
        Mat.Material.Diffuse = Color.White
        AddMaterial("White", Mat, True)
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Demonstrates code that uses a OrthoOffCenterLH projection matrix."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return New Bitmap(Me.GetType, "MeshEx.png")
    End Function

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.L
                EnableLighting(Not IsLightingEnabled())

            Case Keys.Escape
                mobjForm.Close()
        End Select
    End Sub

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "MeshEx"
    End Function
End Class
