'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================
Imports CBX.Libs
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports CBX.Libs.DX9Tools.GeneralHelpers

Public Class VertexBlend
    Inherits BaseExample
    Implements IExample

    Private Rotation As Integer = 0
    Private BlendRotation As Integer = 0
    Private Rect As Rectangle
    Private mobjFont As Direct3D.Font
    Private Structure Vertex
        Public Position As Vector3
        Public Blend1 As Single
        Public Blend2 As Single
        Public Color As Integer
    End Structure
    Public Format As Direct3D.VertexFormats = DirectX.Direct3D.VertexFormats.PositionBlend2 Or DirectX.Direct3D.VertexFormats.Diffuse
    Public StrideSize As Integer = 24
    Private Verts() As Vertex


     Public Sub Run() Implements DX9Tools_Tester.IExample.Run
        Dim Msg As String

        DoInit()

        While mobjForm.Created
            mobjGraphics.BeginScene()

            ' setup 2D projection matrix
            Dim Proj As Matrix
            Proj = Matrix.OrthoOffCenterLH(0, mobjForm.ClientSize.Width, mobjForm.ClientSize.Height, 0, 1, 1000)
            mobjGraphics.Device.SetTransform(DirectX.Direct3D.TransformType.Projection, Proj)

            ' setup rotation matrix
            SetupRotation()

            ' render rect
            mobjGraphics.Device.VertexFormat = Format
            Dim pCount As Integer
            pCount = GetPrimitiveCount(DirectX.Direct3D.PrimitiveType.TriangleFan, Verts.Length)
            mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.TriangleFan, pCount, Verts)

            Msg = "Left mouse button moves the shape" & vbCrLf
            Msg &= "Middle mouse button rotates the shape" & vbCrLf
            Msg &= "Right mouse button rotates the shape using blend weight" & vbCrLf
            Msg &= "W and S sets toggles witeframe and solid rendering"

            mobjFont.DrawText(Msg, mobjForm.ClientRectangle, Left Or Top, Color.Yellow)

            mobjGraphics.EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Private Sub SetupRotation()
        Dim M As Matrix = Matrix.Identity
        Dim HalfSize, Center As Vector3

        HalfSize = New Vector3(Rect.Width \ 2, Rect.Height \ 2, 0)
        Center = Vector3.Add(New Vector3(Rect.Left, Rect.Top, 0), HalfSize)

        ' setup blending weight matrix for Vertex.Blend1
        M = Matrix.Identity
        M.Multiply(M.RotationZ(Direct3D.Geometry.DegreeToRadian(Rotation)))
        M.Multiply(Matrix.Translation(Center))
        mobjGraphics.Device.SetTransform(DirectX.Direct3D.TransformType.World, M)

        ' setup blending weight matrix for Vertex.Blend2
        M = Matrix.Identity
        M.Multiply(M.RotationZ(Direct3D.Geometry.DegreeToRadian(BlendRotation)))
        mobjGraphics.Device.SetTransform(DirectX.Direct3D.TransformType.World1, M)
    End Sub

    Protected Overrides Sub DoCleanUp()
        mobjFont.Dispose()
        mobjFont = Nothing
        RemoveHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit()
        MyBase.DoInit()

        Rotation = 0
        BlendRotation = 0
        Rect = New Rectangle(50, 50, 150, 150)
        mobjForm.Text = "Vertex Blending Example"
        AddHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown

        ' create fonst
        mobjFont = New Direct3D.Font(mobjGraphics.Device, New Font(mobjForm.Font.FontFamily, 16, FontStyle.Bold, GraphicsUnit.Pixel))

        mobjGraphics.Device.RenderState.Lighting = False
        mobjGraphics.Device.RenderState.CullMode = DirectX.Direct3D.Cull.None
        mobjGraphics.Device.RenderState.VertexBlend = DirectX.Direct3D.VertexBlend.TwoWeights

        ' setup geometry
        SetupGeo()
    End Sub

    Private Sub SetupGeo()
        Dim Size As Integer = 200

        ReDim Verts(9)
        Verts(0).Position = New Vector3(0, 0, 0)
        Verts(0).Blend1 = 1
        Verts(0).Blend2 = 0
        Verts(0).Color = Color.White.ToArgb

        Verts(1).Position = New Vector3(-Size, -Size, 0)
        Verts(1).Blend1 = 1
        Verts(1).Blend2 = 0.5
        Verts(1).Color = Color.White.ToArgb

        Verts(2).Position = New Vector3(0, -Size \ 2, 0)
        Verts(2).Blend1 = 1
        Verts(2).Blend2 = 1
        Verts(2).Color = Color.Red.ToArgb

        Verts(3).Position = New Vector3(Size, -Size, 0)
        Verts(3).Blend1 = 1
        Verts(3).Blend2 = 0.5
        Verts(3).Color = Color.White.ToArgb

        Verts(4).Position = New Vector3(Size \ 2, 0, 0)
        Verts(4).Blend1 = 1
        Verts(4).Blend2 = 1
        Verts(4).Color = Color.Blue.ToArgb

        Verts(5).Position = New Vector3(Size, Size, 0)
        Verts(5).Blend1 = 1
        Verts(5).Blend2 = 0.5
        Verts(5).Color = Color.White.ToArgb

        Verts(6).Position = New Vector3(0, Size \ 2, 0)
        Verts(6).Blend1 = 1
        Verts(6).Blend2 = 1
        Verts(6).Color = Color.Green.ToArgb

        Verts(7).Position = New Vector3(-Size, Size, 0)
        Verts(7).Blend1 = 1
        Verts(7).Blend2 = 0.5
        Verts(7).Color = Color.White.ToArgb

        Verts(8).Position = New Vector3(-Size \ 2, 0, 0)
        Verts(8).Blend1 = 1
        Verts(8).Blend2 = 1
        Verts(8).Color = Color.Yellow.ToArgb

        Verts(9).Position = New Vector3(-Size, -Size, 0)
        Verts(9).Blend1 = 1
        Verts(9).Blend2 = 0.5
        Verts(9).Color = Color.White.ToArgb
    End Sub

    Private Sub Form_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Select Case e.Button
            Case MouseButtons.Left
                Rect.Location = New Point(e.X, e.Y)
                Rotation = 0
              
            Case MouseButtons.Right
                  BlendRotation = e.X
                If BlendRotation < 0 Then BlendRotation = 0
                If BlendRotation > 359 Then BlendRotation = 359

            Case MouseButtons.Middle
                Rotation = e.X
                If Rotation < 0 Then Rotation = 0
                If Rotation > 359 Then Rotation = 359
        End Select
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.W
                mobjGraphics.Device.RenderState.FillMode = DirectX.Direct3D.FillMode.WireFrame

            Case Keys.S
                mobjGraphics.Device.RenderState.FillMode = DirectX.Direct3D.FillMode.Solid
        End Select
    End Sub

    Public Function GetDescription() As String Implements DX9Tools_Tester.IExample.GetDescription
        Return "Demonstrates code that uses blending weights."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DX9Tools_Tester.IExample.GetImage
        Return New Bitmap(Me.GetType, "VertexBlending.png")
    End Function

    Public Function GetName() As String Implements DX9Tools_Tester.IExample.GetName
        Return "Vertex Blending"
    End Function
End Class