'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: December 23, 2004
'=============================================

Public Class RenderToTexture
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

     Private Const RTS_SIZE As Integer = 256

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        DoInit()

        Dim rot As Single
        Dim worldMatrix As Matrix = Matrix.Identity

        Dim LastTime As Long
        While mobjForm.Created

            worldMatrix = Matrix.Identity
            worldMatrix.Multiply(Matrix.RotationYawPitchRoll(rot, CSng(Math.Sin(rot)) / 2, 0))
            SetWorldMatrix(worldMatrix)
            SetCurrentCamera("SkyCam", True)

            BeginScene("RTS", "RenderTarget", , False, , "RenderToTextureVP")
            DrawMesh("Sky")
            EndScene(, DirectX.Direct3D.Filter.None)

            BeginScene(, , DEFAULTVIEWPORT)

            ' rotate every 10 milli secs
            If Now.Ticks > LastTime + TimeSpan.FromMilliseconds(10).Ticks Then
                rot += 0.01F
                LastTime = Now.Ticks
            End If

            DrawMesh("Sky")

            SetCurrentCamera("BoxCam", True)
            DrawMesh("Box")

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        ' load sky sphere
        Dim Dev As Direct3D.Device = GetD3DDevice()

        Dim Mesh As New Mesh()
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("SkyBox.X"), Direct3D.MeshFlags.Managed, Dev)
        Mesh.Materials.Add("White")
        Mesh.Textures.Add("Back")
        AddMesh("Sky", Mesh)

        Mesh = New Mesh()
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("Box.X"), Direct3D.MeshFlags.Managed, Dev)
        Mesh.Materials.Add("White")
        Mesh.Textures.Add("RenderTarget")
        AddMesh("Box", Mesh)

        AddMaterial("White", Color.White, Color.White, True)

        Dim VP As New Viewport()
        VP.Viewport.Width = RTS_SIZE
        VP.Viewport.Height = RTS_SIZE
        VP.Viewport.MaxZ = 10000
        AddViewport("RenderToTextureVP", VP)

        AddTexture("Back", LoadResourceImage("Back.png"))

        CreateRenderToSurface("RTS", RTS_SIZE, RTS_SIZE)
        CreateRenderToSurfaceTexture("RenderTarget", RTS_SIZE, RTS_SIZE, 1)

        AddCamera("SkyCam", New Vector3(0, 500, -500.0F), New Vector3(0, 500, 0), New Vector3(0, 1, 0), Math.PI / 4, 1, 10000)
        AddCamera("BoxCam", New Vector3(0, 0, -200.0F), New Vector3(0, 0, 0), New Vector3(0, 1, 0), Math.PI / 2, 1, 10000)

        mobjForm.Text = "Render To Texture Example"
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates how to render to a texture."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "RenderToTexture.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Render To Texture"
    End Function
End Class