'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry
Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX

Public Class RotateAroundAxis
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Private Rotation As Integer
    Private mobjPosition As Vector3
    Private mobjRAA As Vector3
    Private mobjAxis As Vector3
   
    Public Sub Run() Implements DXTTesterExt.IExample.Run
        Dim Msg As String

        DoInit()

        ' setup 2D projection matrix
        SetProjectionMatrix(Matrix.OrthoOffCenterLH(0, mobjForm.ClientSize.Width, mobjForm.ClientSize.Height, 0, 1, 1000))

        While mobjForm.Created
            BeginScene()


            BeginLineDrawing()
            RenderCircle(Color.Red, mobjAxis)
            RenderCircle(Color.Orange, mobjPosition)
            RenderCircle(Color.Cyan, mobjRAA)
            EndLineDrawing()

            ' redner info
            Msg = "Left mouse button sets position" & vbCrLf
            Msg &= "RIght mouse button sets axis" & vbCrLf
            Msg &= "Middle mouse button sets the rotation" & vbCrLf
            Msg &= "Rotation: " & Rotation.ToString & vbCrLf
            Msg &= "GetRotation (Radians): " & GetRotationInRadians(mobjPosition.X, mobjPosition.Y, mobjAxis.X, mobjAxis.Y) & vbCrLf
            Msg &= "GetRotation (Degrees): " & GetRotationInDegrees(mobjPosition.X, mobjPosition.Y, mobjAxis.X, mobjAxis.Y)

            SetFontFormatting(Left Or Top)
            SetDrawColor(Color.Yellow)
            DrawText(Msg, mobjForm.ClientRectangle)

            Msg = "Position: " & Color.Orange.ToString
            SetFontFormatting(Left Or Bottom)
            SetDrawColor(Color.Orange)
            DrawText(Msg, mobjForm.ClientRectangle)

            Msg = "Axis: " & Color.Red.ToString
            SetFontFormatting(Center Or Bottom)
            SetDrawColor(Color.Red)
            DrawText(Msg, mobjForm.ClientRectangle)

            Msg = "Rotated Point: " & Color.Cyan.ToString
            SetFontFormatting(Right Or Bottom)
            SetDrawColor(Color.Cyan)
            DrawText(Msg, mobjForm.ClientRectangle)

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Private Sub RenderCircle(ByVal Color As Color, ByVal Pos As Vector3)
        ' setup translation matrix for position
        Dim M As Matrix = Matrix.Identity
        M.Multiply(Matrix.Translation(Pos))
        SetWorldMatrix(M)

        DrawRectangle(Pos.X - 10, Pos.Y - 10, Pos.X + 10, Pos.Y + 10, Color)
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        RemoveHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        ' restore font formatting
        SetFontFormatting(Left Or Top Or NoClip)
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        Rotation = 0
        mobjPosition = New Vector3(mobjForm.ClientSize.Width \ 2, mobjForm.ClientSize.Width \ 2, 0)
        mobjAxis = Vector3.Add(mobjPosition, New Vector3(25, 25, 0))
        mobjForm.Text = "Rotate Around Axis Example"
        AddHandler mobjForm.MouseMove, AddressOf Form_MouseMove
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Escape
                mobjform.Close()
        End Select
    End Sub

    Private Sub Form_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        Select Case e.Button
            Case MouseButtons.Left
                mobjPosition = New Vector3(e.X, e.Y, 0)

            Case MouseButtons.Right
                mobjAxis = New Vector3(e.X, e.Y, 0)

            Case MouseButtons.Middle
                Rotation = e.X
                If Rotation < 0 Then Rotation = 0
                If Rotation > 359 Then Rotation = 359
        End Select

        mobjRAA = MathHelpers.RotateAroundAxis(mobjAxis, mobjPosition, New Vector3(0, 0, DegreeToRadian(Rotation)))
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates code that uses the GenerateEllipsePoints and RotateAroundAxis methods."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "RotateAroundAxis.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Rotate Around Axis"
    End Function
End Class