'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 17, 2004
'=============================================

' We import this name space so we can call MilliToTicks

Imports Microsoft.DirectX.Direct3D.Geometry

Public Class TheDemo
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample


    Private mintCurrent As Integer = 0
    Private mobjTimer As HiResolutionTimer
    Private TheTime As Long
    Private ONEMILLI As Long = 0
    Private CurrentScene As WhatScene = WhatScene.LoadingScreen
    Private Sprite As New Sprite2D()

    Private Enum WhatScene
        LoadingScreen = 0
        LogoIntro = 1
        TunnelScene = 2
    End Enum

    Protected Friend Overrides Sub DoCleanUp()
        Sprite = Nothing
        mobjTimer = Nothing
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        RemoveAllAnimations()
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        mobjForm.Text = "'The Demo' Example"
        CurrentScene = WhatScene.LoadingScreen

        AddTexture("Logo", LoadResourceImage("CBX.png"))
        ' AddTexture("Back", LoadResourceImage("Back.png"))
        ' AddTexture("Noise", LoadResourceImage("Noise.png"))

        AddMaterial("White", Color.White, Color.White)
      
        EnableLighting(False)
        SetCullMode(Direct3D.Cull.None)

        mintCurrent = 0

        mobjTimer = New HiResolutionTimer()
        ONEMILLI = mobjTimer.GetTimeInfo(TimeInformation.Frequency) \ 1000

        ' setup scene(s)
        AddCamera("Main", New Vector3(0, 0, -100), New Vector3(), New Vector3(0, 1, 0), Math.PI / 2, 1, 100000, True)
        SetupTheDemoExample(ONEMILLI, mobjForm)


        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        Dim R As RectangleF

        DoInit()

        While mobjForm.Created
            If GraphicsDeviceIsLost() Then Exit While ' stop the demo
            mobjTimer.CaptureTime()

            BeginScene()

            TheTime = mobjTimer.GetTimeInfo(TimeInformation.SystemTime)

            Select Case CurrentScene
                Case WhatScene.LoadingScreen
                    RenderLoadingScreen()

                Case WhatScene.LogoIntro
                    RenderLogoIntro()

                Case WhatScene.TunnelScene
                    RenderTunnelScene()

            End Select

            EndScene()
            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Private Sub RenderTunnelScene()
        ApplyCamera("Main")
        'SetFillMode(FillMode.WireFrame)
        ApplyMaterial("White")
        DrawVertexBuffer("Cylinder")
    End Sub

    Private Sub RenderLoadingScreen()
        Static StartTime As Long

        If StartTime < mobjTimer.GetTimeInfo(TimeInformation.StartTime) Then StartTime = mobjTimer.GetTimeInfo(TimeInformation.StartTime)
        If mobjTimer.GetTimeInfo(TimeInformation.SystemTime) > StartTime + ONEMILLI * 1000 Then CurrentScene = WhatScene.LogoIntro
        DrawText("Loading...", (GetCurrentViewport.Viewport.Width \ 2) - 64, GetCurrentViewport.Viewport.Height - 64)
    End Sub

    Private Sub RenderLogoIntro()
        Dim Values(2) As Single
        Static Started As Boolean = False

        If Not Started Then
            RestartAnimation("LogoFadeIn", TheTime)
            Started = True
        End If
        Dim DonePlaying As Boolean = False
        If CheckIfAllTracksDonePlaying("LogoFadeIn", DonePlaying) Then
            If DonePlaying Then
                CurrentScene = WhatScene.TunnelScene
                Started = False
                Exit Sub
            End If
        End If


        GetTrackValue("LogoFadeIn", "Alpha", TheTime, Values(0))
        GetTrackValue("LogoFadeIn", "PositionX", TheTime, Values(2))
        GetTrackValue("LogoFadeIn", "Rotation", TheTime, Values(1))

        Dim S As Size
        GetTextureSize("Logo", S)

        BeginSpriteRender()
        DrawSprite("Logo", New Rectangle(New Point(), S), Values(2), 0, S.Width / 2.0F, S.Height / 2.0F, Values(1), Color.FromArgb(CInt(Values(0)), 255, 255, 255))
        EndSpriteRender()

        'Sprite.Color = Color.FromArgb(CInt(Values(4)), 255, 255, 255)
        'Sprite.Scale = New SizeF(3, 2)
        'GetTextureSize("Noise", S)
        'Sprite.Rectangle = New Rectangle(New Point(), S)
        'Sprite.Texture = "Noise"
        'Sprite.Visible = True

        'DrawSprite(Sprite)

    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates numerous features of DX9Tools in one demo!"
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "TheDemo.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "The Demo"
    End Function
End Class
