'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: May 17, 2004
'=============================================

Public Class TimeControl
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Private TCtrl As TimeController

    Protected Friend Overrides Sub DoCleanUp()
        TCtrl = Nothing
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        RemoveAnimation("AnimatedStrip")
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        mobjForm.Text = "Animated Strip Example"

        AddTexture("Sprite", LoadResourceImage("Turkey.png"))

        EnableLighting(False)
        SetCullMode(Direct3D.Cull.None)

        AddAnimation("AnimatedStrip")
        AddTrack("AnimatedStrip", New String() {"Left", "Top", "Width", "Height"})
        ' default playstyle is linear so we need to specify keylock otherwise animation will not be frame based
        SetTrackPlayStyle("AnimatedStrip", New String() {"Left", "Top", "Width", "Height"}, _
                          TrackPlayStyle.Looping Or TrackPlayStyle.KeyLock)

        Dim Times() As Long
        Times = BuildTimeKeys(0, 12, TimeSpan.TicksPerSecond \ 30)  ' 30 fps
        AddTrackKey("AnimatedStrip", "Left", Times, New Single() {0, 84, 168, 252, 336, 420, 0, 84, 168, 252, 336, 420})
        AddTrackKey("AnimatedStrip", "Top", Times, New Single() {0, 0, 0, 0, 0, 0, 105, 105, 105, 105, 105, 105})
        AddTrackKey("AnimatedStrip", "Width", Times, New Single() {84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84, 84})
        AddTrackKey("AnimatedStrip", "Height", Times, New Single() {105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105})

        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        TCtrl = New TimeController()
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Escape
                mobjForm.Close()

            Case Keys.Add
                TCtrl.TimeStep += 0.01F

            Case Keys.Subtract
                TCtrl.TimeStep -= 0.01F
                If TCtrl.TimeStep <= 0 Then TCtrl.TimeStep = 0

            Case Keys.Space
                RestartAnimation("AnimatedStrip", TCtrl.CurrentTime)

            Case Keys.O
                SetTrackPlayStyle("AnimatedStrip", New String() {"Left", "Top", "Width", "Height"}, TrackPlayStyle.Once Or TrackPlayStyle.KeyLock)

            Case Keys.L
                SetTrackPlayStyle("AnimatedStrip", New String() {"Left", "Top", "Width", "Height"}, TrackPlayStyle.Looping Or TrackPlayStyle.KeyLock)

        End Select

    End Sub

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        Dim R As RectangleF

        DoInit()

        Dim Msg As String
        Msg = vbCrLf & "Press Escape or click to exit" & vbCrLf
        Msg &= "Spacebar resets animation to begining." & vbCrLf
        Msg &= "O Key sets play style to play once" & vbCrLf
        Msg &= "L Key sets play style to loop" & vbCrLf
        Msg &= "+ Makes time speed up" & vbCrLf
        Msg &= "- Makes time slow down" & vbCrLf

        While mobjForm.Created
            TCtrl.Update(Now.Ticks)

            BeginScene()

            Dim Values() As Single
            GetTrackValue("AnimatedStrip", New String() {"Left", "Top", "Width", "Height"}, _
                          TCtrl.CurrentTime, Values)
            R = New RectangleF(Values(0), Values(1), Values(2), Values(3))

            BeginSpriteRender()
            DrawSprite("Sprite", R, 0, 0)
            EndSpriteRender()

            DrawText("TimeStep: " & TCtrl.TimeStep.ToString & Msg, 10, 120)

            EndScene()
            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates code that how to manipulate time by changing it's speed and still mataining fluid animation."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "AniStrip.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Time Control"
    End Function
End Class
