'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 16, 2004
'=============================================

Imports Microsoft.DirectX.Direct3D.DrawTextFormat
Imports Microsoft.DirectX.Direct3D.Geometry

Public Class TrackAnimation
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample


    Private TCtrl As TimeController
    
    Public Sub Run() Implements DXTTesterExt.IExample.Run

        DoInit()

        ' setup 2D projection matrix
        SetProjectionMatrix(Matrix.OrthoOffCenterLH(0, mobjForm.ClientSize.Width, mobjForm.ClientSize.Height, 0, 0, 1000))

        Dim Msg As String
        Msg = vbCrLf & "+ Makes time speed up" & vbCrLf
        Msg &= "- Makes time slow down" & vbCrLf
        Msg &= "Hold Control key to increase change" & vbCrLf
        While mobjForm.Created
            TCtrl.Update(Now.Ticks)

            BeginScene()

            Dim Values(4) As Single

            GetTrackValue("CBX", "Red", TCtrl.CurrentTime, Values(0))
            GetTrackValue("CBX", "Green", TCtrl.CurrentTime, Values(1))
            GetTrackValue("CBX", "Blue", TCtrl.CurrentTime, Values(2))
            GetTrackValue("CBX", "PositionX", TCtrl.CurrentTime, Values(3))
            GetTrackValue("CBX", "Rotation", TCtrl.CurrentTime, Values(4))

            Dim WorldMatrix As Matrix
            WorldMatrix = Matrix.Identity
            WorldMatrix.Multiply(Matrix.Translation(-200, -200, 0))
            WorldMatrix.Multiply(Matrix.RotationZ(CSng(Math.PI / 180.0F) * Values(4)))
            WorldMatrix.Multiply(Matrix.Translation(Values(3) + 150, 220, 0))
            SetWorldMatrix(WorldMatrix)

            ApplyMaterial(Color.FromArgb(255, CInt(Values(0)), CInt(Values(1)), CInt(Values(2))))
            SetFillMode(Direct3D.FillMode.Solid)
            DrawVertexBuffer("Plane", "CBX")

            ApplyMaterial(Color.White)
            SetFillMode(Direct3D.FillMode.WireFrame)
            DrawVertexBuffer("Plane", NOTEXTURE)


            DrawText("TimeStep: " & TCtrl.TimeStep.ToString &  Msg, 10, 10)

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        TCtrl = Nothing
        RemoveHandler mobjForm.Click, AddressOf Form_Click
        RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        RemoveAllAnimations()
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit(Windowed)

        mobjForm.Text = "Track Animation Example"

       
        AddTexture("CBX", LoadResourceImage("CBX.png"))

        EnableLighting(True)
        GetD3DDevice.RenderState.Ambient = Color.White
        SetTextureTransform(0, Direct3D.TextureTransform.Count2)
        SetCullMode(DirectX.Direct3D.Cull.None)

        ' setup tracks and geometry
        SetupTracks()
        SetupGeo()
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        TCtrl = New TimeController()
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        Select Case e.KeyCode
            Case Keys.Escape
                mobjForm.Close()

            Case Keys.Add
                If e.Control Then
                    TCtrl.TimeStep += 1.0F
                Else
                    TCtrl.TimeStep += 0.01F
                End If

            Case Keys.Subtract
                If e.Control Then
                    TCtrl.TimeStep -= 1.0F
                Else
                    TCtrl.TimeStep -= 0.01F
                End If
                If TCtrl.TimeStep < 0 Then TCtrl.TimeStep = 0
        End Select
    End Sub

    Private Sub SetupTracks()
        AddAnimation("CBX")
        AddTrack("CBX", "Red")
        AddTrack("CBX", "Green")
        AddTrack("CBX", "Blue")

        AddTrackKey("CBX", "Red", TimeSpan.TicksPerMillisecond * 0, 255)
        AddTrackKey("CBX", "Green", TimeSpan.TicksPerMillisecond * 0, 255)
        AddTrackKey("CBX", "Blue", TimeSpan.TicksPerMillisecond * 0, 255)

        AddTrackKey("CBX", "Red", TimeSpan.TicksPerMillisecond * 1000, 255)
        AddTrackKey("CBX", "Green", TimeSpan.TicksPerMillisecond * 1000, 0)
        AddTrackKey("CBX", "Blue", TimeSpan.TicksPerMillisecond * 1000, 0)

        AddTrackKey("CBX", "Red", TimeSpan.TicksPerMillisecond * 2000, 0)
        AddTrackKey("CBX", "Green", TimeSpan.TicksPerMillisecond * 2000, 255)
        AddTrackKey("CBX", "Blue", TimeSpan.TicksPerMillisecond * 2000, 0)

        AddTrackKey("CBX", "Red", TimeSpan.TicksPerMillisecond * 3000, 0)
        AddTrackKey("CBX", "Green", TimeSpan.TicksPerMillisecond * 3000, 0)
        AddTrackKey("CBX", "Blue", TimeSpan.TicksPerMillisecond * 3000, 255)

        AddTrackKey("CBX", "Red", TimeSpan.TicksPerMillisecond * 4000, 255)
        AddTrackKey("CBX", "Green", TimeSpan.TicksPerMillisecond * 4000, 255)
        AddTrackKey("CBX", "Blue", TimeSpan.TicksPerMillisecond * 4000, 255)


        AddTrack("CBX", "PositionX")
        AddTrack("CBX", "Rotation")

        AddTrackKey("CBX", "PositionX", TimeSpan.TicksPerMillisecond * 0, 0)
        AddTrackKey("CBX", "PositionX", TimeSpan.TicksPerMillisecond * 2000, 400)
        AddTrackKey("CBX", "PositionX", TimeSpan.TicksPerMillisecond * 4000, 0)

        AddTrackKey("CBX", "Rotation", TimeSpan.TicksPerMillisecond * 0, 0)
        AddTrackKey("CBX", "Rotation", TimeSpan.TicksPerMillisecond * 1000, 45)
        AddTrackKey("CBX", "Rotation", TimeSpan.TicksPerMillisecond * 2000, 0)
        AddTrackKey("CBX", "Rotation", TimeSpan.TicksPerMillisecond * 3000, -45)
        AddTrackKey("CBX", "Rotation", TimeSpan.TicksPerMillisecond * 4000, 0)
    End Sub

    Private Sub SetupGeo()
        Dim Verts(3) As Direct3D.CustomVertex.PositionTextured

        Verts(0) = New Direct3D.CustomVertex.PositionTextured(New Vector3(0, 0, 0), 0, 0)
        Verts(1) = New Direct3D.CustomVertex.PositionTextured(New Vector3(400, 0, 0), 1, 0)
        Verts(2) = New Direct3D.CustomVertex.PositionTextured(New Vector3(400, 400, 0), 1, 1)
        Verts(3) = New Direct3D.CustomVertex.PositionTextured(New Vector3(0, 400, 0), 0, 1)

        Dim VB As New VertexBuffer()
        ' this does not seem to work for some reason ...
        'VB.Buffer = New Direct3D.VertexBuffer(GetD3DDevice , Verts.Length * Verts(0).StrideSize, 0, Verts(0).Format, DirectX.Direct3D.Pool.Managed)
        ' ... but this line of code does??? 
        VB.Buffer = New Direct3D.VertexBuffer(Verts(0).GetType, Verts.Length, GetD3DDevice, 0, Verts(0).Format, DirectX.Direct3D.Pool.Managed)
        VB.Buffer.SetData(Verts, 0, Direct3D.LockFlags.None)
        VB.PrimitiveCount = GetPrimitiveCount(Direct3D.PrimitiveType.TriangleFan, Verts.Length)
        VB.PrimitiveType = Direct3D.PrimitiveType.TriangleFan
        AddVertexBuffer("Plane", VB)
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates code that uses the animation functionlity provided by DX9Tools."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "TrackAnimation.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Track Animation"
    End Function
End Class