'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: December 23, 2004
'=============================================

Public Class Viewports
    Inherits DXTTesterExt.BaseExample
    Implements DXTTesterExt.IExample

    Public Sub Run() Implements DXTTesterExt.IExample.Run
        DoInit()

        Dim LastTime As Long
        Dim worldMatrix As Matrix = Matrix.Identity
        While mobjForm.Created

            ' rotate every 10 milli secs
            If Now.Ticks > LastTime + TimeSpan.FromMilliseconds(10).Ticks Then
                worldMatrix.Multiply(Matrix.RotationYawPitchRoll(0.01, CSng(Math.Sin(0.01)) / 2, 0))
                SetWorldMatrix(worldMatrix)

                LastTime = Now.Ticks
            End If


            '  RenderToTexture()
            SetCurrentCamera("SkyCam", True)

            BeginScene()   ' will apply default viewport
            DrawMesh("Sky")

            ' update viewport position
            Dim ValueX, ValueY As Single
            Dim TheTime As Long
            TheTime = Now.Ticks
            GetTrackValue("VPPosition", "XPos", TheTime, ValueX)
            GetTrackValue("VPPosition", "YPos", TheTime, ValueY)

            Dim VP As Viewport
            GetViewport("Corner", VP)
            VP.Viewport.X = CInt(ValueX)
            VP.Viewport.Y = CInt(ValueY)
            ' apply viewport 
            ApplyViewport("Corner")

            ClearScene()
            DrawMesh("Sky")

            ApplyViewport(DEFAULTVIEWPORT)
            BeginLineDrawing()
            DrawRectangle(VP.Viewport.X, VP.Viewport.Y, VP.Viewport.X + VP.Viewport.Width, VP.Viewport.Y + VP.Viewport.Height, Color.White)
            EndLineDrawing()

            EndScene()

            Application.DoEvents()
        End While

        DoCleanUp()
    End Sub

    Protected Friend Overrides Sub DoCleanUp()
        If mobjForm Is Nothing = False Then
            RemoveHandler mobjForm.Click, AddressOf Form_Click
            RemoveHandler mobjForm.KeyDown, AddressOf Form_KeyDown
        End If
        MyBase.DoCleanUp()
    End Sub

    Protected Overrides Sub DoInit(Optional ByVal Windowed As Boolean = True)
        MyBase.DoInit()

        ' load sky sphere
        Dim Dev As Direct3D.Device = GetD3DDevice()

        Dim VP As New Viewport()
        VP.Viewport = CreateViewport(0, 0, 256, 256, 0, 10000)
        AddViewport("Corner", VP)


        Dim Mesh As New Mesh()
        Mesh.Mesh = Direct3D.Mesh.FromStream(LoadResource("SkyBox.X"), Direct3D.MeshFlags.Managed, Dev)
        Mesh.Materials.Add("White")
        Mesh.Textures.Add("Back")
        AddMesh("Sky", Mesh)

        AddMaterial("White", Color.White, Color.White, True)
        AddTexture("Back", LoadResourceImage("Back.png"))

        AddCamera("SkyCam", New Vector3(0, 500, -400.0F), New Vector3(0, 0, 0), New Vector3(0, 1, 0), Math.PI / 4, 1, 10000)

        ' get main viewport
        Dim MVP As Viewport
        MVP = GetCurrentViewport()

        ' create viewport animation
        AddAnimation("VPPosition")
        AddTrack("VPPosition", "XPos")
        AddTrack("VPPosition", "YPos")
        AddTrackKey("VPPosition", "XPos", 0, 0)
        AddTrackKey("VPPosition", "YPos", 0, 0)
        AddTrackKey("VPPosition", "XPos", TimeSpan.TicksPerMillisecond * 2000, MVP.Viewport.Width - VP.Viewport.Width - 1)
        AddTrackKey("VPPosition", "YPos", TimeSpan.TicksPerMillisecond * 2000, MVP.Viewport.Y)
        AddTrackKey("VPPosition", "XPos", TimeSpan.TicksPerMillisecond * 4000, MVP.Viewport.Width - VP.Viewport.Width - 1)
        AddTrackKey("VPPosition", "YPos", TimeSpan.TicksPerMillisecond * 4000, MVP.Viewport.Height - VP.Viewport.Height - 1)
        AddTrackKey("VPPosition", "XPos", TimeSpan.TicksPerMillisecond * 6000, MVP.Viewport.X)
        AddTrackKey("VPPosition", "YPos", TimeSpan.TicksPerMillisecond * 6000, MVP.Viewport.Height - VP.Viewport.Height - 1)
        AddTrackKey("VPPosition", "XPos", TimeSpan.TicksPerMillisecond * 8000, MVP.Viewport.X)
        AddTrackKey("VPPosition", "YPos", TimeSpan.TicksPerMillisecond * 8000, MVP.Viewport.Y)

        mobjForm.Text = "Viewports Example"
        AddHandler mobjForm.Click, AddressOf Form_Click
        AddHandler mobjForm.KeyDown, AddressOf Form_KeyDown
    End Sub

    Private Sub Form_Click(ByVal sender As Object, ByVal e As System.EventArgs)
        mobjForm.Close()
    End Sub

    Private Sub Form_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        mobjForm.Close()
    End Sub

    Public Function GetDescription() As String Implements DXTTesterExt.IExample.GetDescription
        Return "Demonstrates how to use viewports."
    End Function

    Public Function GetImage() As System.Drawing.Image Implements DXTTesterExt.IExample.GetImage
        Return New Bitmap(Me.GetType, "Viewports.png")
    End Function

    Public Function GetName() As String Implements DXTTesterExt.IExample.GetName
        Return "Viewports"
    End Function
End Class