Imports Microsoft.DirectX.Direct3D.Geometry

Public Module General

    Public Sub SetupTheDemoExample(ByVal OneMilli As Long, ByVal Frm As Form)
        SetupLogoFadeInScene(OneMilli, Frm)
        SetupTunnelScene(OneMilli)
    End Sub

    Private Sub SetupTunnelScene(ByVal OneMilli As Long)
        Dim VB As New VertexBuffer()
        Dim Verts() As Vector3
        Dim tVerts() As Vector2
        Dim V() As Direct3D.CustomVertex.PositionTextured

        Verts = BuildCylinderStrip(New Vector3(), 50, 10, 200, tVerts)
        ReDim V(Verts.Length - 1)
        Dim idx As Integer
        For idx = 0 To Verts.Length - 1
            V(idx) = New Direct3D.CustomVertex.PositionTextured(Verts(idx), tVerts(idx).X, tVerts(idx).Y)
        Next

        VB.Buffer = New Direct3D.VertexBuffer(GetD3DDevice, V.Length * V(0).StrideSize, 0, V(0).Format, Direct3D.Pool.Managed)
        VB.Buffer.SetData(V, 0, Direct3D.LockFlags.None)
        VB.PrimitiveCount = GetPrimitiveCount(Direct3D.PrimitiveType.TriangleStrip, V.Length)
        VB.PrimitiveType = Direct3D.PrimitiveType.TriangleStrip
        AddVertexBuffer("Cylinder", VB)
    End Sub

    Private Sub SetupLogoFadeInScene(ByVal OneMilli As Long, ByVal Frm As Form)
        AddAnimation("LogoFadeIn")
        AddTrack("LogoFadeIn", "Alpha")
        AddTrack("LogoFadeIn", "PositionX")
        AddTrack("LogoFadeIn", "Rotation")

        SetTrackPlayStyle("LogoFadeIn", "Alpha", TrackPlayStyle.Once)
        SetTrackPlayStyle("LogoFadeIn", "PositionX", TrackPlayStyle.Once)
        SetTrackPlayStyle("LogoFadeIn", "Rotation", TrackPlayStyle.Once)

        Dim Half As SizeF = New SizeF(Frm.ClientSize.Width / 2.0F, Frm.ClientSize.Height / 2.0F)
        AddTrackKey("LogoFadeIn", "Alpha", 0, 0)
        AddTrackKey("LogoFadeIn", "Alpha", OneMilli * 1000, 255)
        AddTrackKey("LogoFadeIn", "Alpha", OneMilli * 2000, 0)

        AddTrackKey("LogoFadeIn", "PositionX", 0, (GetCurrentViewport.Viewport.Width \ 2) - 512)
        AddTrackKey("LogoFadeIn", "PositionX", OneMilli * 1000, (GetCurrentViewport.Viewport.Width \ 2) - 256)
        AddTrackKey("LogoFadeIn", "PositionX", OneMilli * 2000, (GetCurrentViewport.Viewport.Width \ 2))

        AddTrackKey("LogoFadeIn", "Rotation", 0, DegreeToRadian(-45))
        AddTrackKey("LogoFadeIn", "Rotation", OneMilli * 1000, DegreeToRadian(0))
        AddTrackKey("LogoFadeIn", "Rotation", OneMilli * 2000, DegreeToRadian(45))
    End Sub
End Module
