//--------------------------------------------------------------//
// Ocean Effect
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Ocean
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Sky
//--------------------------------------------------------------//
//string Ocean_Effect_Ocean_Sky_Sky_Sphere : ModelData = "C:/Program Files/ATI Research Inc/RenderMonkey 1.5/Examples/Media/Models/Cube.x";

float4x4 view_proj_matrix : ViewProjection;
float4 view_position : ViewPosition;
struct Ocean_Effect_Ocean_Sky_Vertex_Shader_VS_OUTPUT {
   float4 Pos: POSITION;
   float3 pos: TEXCOORD0;
};

Ocean_Effect_Ocean_Sky_Vertex_Shader_VS_OUTPUT Ocean_Effect_Ocean_Sky_Vertex_Shader_main(float4 Pos: POSITION){
   Ocean_Effect_Ocean_Sky_Vertex_Shader_VS_OUTPUT Out;

   // Lock environment to view position
   Out.Pos = mul(view_proj_matrix, float4(Pos.xyz + view_position, 1));
   Out.pos = Pos.yzx;

   return Out;
}






texture skyBox_Tex
<
   string ResourceName = "C:\Program Files\ATI Research Inc\RenderMonkey 1.5\Examples\Media\Textures\Snow.dds";
>;
sampler skyBox = sampler_state
{
   Texture = (skyBox_Tex);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
float4 Ocean_Effect_Ocean_Sky_Pixel_Shader_main(float3 pos: TEXCOORD0) : COLOR {
   return texCUBE(skyBox, pos);
}


//--------------------------------------------------------------//
// Water
//--------------------------------------------------------------//
//string Ocean_Effect_Ocean_Water_Quad : ModelData = "C:/Program Files/ATI Research Inc/RenderMonkey 1.5/Examples/Media/Models/ScreenAlignedQuad.3ds";

float4x4 Ocean_Effect_Ocean_Water_Vertex_Shader_view_proj_matrix : ViewProjection;
float4 scale
<
   string UIName = "scale";
   string UIWidget = "Direction";
   float4 UIMin = ( 0.00, 0.00, 0.00, 0.00 );
   float4 UIMax = ( 0.01, 0.01, 0.01, 0.01 );
   bool   Normalize = false;
> = ( 0.01, 0.01, 0.01, 1.00 );
float4 Ocean_Effect_Ocean_Water_Vertex_Shader_view_position : ViewPosition;
struct Ocean_Effect_Ocean_Water_Vertex_Shader_VS_OUTPUT {
   float4 Pos:    POSITION;
   float3 pos:    TEXCOORD0;
   float3 normal: TEXCOORD1;
   float3 vVec:   TEXCOORD2;
};

Ocean_Effect_Ocean_Water_Vertex_Shader_VS_OUTPUT Ocean_Effect_Ocean_Water_Vertex_Shader_main(float4 Pos: POSITION, float3 normal: NORMAL){
   Ocean_Effect_Ocean_Water_Vertex_Shader_VS_OUTPUT Out;

   // Get some size on the water
   Pos.xy *= 1000;
   Pos.z = -30;

   Out.Pos = mul(Ocean_Effect_Ocean_Water_Vertex_Shader_view_proj_matrix, Pos);
   Out.pos = Pos.xyz * scale;
   Out.vVec = Pos - Ocean_Effect_Ocean_Water_Vertex_Shader_view_position;
   Out.normal = normal;

   return Out;
}


float waveSpeed
<
   string UIName = "waveSpeed";
   string UIWidget = "Numeric";
   float UIMin = 0.00;
   float UIMax = 1.00;
> = 0.34;
float noiseSpeed
<
   string UIName = "noiseSpeed";
   string UIWidget = "Numeric";
   float UIMin = 0.00;
   float UIMax = 1.00;
> = 0.18;
float fadeBias
<
   string UIName = "fadeBias";
   string UIWidget = "Numeric";
   float UIMin = 0.00;
   float UIMax = 1.00;
> = 0.30;
float fadeExp
<
   string UIName = "fadeExp";
   string UIWidget = "Numeric";
   float UIMin = 0.00;
   float UIMax = 8.00;
> = 6.08;
float time_0_X : Time0_X;
float4 waterColor
<
   string UIName = "waterColor";
   string UIWidget = "Color";
> = ( 0.20, 0.35, 0.68, 1.00 );
texture Noise_Tex
<
   string ResourceName = "C:\Program Files\ATI Research Inc\RenderMonkey 1.5\Examples\Media\Textures\NoiseVolume.dds";
>;
sampler Noise = sampler_state
{
   Texture = (Noise_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   ADDRESSW = WRAP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
sampler Ocean_Effect_Ocean_Water_Pixel_Shader_skyBox = sampler_state
{
   Texture = (skyBox_Tex);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
float4 Ocean_Effect_Ocean_Water_Pixel_Shader_main(float3 pos: TEXCOORD0, float3 normal: TEXCOORD1, float3 vVec: TEXCOORD2) : COLOR {
   pos.x += waveSpeed  * time_0_X;
   pos.z += noiseSpeed * time_0_X;

   float4 noisy = tex3D(Noise, pos);

   // Signed noise 
   float3 bump = 2 * noisy - 1;
   bump.xy *= 0.15;
   // Make sure the normal always points upwards
   bump.z = 0.8 * abs(bump.z) + 0.2;
   // Offset the surface normal with the bump
   bump = normalize(normal + bump);

   // Find the reflection vector
   float3 reflVec = reflect(vVec, bump);
   float4 refl = texCUBE(Ocean_Effect_Ocean_Water_Pixel_Shader_skyBox, reflVec.yzx);

   float lrp = 1 - dot(-normalize(vVec), bump);

   // Interpolate between the water color and reflection
   return lerp(waterColor, refl, saturate(fadeBias + pow(lrp, fadeExp)));
}



//--------------------------------------------------------------//
// Technique Section for Ocean Effect
//--------------------------------------------------------------//
technique Ocean
{
   pass Sky
   {
      ZENABLE = FALSE;
      CULLMODE = CW;

      VertexShader = compile vs_1_1 Ocean_Effect_Ocean_Sky_Vertex_Shader_main();
      PixelShader = compile ps_1_1 Ocean_Effect_Ocean_Sky_Pixel_Shader_main();
   }

   pass Water
   {
      ZENABLE = TRUE;
      CULLMODE = NONE;

      VertexShader = compile vs_1_1 Ocean_Effect_Ocean_Water_Vertex_Shader_main();
      PixelShader = compile ps_2_0 Ocean_Effect_Ocean_Water_Pixel_Shader_main();
   }

}

