'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: May 21, 2004
'=============================================
Imports CBX.Libs
Imports Microsoft.DirectX

Public Class XFileLoader

    Public Function ParseXFile(ByVal Filename As String) As Boolean
        Dim F As IO.Stream
        Dim Ret As Boolean

        F = IO.File.OpenRead(Filename)
        Ret = ParseXFile(F)
        F.Close()
        F = Nothing
        Return Ret
    End Function

    Public Function ParseXFile(ByVal Stream As IO.Stream) As Boolean
        Dim FileMan As Direct3D.XFileManager
        Dim File As Direct3D.XFile = Nothing
        Dim FileEnum As Direct3D.XFileObject = Nothing
        Dim Data As Direct3D.XFileData = Nothing

        FileMan = New Direct3D.XFileManager()

        ' Create the .X file object
        File = FileMan.LoadFromStream(Stream)
        If File Is Nothing Then Return False

        ' Use the standard retained mode templates from Direct3D
        FileMan.RegisterDefaultTemplates()

        '// Create a root frame
        '  Dim ParentFrame As New Direct3D.Frame()

        '// Enumerate all top-level templates
        Data = File.GetNextDataObject
        While Not Data Is Nothing

            Select Case Data.Type.ToString ' GetXFileName(Data.Type).ToLower
                Case Direct3D.XFileGuid.Frame.ToString
                    '        ParentFrame = ReadFrameData(Data)

                Case Direct3D.XFileGuid.Mesh.ToString
            End Select

            Data = File.GetNextDataObject
        End While

        ' Return a success
        Return True
    End Function

    Private Function ReadFrameData(ByVal Frame As Direct3D.XFileData) As Direct3D.Frame
        Dim Data As Direct3D.XFileData
        '  Dim F As New Direct3D.Frame()
        '       F.Name = Frame.Name

        Data = Direct3D.XFileData.FromXFileObject(Frame.GetNextObject)
        While Not Data Is Nothing
            '  Console.WriteLine(GetXFileName(Data.Type))
            Select Case Data.Type.ToString ' GetXFileName(Data.Type).ToLower
                Case Direct3D.XFileGuid.FrameTransformMatrix.ToString
                    Dim M As Matrix
                    M = CType(Data.GetData("frameMatrix", GetType(Matrix)), Matrix)
                    '    F.TransformationMatrix = M

                Case Direct3D.XFileGuid.Frame.ToString
                    '              Direct3D.Frame.AppendChild(F, ReadFrameData(Data))

                Case Direct3D.XFileGuid.Mesh.ToString
                    '                  ReadMeshData(F, Data)
            End Select

            Try
                Data = Direct3D.XFileData.FromXFileObject(Frame.GetNextObject)
            Catch ex As Exception
                'ERR: handle error?
            End Try

        End While

        '       Return F
    End Function

    Private Function GetXFileName(ByVal ID As Guid) As String
        Dim XF As Type = GetType(Direct3D.XFileGuid)
        Dim F As Reflection.FieldInfo

        For Each F In XF.GetFields
            If ID.Equals(F.GetValue(F)) Then
                Return F.Name
            End If
        Next

        Return Nothing
    End Function

    Private Structure xFace
        Public Count As Integer
        Public X As Integer
        Public Y As Integer
        Public Z As Integer
    End Structure

    Private Structure xMaterialList
        Public Count As Integer
        Public FaceCount As Integer
    End Structure

    Public Sub ReadMeshData(ByVal Frame As Direct3D.Frame, ByVal FrameData As Direct3D.XFileData)
        Dim Data As Direct3D.XFileData
        Dim VertCount As Integer
        Dim FaceCount As Integer
        Dim NormalCount As Integer
        Dim FaceNormalCount As Integer
        Dim MaterialCount As Integer
        Dim MaterialFaceCount As Integer
        Dim Verts() As Vector3
        ' Dim Verts() As Vector3
        Dim Faces() As xFace
        Dim Normals() As Vector3
        Dim NormalFaces() As xFace


        VertCount = CType(FrameData.GetData("nVertices", GetType(Integer)), Integer)
        FaceCount = CType(FrameData.GetData("nFaces", GetType(Integer)), Integer)
        If VertCount > 0 Then Verts = CType(FrameData.GetDataArray("vertices", GetType(Vector3), VertCount), Vector3())
        If FaceCount > 0 Then Faces = CType(FrameData.GetDataArray("faces", GetType(xFace), FaceCount), xFace())

        '  Frame.MeshContainer = New Direct3D.MeshContainer()
        'dim M as New Direct3D.Mesh (facecount,vertcount,DirectX.Direct3D.MeshFlags.Managed,
        'frame.MeshContainer.MeshData.

        Data = Direct3D.XFileData.FromXFileObject(FrameData.GetNextObject)
        While Not Data Is Nothing
            Console.WriteLine(GetXFileName(Data.Type))
            Select Case Data.Type.ToString ' GetXFileName(Data.Type).ToLower
                Case Direct3D.XFileGuid.MeshNormals.ToString
                    NormalCount = CType(Data.GetData("nNormals", GetType(Integer)), Integer)
                    If NormalCount > 0 Then Normals = CType(Data.GetDataArray("normals", GetType(Vector3), NormalCount), Vector3())
                    FaceNormalCount = CType(Data.GetData("nFaceNormals", GetType(Integer)), Integer)
                    If FaceNormalCount > 0 Then NormalFaces = CType(Data.GetDataArray("meshFaces", GetType(xFace), FaceNormalCount), xFace())

                Case Direct3D.XFileGuid.MeshMaterialList.ToString
                    ' NormalCount = CType(Data.GetData("nNormals", GetType(Integer)), Integer)
                    ' If NormalCount > 0 Then Normals = CType(Data.GetDataArray("normals", GetType(Vector3), NormalCount), Vector3())

                Case Direct3D.XFileGuid.Material.ToString
                    Dim M As Integer
                    M = CType(Data.GetData("faceColor", GetType(Integer)), Integer)

            End Select

            Try
                Data = Direct3D.XFileData.FromXFileObject(FrameData.GetNextObject)
            Catch ex As Exception
                'ERR: handle error?
            End Try

        End While
    End Sub

    'Public Sub ParseXFileData(ByVal Data As Direct3D.XFileData, ByVal ParentFrame As Direct3D.Frame) 'sFrame)
    '    Dim SubObj As Direct3D.XFileObject
    '    Dim SubData As Direct3D.XFileData
    '    Dim DataRef As Direct3D.XFileDataReference
    '    Dim Type As System.Guid
    '    Dim dwSize As Long
    '    Dim Frame, SubFrame As Direct3D.Frame

    '    If Data Is Nothing Then Exit Sub

    '    '// Set sub frame parent
    '    SubFrame = ParentFrame
    '    If Data.Id.Equals(Direct3D.XFileGuid.Frame) Then
    '        '// Create a frame
    '        Frame = New Direct3D.Frame()

    '        '// Store the name
    '        Frame.Name = Data.Name

    '        '// Add to parent frame as sibling
    '        Direct3D.Frame.AppendChild(ParentFrame, Frame)

    '        '// Set sub frame parent
    '        SubFrame = Frame
    '        '   ParseXFileData(Data.GetNextObject, SubFrame)

    '    End If

    '    'ElseIf Data.Type.Equals(Direct3D.XFileGuid.FrameTransformMatrix) Then
    '    '    ParentFrame.TransformationMatrix = CType(Data.GetData("frameMatrix", GetType(Matrix)), Matrix)
    '    '    ParseXFileData(Data, ParentFrame)
    '    'End If

    '    ''// Scan for embedded templates
    '    'SubObj = Data.GetNextObject()
    '    'While Not SubObj Is Nothing

    '    '    '// Process embedded references
    '    '    'MsgBox(pSubObj.Id)
    '    '    'if(SUCCEEDED(pSubObj->QueryInterface(                     \
    '    '    '             IID_IDirectXFileDataReference, (void**)&pDataRef))) {
    '    '    '                pDataRef.Resolv()
    '    '    'If TypeOf pSubObj Is Direct3D.XFileDataReference Then
    '    '    ParseXFileData(SubData, SubFrame)
    '    '    'ReleaseCOM(pSubData)

    '    '    'End If
    '    '    '          ReleaseCOM(pDataRef);
    '    '    '        }

    '    '    '                    '// Process non-referenced embedded templates
    '    '    'If TypeOf pSubObj Is Direct3D.XFileData Then
    '    '    '    ParseXFileData(pSubData, SubFrame)
    '    '    '    'ReleaseCOM(pSubData)

    '    '    'End If '        if(SUCCEEDED(pSubObj->QueryInterface(                     \
    '    '    '            IID_IDirectXFileData, (void**)&pSubData))) {
    '    '    '          ParseXFileData(pSubData, SubFrame);
    '    '    '          ReleaseCOM(pSubData);
    '    '    '        }
    '    '    '        ReleaseCOM(pSubObj);

    '    '    SubObj = Data.GetNextObject()
    '    'End While

    '    ''// Release name buffer
    '    ''delete pName;
    'End Sub
End Class