'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: October 22, 2003
'=============================================


''' <summary>
''' Contains the main graphics oriented methods.
''' </summary>
Public Module Graphics


#Region "  Varibles ... "

    Friend mobjDevice As Direct3D.Device
    Friend mobjPresent As Direct3D.PresentParameters
    Friend mobjLine As Direct3D.Line
    Friend mblnWindowedMode As Boolean = True
    Friend mblnBeginScene As Boolean = False
    Friend mblnBeginSceneRTS As Boolean = False
    Friend mstrRTSName As String = ""
    Friend mblnBeginSprites As Boolean = False
    Friend mblnBeginLines As Boolean = False
    Friend mblnDeviceLost As Boolean = False
    ' basic drawing vars
    Friend mobjDrawColor As Color = Color.White
    ' Friend mobjVerts(3) As Direct3D.CustomVertex.TransformedColored
    ' Friend mintCurrentView As Integer
    Friend mobjSprite As Direct3D.Sprite
    Friend mblnHasBeenInit As Boolean = False
    ' Friend mobjLine As Direct3D.Line
    Friend mobjRenderTargetControl As Control
    Friend mintClearFlags As Direct3D.ClearFlags
    Friend mintZDepth As Integer = 1
    Friend mintStencil As Integer = 0
    Public Const NOTEXTURE As String = "{21DB2A97-2A36-4d45-9A94-3F5C95CDD764}"
    Public Const DEFAULTLINEWIDTH As Single = 1
    Private mobjMinimumBBSize As New Size(1, 1)
    Private mobjDefaultState As Direct3D.StateBlock
#End Region


    Public Function GetMinimumBackBufferSize() As Size
        Return mobjMinimumBBSize
    End Function

    Public Function SetMinimumBackBufferSize(ByVal Value As Size) As Boolean
        If Value.Width < 1 Then Return False
        If Value.Height < 1 Then Return False
        mobjMinimumBBSize = Value
        Return True
    End Function

    Public Function GetClearFlags() As Direct3D.ClearFlags
        Return mintClearFlags
    End Function

    Public Sub SetClearFlags(ByVal Value As Direct3D.ClearFlags)
        mintClearFlags = Value
    End Sub

    Public Function GetZDepthClear() As Integer
        Return mintZDepth
    End Function

    Public Sub SetZDepthClear(ByVal Value As Integer)
        mintZDepth = Value
    End Sub

    Public Function GetStencilClear() As Integer
        Return mintStencil
    End Function

    Public Sub SetStencilClear(ByVal Value As Integer)
        mintStencil = Value
    End Sub

    ''' <summary>
    ''' Retrieves the Direct3D device.
    ''' </summary>
    ''' <returns>Return a Direct3D.Device type.</returns>
    Public Function GetD3DDevice() As Direct3D.Device
        Return mobjDevice
    End Function

    Public Function GetD3DPresentParameters() As Direct3D.PresentParameters
        Return mobjPresent
    End Function

    Public Function GetD3DSprite() As Direct3D.Sprite
        Return mobjSprite
    End Function

    Public Function GetD3DLine() As Direct3D.Line
        Return mobjLine
    End Function


#Region "  Drawing related mothods ... "

    ''' <summary>
    ''' Sets the current drawing color.
    ''' </summary>
    ''' <param name="DrawColor">The color to set as the current drawing color.</param>
    Public Sub SetDrawColor(ByVal DrawColor As Color)
        mobjDrawColor = DrawColor
    End Sub

    ''' <summary>
    ''' Gets the current drawing color.
    ''' </summary>
    ''' <param name="GetDrawColor">The color that will be retrieved.</param>
    Public Function GetDrawColor() As Color
        Return mobjDrawColor
    End Function

    Public Function SetLineWidth(ByVal Value As Single) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjLine.Width = Value
        Return True
    End Function

    Public Function GetLineWidth(ByRef Value As Single) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjLine.Width
        Return True
    End Function

    Public Function SetLinePatternScale(ByVal Value As Single) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjLine.PatternScale = Value
        Return True
    End Function

    Public Function GetLinePatternScale(ByRef Value As Single) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjLine.PatternScale
        Return True
    End Function

    Public Function SetLinePattern(ByVal Value As Integer) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjLine.Pattern = Value
        Return True
    End Function

    Public Function GetLinePattern(ByRef Value As Integer) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjLine.Pattern
        Return True
    End Function
#End Region

    '#Region " DrawLine overloads ... "
    '    'TODO: add more drawline overloads

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the line.</param>
    '    ''' <param name="Location1">Start position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color As Color, ByVal Location1 As PointF, ByVal X2 As Single, ByVal Y2 As Single)
    '        DrawLine(Color.ToArgb, Location1.X, Location1.Y, X2, Y2)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color As Color, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    '        DrawLine(Color.ToArgb, X1, Y1, X2, Y2)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color As Integer, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()
    '        With mobjVerts(0)
    '            .Color = Color
    '            .Rhw = 1
    '            .X = X1
    '            .Y = Y1
    '            .Z = 0
    '        End With

    '        With mobjVerts(1)
    '            .Color = Color
    '            .Rhw = 1
    '            .X = X2
    '            .Y = Y2
    '            .Z = 0
    '        End With

    '        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineList, 1, mobjVerts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color As Color, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
    '        DrawLine(Color.ToArgb, X1, Y1, X2, Y2)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color As Integer, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        With mobjVerts(0)
    '            .Color = Color
    '            .Rhw = 1
    '            .X = X1
    '            .Y = Y1
    '            .Z = 0
    '        End With

    '        With mobjVerts(1)
    '            .Color = Color
    '            .Rhw = 1
    '            .X = X2
    '            .Y = Y2
    '            .Z = 0
    '        End With

    '        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineList, 1, mobjVerts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color1">The start color to use to draw the line.</param>
    '    ''' <param name="Color2">The end color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color1 As Color, ByVal Color2 As Color, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    '        DrawLine(Color1.ToArgb, Color2.ToArgb, X1, Y1, X2, Y2)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color1">The start color to use to draw the line.</param>
    '    ''' <param name="Color2">The end color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color1 As Integer, ByVal Color2 As Integer, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        With mobjVerts(0)
    '            .Color = Color1
    '            .Rhw = 1
    '            .X = X1
    '            .Y = Y1
    '            .Z = 0
    '        End With

    '        With mobjVerts(1)
    '            .Color = Color2
    '            .Rhw = 1
    '            .X = X2
    '            .Y = Y2
    '            .Z = 0
    '        End With

    '        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineList, 1, mobjVerts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color1">The start color to use to draw the line.</param>
    '    ''' <param name="Color2">The end color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color1 As Color, ByVal Color2 As Color, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
    '        DrawLine(Color1.ToArgb, Color2.ToArgb, X1, Y1, X2, Y2)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="Color1">The start color to use to draw the line.</param>
    '    ''' <param name="Color2">The end color to use to draw the line.</param>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Color1 As Integer, ByVal Color2 As Integer, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        With mobjVerts(0)
    '            .Color = Color1
    '            .Rhw = 1
    '            .X = X1
    '            .Y = Y1
    '            .Z = 0
    '        End With

    '        With mobjVerts(1)
    '            .Color = Color2
    '            .Rhw = 1
    '            .X = X2
    '            .Y = Y2
    '            .Z = 0
    '        End With

    '        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineList, 1, mobjVerts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        With mobjVerts(0)
    '            .Color = mobjDrawColor.ToArgb
    '            .Rhw = 1
    '            .X = X1
    '            .Y = Y1
    '            .Z = 0
    '        End With

    '        With mobjVerts(1)
    '            .Color = mobjDrawColor.ToArgb
    '            .Rhw = 1
    '            .X = X2
    '            .Y = Y2
    '            .Z = 0
    '        End With

    '        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(Direct3D.PrimitiveType.LineList, 1, mobjVerts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line on the screen.
    '    ''' </summary>
    '    ''' <param name="X1">Start X position of the line.</param>
    '    ''' <param name="Y1">Start Y position of the line.</param>
    '    ''' <param name="X2">End X position of the line.</param>
    '    ''' <param name="Y2">End Y position of the line.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        With mobjVerts(0)
    '            .Color = mobjDrawColor.ToArgb
    '            .Rhw = 1
    '            .X = X1
    '            .Y = Y1
    '            .Z = 0
    '        End With

    '        With mobjVerts(1)
    '            .Color = mobjDrawColor.ToArgb
    '            .Rhw = 1
    '            .X = X2
    '            .Y = Y2
    '            .Z = 0
    '        End With

    '        mobjGraphics.Device.VertexFormat = mobjVerts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineList, 1, mobjVerts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a line(s) on the screen.
    '    ''' </summary>
    '    ''' <param name="Points">A array of points to use to draw the line(s).</param>
    '    ''' <param name="LineStrip">If True will draw the lines as a linestrip.</param>
    '    ''' <param name="LineCount">Determins how many lines to draw.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="ArgumentNullException">
    '    '''     Will throw a ArgumentNullException Exception if the Points argument is nothing.
    '    ''' </exception>
    '    Public Sub DrawLine(ByVal Points() As Direct3D.CustomVertex.TransformedColored, Optional ByVal LineStrip As Boolean = False, Optional ByVal LineCount As Integer = 1)
    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        If Points Is Nothing Then Throw New ArgumentNullException("Points")
    '        mobjGraphics.Device.VertexFormat = Points(0).Format
    '        If LineStrip Then
    '            mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineStrip, LineCount, Points)
    '        Else
    '            mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.LineList, LineCount, Points)
    '        End If
    '    End Sub
    '#End Region

    '    ''' <summary>
    '    ''' Builds as array of verts representing a rectangle.
    '    ''' </summary>
    '    ''' <param name="TLColor">Top left color of rectangle.</param>
    '    ''' <param name="TRColor">Top right color of rectangle.</param>
    '    ''' <param name="BLColor">Bottom left color of rectangle.</param>
    '    ''' <param name="BRColor">Bottom right color of rectangle.</param>
    '    ''' <param name="X1">Start X position of the rectangle.</param>
    '    ''' <param name="Y1">Start Y position of the rectangle.</param>
    '    ''' <param name="X2">End X position of the rectangle.</param>
    '    ''' <param name="Y2">End Y position of the rectangle.</param>
    '    ''' <returns>Returns an array of verts representing a rectangle.</returns>
    '    Public Function RectangleStripBuilder(ByVal TLColor As Integer, ByVal TRColor As Integer, ByVal BLColor As Integer, _
    '                                          ByVal BRColor As Integer, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, _
    '                                          ByVal Y2 As Single) As Direct3D.CustomVertex.TransformedColored()
    '        Dim Verts(3) As Direct3D.CustomVertex.TransformedColored

    '        Verts(0).Color = TLColor
    '        Verts(0).Rhw = 1
    '        Verts(0).X = X1
    '        Verts(0).Y = Y1
    '        Verts(0).Z = 0

    '        Verts(1).Color = BLColor
    '        Verts(1).Rhw = 1
    '        Verts(1).X = X1
    '        Verts(1).Y = Y2
    '        Verts(1).Z = 0

    '        Verts(2).Color = TRColor
    '        Verts(2).Rhw = 1
    '        Verts(2).X = X2
    '        Verts(2).Y = Y1
    '        Verts(2).Z = 0

    '        Verts(3).Color = BRColor
    '        Verts(3).Rhw = 1
    '        Verts(3).X = X2
    '        Verts(3).Y = Y2
    '        Verts(3).Z = 0

    '        Return Verts
    '    End Function

    '    ''' <summary>
    '    ''' Builds as array of verts representing a rectangle.
    '    ''' </summary>
    '    ''' <param name="TLColor">Top left color of rectangle.</param>
    '    ''' <param name="TRColor">Top right color of rectangle.</param>
    '    ''' <param name="BLColor">Bottom left color of rectangle.</param>
    '    ''' <param name="BRColor">Bottom right color of rectangle.</param>
    '    ''' <param name="X1">Start X position of the rectangle.</param>
    '    ''' <param name="Y1">Start Y position of the rectangle.</param>
    '    ''' <param name="X2">End X position of the rectangle.</param>
    '    ''' <param name="Y2">End Y position of the rectangle.</param>
    '    ''' <returns>Returns an array of verts representing a rectangle.</returns>
    '    Public Function RectangleBuilder(ByVal TLColor As Integer, ByVal TRColor As Integer, ByVal BLColor As Integer, _
    '                                     ByVal BRColor As Integer, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, _
    '                                     ByVal Y2 As Single) As Direct3D.CustomVertex.TransformedColored()
    '        Dim Verts(4) As Direct3D.CustomVertex.TransformedColored

    '        Verts(0).Color = TLColor
    '        Verts(0).Rhw = 1
    '        Verts(0).X = X1
    '        Verts(0).Y = Y1
    '        Verts(0).Z = 0

    '        Verts(1).Color = BLColor
    '        Verts(1).Rhw = 1
    '        Verts(1).X = X1
    '        Verts(1).Y = Y2
    '        Verts(1).Z = 0

    '        Verts(2).Color = TRColor
    '        Verts(2).Rhw = 1
    '        Verts(2).X = X2
    '        Verts(2).Y = Y1
    '        Verts(2).Z = 0

    '        Verts(3).Color = BRColor
    '        Verts(3).Rhw = 1
    '        Verts(3).X = X2
    '        Verts(3).Y = Y2
    '        Verts(3).Z = 0

    '        Verts(4) = Verts(0)

    '        Return Verts
    '    End Function

    '#Region " DrawRectangle overloads ... "
    '    ''' <summary>
    '    ''' Draws a rectangle on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the rectangle.</param>
    '    ''' <param name="X1">Start X position of the rectangle.</param>
    '    ''' <param name="Y1">Start Y position of the rectangle.</param>
    '    ''' <param name="X2">End X position of the rectangle.</param>
    '    ''' <param name="Y2">End Y position of the rectangle.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawRectangle(ByVal Color As Color, ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single)
    '        Dim Verts() As Direct3D.CustomVertex.TransformedColored

    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        Verts = RectangleBuilder(Color.ToArgb, Color.ToArgb, Color.ToArgb, Color.ToArgb, X1, Y1, X2, Y2)
    '        mobjGraphics.Device.VertexFormat = Verts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.TriangleStrip, 2, Verts)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws a rectangle on the screen.
    '    ''' </summary>
    '    ''' <param name="Color">The color to use to draw the rectangle.</param>
    '    ''' <param name="X1">Start X position of the rectangle.</param>
    '    ''' <param name="Y1">Start Y position of the rectangle.</param>
    '    ''' <param name="X2">End X position of the rectangle.</param>
    '    ''' <param name="Y2">End Y position of the rectangle.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    Public Sub DrawRectangle(ByVal Color As Color, ByVal X1 As Integer, ByVal Y1 As Integer, ByVal X2 As Integer, ByVal Y2 As Integer)
    '        Dim Verts() As Direct3D.CustomVertex.TransformedColored

    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()

    '        Verts = RectangleBuilder(Color.ToArgb, Color.ToArgb, Color.ToArgb, Color.ToArgb, X1, Y1, X2, Y2)
    '        mobjGraphics.Device.VertexFormat = Verts(0).Format
    '        mobjGraphics.Device.DrawUserPrimitives(DirectX.Direct3D.PrimitiveType.TriangleStrip, 2, Verts)
    '    End Sub
    '#End Region

    ''' <summary>
    ''' Shuts down the graphics system.
    ''' </summary>
    Public Sub ShutdownGraphics(Optional ByVal DisposeDevice As Boolean = True)
        '  Log("Graphics-ShutdownGraphics Started")
        Try
            If mblnHasBeenInit = False Then Exit Try

            RemoveAllFonts(True)
            RemoveAllMeshes(True)
            RemoveAllTextures(True)
            RemoveAllVertexBuffers(True)

            mobjPresent = Nothing
            mobjLine.Dispose()
            mobjLine = Nothing
            mobjSprite.Dispose()
            mobjSprite = Nothing
            RemoveHandler mobjDevice.DeviceResizing, AddressOf MinimumSizeCheck
            mobjDefaultState.Dispose()
            mobjDefaultState = Nothing
            If DisposeDevice Then mobjDevice.Dispose()
            mobjDevice = Nothing
            mobjRenderTargetControl = Nothing

        Catch
            'ERR handle error
        End Try
        mblnHasBeenInit = False
        '   Log("Graphics-ShutdownGraphics Completed")
    End Sub

    Public Function SetCullMode(ByVal Value As Direct3D.Cull) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.RenderState.CullMode = Value
        Return True
    End Function

    Public Function GetCullMode(ByRef Value As Direct3D.Cull) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.RenderState.CullMode
        Return True
    End Function

    Public Function SetFillMode(ByVal Value As Direct3D.FillMode) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.RenderState.FillMode = Value
        Return True
    End Function

    Public Function GetFillMode(ByRef Value As Direct3D.FillMode) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.RenderState.FillMode
        Return True
    End Function

    Private Sub MinimumSizeCheck(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        If mobjRenderTargetControl.ClientSize.Width < mobjMinimumBBSize.Width Then e.Cancel = True
        If mobjRenderTargetControl.ClientSize.Height < mobjMinimumBBSize.Height Then e.Cancel = True
        If e.Cancel = False Then
            Dim V As Viewport
            V = DirectCast(mobjViewports(DEFAULTVIEWPORT), Viewport)
            V.Viewport.Width = mobjRenderTargetControl.ClientSize.Width
            V.Viewport.Height = mobjRenderTargetControl.ClientSize.Height
        End If
    End Sub

    Public Function RestoreDefaultGraphicsState() As Boolean
        Try
            mobjDefaultState.Apply()
        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

    Public Function InitGraphics(ByVal Target As Control, ByVal Device As Direct3D.Device, ByVal Present As Direct3D.PresentParameters) As Boolean
        '  Log("Graphics-InitGraphics Started")

        If mblnHasBeenInit Then Return False
        If Target Is Nothing Then Return False
        If Device Is Nothing Then Return False
        If Present Is Nothing Then Return False

        mobjDevice = Device
        mobjRenderTargetControl = Target
        mobjPresent = Present
        DoInit()

        '  Log("Graphics-InitGraphics Completed")
        Return True
    End Function

    Public Function InitGraphics(ByVal Target As Control, ByVal Windowed As Boolean, Optional ByVal Width As Integer = 640, Optional ByVal Height As Integer = 480, _
                                 Optional ByVal Format As Direct3D.Format = Direct3D.Format.X8R8G8B8, Optional ByVal Depth As Direct3D.DepthFormat = Direct3D.DepthFormat.D16) As Boolean
        '   Log("Graphics-InitGraphics Started")
        If mblnHasBeenInit Then Return False
        If Target Is Nothing Then Return False

        ' Set our presentation parameters
        mobjPresent = Nothing
        mobjPresent = New Direct3D.PresentParameters()

        mobjPresent.Windowed = Windowed
        mobjPresent.AutoDepthStencilFormat = Depth
        mobjPresent.EnableAutoDepthStencil = True
        mobjPresent.SwapEffect = Direct3D.SwapEffect.Discard
        mobjPresent.PresentationInterval = Direct3D.PresentInterval.Immediate
        If Windowed = False Then
            mobjPresent.BackBufferWidth = Width
            mobjPresent.BackBufferHeight = Height
            mobjPresent.BackBufferFormat = Format
            ' mobjPresent.DeviceWindow = Target
        End If

        ' Store the default adapter
        Dim adapterOrdinal As Integer = Direct3D.Manager.Adapters.Default.Adapter
        Dim flags As Direct3D.CreateFlags = Direct3D.CreateFlags.SoftwareVertexProcessing

        ' Check to see if we can use a pure hardware device
        Dim caps As Direct3D.Caps = Direct3D.Manager.GetDeviceCaps(adapterOrdinal, Direct3D.DeviceType.Hardware)

        'Dim Ret As Integer
        'If Direct3D.Manager.CheckDepthStencilMatch(adapterOrdinal, Direct3D.DeviceType.Hardware, Format, Format, Depth, Ret) Then
        'Else

        'End If

        ' Do we support hardware vertex processing?
        If caps.DeviceCaps.SupportsHardwareTransformAndLight = True Then
            ' Replace the software vertex processing
            flags = Direct3D.CreateFlags.HardwareVertexProcessing
        End If

        ' Do we support a pure device?
        If caps.DeviceCaps.SupportsPureDevice = True Then
            flags = flags Or Direct3D.CreateFlags.PureDevice
        End If

        ' Create our device
        If mobjDevice Is Nothing = False Then mobjDevice.Dispose()
        mobjDevice = Nothing
        Try
            mobjDevice = New Direct3D.Device(adapterOrdinal, Direct3D.DeviceType.Hardware, Target, flags, mobjPresent)
        Catch ex As Exception
            Return False
        End Try

        mobjRenderTargetControl = Target
        DoInit()

        ' Log("Graphics-InitGraphics Completed")
        Return True
    End Function

    Public Function IsDepthFormatOK(ByVal depthFmt As Direct3D.DepthFormat, ByVal adapterFmt As Direct3D.Format, ByVal backbufferFmt As Direct3D.Format, ByRef result As Integer) As Boolean
        Dim ai As Direct3D.AdapterInformation = Direct3D.Manager.Adapters.Default

        ' Verify that the depth format exists
        If Direct3D.Manager.CheckDeviceFormat(ai.Adapter, Direct3D.DeviceType.Hardware, adapterFmt, Direct3D.Usage.DepthStencil, Direct3D.ResourceType.Surface, depthFmt, result) Then
            ' Verify that the depth format is compatible
            If Direct3D.Manager.CheckDepthStencilMatch(ai.Adapter, Direct3D.DeviceType.Hardware, adapterFmt, backbufferFmt, depthFmt, result) Then
                Return True    ' if both calls succeed
            End If
        End If

        Return False   ' if either call fails.  NOTE: HRESULT passed back in result
    End Function

    Private Sub DoInit()
        AddHandler mobjDevice.DeviceResizing, AddressOf MinimumSizeCheck
        mobjDefaultState = New Direct3D.StateBlock(mobjDevice, Direct3D.StateBlockType.All)
        mobjDefaultState.Capture()

        If mobjLine Is Nothing = False Then mobjLine.Dispose()
        mobjLine = Nothing
        mobjLine = New Direct3D.Line(mobjDevice)
        If mobjSprite Is Nothing = False Then mobjSprite.Dispose()
        mobjSprite = Nothing
        mobjSprite = New Direct3D.Sprite(mobjDevice)
        mintClearFlags = Direct3D.ClearFlags.Target Or Direct3D.ClearFlags.ZBuffer
        mobjDrawColor = Color.White

        If mobjViewports.ContainsKey(DEFAULTVIEWPORT) = False Then
            Dim VP As New Viewport()
            VP.BackgroundColor = Color.Black
            VP.Viewport = mobjDevice.Viewport
            VP.mstrName = DEFAULTVIEWPORT
            '  VP.mobjVPCollectionReference = mobjViewports
            mobjViewports.Add(DEFAULTVIEWPORT, VP)
            mstrCurrentViewport = DEFAULTVIEWPORT
        End If
        If mobjFonts.ContainsKey(DEFAULTFONT) = False Then
            Dim Fnt As New Font()

            Fnt.D3DFont = New Direct3D.Font(mobjDevice, New Drawing.Font(FontFamily.GenericSansSerif, 12))
            Fnt.mstrName = DEFAULTFONT
            mobjFonts.Add(DEFAULTFONT, Fnt)
            mstrCurrentFont = DEFAULTFONT
        End If
        mblnHasBeenInit = True
        mblnDeviceLost = False
        mblnBeginScene = False
        mblnBeginSprites = False
    End Sub
#Region " Presentation related methods ... "

    ''' <summary>
    ''' Clears the scene.
    ''' </summary>
    ''' <param name="Color">The color to use to clear the scene.</param>
    ''' <param name="ZDepth">New z value that this method stores in the depth buffer. This parameter can be in the range of 0.0 through 1.0 (for z-based or w-based depth buffers). A value of 0.0 represents the nearest distance to the viewer; a value of 1.0 represents the farthest distance.</param>
    ''' <param name="Stencil">Integer value to store in each stencil-buffer entry. This parameter can be in the range of 0 through 2n-1, where n is the bit depth of the stencil buffer.</param>
    Public Function ClearScene(Optional ByVal ZDepth As Single = 1, Optional ByVal Stencil As Integer = 0) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.Clear(mintClearFlags, DirectCast(mobjViewports(mstrCurrentViewport), Viewport).BackgroundColor, ZDepth, Stencil)
        Return True
    End Function

    ''' <summary>
    ''' Begins the scene.
    ''' </summary>
    ''' <param name="DoClear">If True will clear the scene first.</param>
    Public Function BeginScene(ByVal RTSName As String, ByVal TextureName As String, Optional ByVal Level As Integer = 0, _
                               Optional ByVal DoClear As Boolean = True, Optional ByVal ClearTextures As Boolean = False, _
                               Optional ByVal Viewport As String = CURRENTVIEWPORT) As Boolean
        If mblnBeginScene Or mblnBeginSceneRTS Then Return False
        If mblnHasBeenInit = False Then Return False
        If Level < 0 Then Return False
        '        If mobjRTS.ContainsKey(RTSName) = False Then Return False
        '        If mobjRTS.ContainsKey(TextureName) = False Then Return False

        Dim RTS As Direct3D.RenderToSurface
        If GetRenderToSurface(RTSName, RTS) = False Then Return False

        Dim Tex As Direct3D.Texture
        If GetTexture(TextureName, Tex) = False Then Return False

        Dim Surf As Direct3D.Surface
        Surf = Tex.GetSurfaceLevel(Level)

        ' check if texture is a render to texture
        If CBool(Surf.Description.Usage And Direct3D.Usage.RenderTarget) = False Then
            SpecifyError("DXTools.Graphics.BeginScene", "Texture is not a RenderTarget!")
            Return False
        End If

        Dim VP As Direct3D.Viewport

        If Viewport = CURRENTVIEWPORT Then
            'mobjDevice.Viewport = VP
            VP = DirectCast(mobjViewports(mstrCurrentViewport), Viewport).Viewport
        Else
            If mobjViewports.ContainsKey(Viewport) = False Then Return False
            VP = DirectCast(mobjViewports(Viewport), Viewport).Viewport

            'If ApplyViewport(Viewport) = False Then Return False
        End If
        If DoClear Then ClearScene()
        ' begin rendering
        RTS.BeginScene(Surf, VP)

        ApplyCamera()

        If mobjMaterials.ContainsKey(mstrCurrentMaterial) Then
            mobjDevice.Material = DirectCast(mobjMaterials(mstrCurrentMaterial), Direct3D.Material) '.Material
        End If

        If ClearTextures Then
            Dim idx As Integer
            For idx = 0 To mobjDevice.DeviceCaps.MaxTextureBlendStages - 1
                mobjDevice.SetTexture(idx, Nothing)
            Next
        End If
        mblnBeginScene = True
        mblnBeginSceneRTS = True
        mstrRTSName = RTSName
        Return True
    End Function

    ''' <summary>
    ''' Begins the scene.
    ''' </summary>
    ''' <param name="DoClear">If True will clear the scene first.</param>
    Public Function BeginScene(Optional ByVal DoClear As Boolean = True, Optional ByVal ClearTextures As Boolean = False, _
                               Optional ByVal Viewport As String = CURRENTVIEWPORT) As Boolean
        If mblnBeginScene Or mblnBeginSceneRTS Then Return False
        If mblnHasBeenInit = False Then Return False


        If Viewport = CURRENTVIEWPORT Then
            mobjDevice.Viewport = DirectCast(mobjViewports(mstrCurrentViewport), Viewport).Viewport
        Else
            If ApplyViewport(Viewport) = False Then Return False
        End If
        If DoClear Then ClearScene()
        mobjDevice.BeginScene()

        ApplyCamera()

        If mobjMaterials.ContainsKey(mstrCurrentMaterial) Then
            mobjDevice.Material = DirectCast(mobjMaterials(mstrCurrentMaterial), Direct3D.Material) '.Material
        End If

        If ClearTextures Then
            Dim idx As Integer
            For idx = 0 To mobjDevice.DeviceCaps.MaxTextureBlendStages - 1
                mobjDevice.SetTexture(idx, Nothing)
            Next
        End If
        mblnBeginScene = True
        Return True
    End Function

    ''' <summary>
    ''' Ends a scene that was started by calling the BeginScene method.
    ''' </summary>
    ''' <param name="DoPresent">If True the scene will be presented.</param>
    Public Function EndScene(Optional ByVal DoPresent As Boolean = True, _
                        Optional ByVal Filter As Direct3D.Filter = Direct3D.Filter.None) As Boolean
        If mblnBeginScene = False Then Exit Function
        If mblnBeginLines Then mobjLine.End()
        If mblnBeginSprites Then mobjSprite.End()

        If mblnBeginSceneRTS Then
            If mobjRTS.ContainsKey(mstrRTSName) Then
                Dim RTS As Direct3D.RenderToSurface
                RTS = DirectCast(mobjRTS(mstrRTSName), Direct3D.RenderToSurface)
                RTS.EndScene(Filter)
            Else
                SpecifyError("DXTools.Graphics.EndScene", "(" & mstrRTSName & ") RenderToSurface no longer exists within the collection!")
                Return False
            End If
        Else
            mobjDevice.EndScene()
        End If

        mblnBeginSceneRTS = False
        mblnBeginScene = False
        mblnBeginSprites = False
        mblnBeginLines = False
        If DoPresent Then PresentScene()
        Return True
    End Function


    ''' <summary>
    ''' Presents the scene.
    ''' </summary>
    Public Function PresentScene() As Boolean
        If mblnHasBeenInit = False Then Return False
        If mblnDeviceLost Then Return False
        Try
            mobjDevice.Present()
        Catch ex As Exception
            mblnDeviceLost = True
            Return False
        End Try
        mblnDeviceLost = False
        Return True
    End Function

    Public Function GraphicsDeviceIsLost() As Boolean
        If mblnHasBeenInit Then Return mblnDeviceLost Else Return True
    End Function

    Public Function ResetGraphics() As Boolean
        If mblnHasBeenInit And mblnDeviceLost Then
            Try
                Try
                    mobjDevice.TestCooperativeLevel()
                Catch ex As Exception
                    Return False
                End Try

                Dim Ret As Integer
                If mobjDevice.CheckCooperativeLevel(Ret) = False Then
                    If Ret = Direct3D.ResultCode.DeviceLost Then
                        Return False
                    End If
                Else
                    Return False
                End If

            Catch ex As Exception
                Return False
            End Try
            Try
                mobjDevice.Reset(mobjPresent)
            Catch ex As Exception
                Return False
            End Try
            mblnDeviceLost = False
        End If

        Return True
    End Function

    ''' <summary>
    ''' Determins if the scene has begun.
    ''' </summary>
    ''' <returns>Return True if the scene has begun.</returns>
    Public Function BeginSceneHasBeenCalled() As Boolean
        Return mblnBeginScene
    End Function

#End Region

    '#Region " DrawText overloads ... "
    '    ''' <summary>
    '    ''' Draws text on the screen.
    '    ''' </summary>
    '    ''' <param name="Text">The text to be drawn.</param>
    '    ''' <param name="Bounds">A Rectangle structure that contains the rectangle, in logical coordinates, in which the text is being formatted.</param>
    '    ''' <param name="Format">Method of formatting the text can be any combination of values from the DrawTextFormat enumeration.</param>
    '    ''' <param name="Color">Color of the text.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="IndexOutOfRangeException">
    '    '''     Will throw a standard IndexOutOfRangeException Exception if the index is out of range.
    '    ''' </exception>
    '    Public Sub DrawText(ByVal Text As String, ByVal Bounds As Rectangle, ByVal Format As Direct3D.DrawTextFormat, ByVal Color As Color)
    '        DrawText(mobjDXE.mintCurrentFont, Text, Bounds, Format, Color.ToArgb)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws text on the screen.
    '    ''' </summary>
    '    ''' <param name="Text">The text to be drawn.</param>
    '    ''' <param name="Bounds">A Rectangle structure that contains the rectangle, in logical coordinates, in which the text is being formatted.</param>
    '    ''' <param name="Format">Method of formatting the text can be any combination of values from the DrawTextFormat enumeration.</param>
    '    ''' <param name="Color">Color of the text.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="IndexOutOfRangeException">
    '    '''     Will throw a standard IndexOutOfRangeException Exception if the index is out of range.
    '    ''' </exception>
    '    Public Sub DrawText(ByVal Text As String, ByVal Bounds As Rectangle, ByVal Format As Direct3D.DrawTextFormat, ByVal Color As Integer)
    '        DrawText(mobjDXE.mintCurrentFont, Text, Bounds, Format, Color)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws text on the screen.
    '    ''' </summary>
    '    ''' <param name="FontIndex">The index of the font to use.</param>
    '    ''' <param name="Text">The text to be drawn.</param>
    '    ''' <param name="Bounds">A Rectangle structure that contains the rectangle, in logical coordinates, in which the text is being formatted.</param>
    '    ''' <param name="Format">Method of formatting the text can be any combination of values from the DrawTextFormat enumeration.</param>
    '    ''' <param name="Color">Color of the text.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="IndexOutOfRangeException">
    '    '''     Will throw a standard IndexOutOfRangeException Exception if the index is out of range.
    '    ''' </exception>
    '    Public Sub DrawText(ByVal FontIndex As Integer, ByVal Text As String, ByVal Bounds As Rectangle, ByVal Format As Direct3D.DrawTextFormat, ByVal Color As Color)
    '        DrawText(FontIndex, Text, Bounds, Format, Color.ToArgb)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws text on the screen.
    '    ''' </summary>
    '    ''' <param name="Text">The text to be drawn.</param>
    '    ''' <param name="Bounds">A Rectangle structure that contains the rectangle, in logical coordinates, in which the text is being formatted.</param>
    '    ''' <param name="Format">Method of formatting the text can be any combination of values from the DrawTextFormat enumeration.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="IndexOutOfRangeException">
    '    '''     Will throw a standard IndexOutOfRangeException Exception if the index is out of range.
    '    ''' </exception>
    '    Public Sub DrawText(ByVal Text As String, ByVal Bounds As Rectangle, ByVal Format As Direct3D.DrawTextFormat)
    '        DrawText(mobjDXE.mintCurrentFont, Text, Bounds, Format, mobjDrawColor)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws text on the screen.
    '    ''' </summary>
    '    ''' <param name="FontIndex">The index of the font to use.</param>
    '    ''' <param name="Text">The text to be drawn.</param>
    '    ''' <param name="Bounds">A Rectangle structure that contains the rectangle, in logical coordinates, in which the text is being formatted.</param>
    '    ''' <param name="Format">Method of formatting the text can be any combination of values from the DrawTextFormat enumeration.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="IndexOutOfRangeException">
    '    '''     Will throw a standard IndexOutOfRangeException Exception if the index is out of range.
    '    ''' </exception>
    '    Public Sub DrawText(ByVal FontIndex As Integer, ByVal Text As String, ByVal Bounds As Rectangle, ByVal Format As Direct3D.DrawTextFormat)
    '        DrawText(FontIndex, Text, Bounds, Format, mobjDrawColor)
    '    End Sub

    '    ''' <summary>
    '    ''' Draws text on the screen.
    '    ''' </summary>
    '    ''' <param name="FontIndex">The index of the font to use.</param>
    '    ''' <param name="Text">The text to be drawn.</param>
    '    ''' <param name="Bounds">A Rectangle structure that contains the rectangle, in logical coordinates, in which the text is being formatted.</param>
    '    ''' <param name="Format">Method of formatting the text can be any combination of values from the DrawTextFormat enumeration.</param>
    '    ''' <param name="Color">Color of the text.</param>
    '    ''' <exception cref="GraphicsHaveNotBeenInitException">
    '    '''     Will throw a GraphicsHaveNotBeenInitException Exception if the graphics have not been initilized.
    '    ''' </exception>
    '    ''' <exception cref="IndexOutOfRangeException">
    '    '''     Will throw a standard IndexOutOfRangeException Exception if the index is out of range.
    '    ''' </exception>
    '    Public Sub DrawText(ByVal FontIndex As Integer, ByVal Text As String, ByVal Bounds As Rectangle, ByVal Format As Direct3D.DrawTextFormat, ByVal Color As Integer)
    '        Dim F As DXEliminator.Font

    '        If mobjGraphics Is Nothing Then Throw New GraphicsHaveNotBeenInitException()
    '        If FontIndex < 0 Then Throw New IndexOutOfRangeException()
    '        If FontIndex > mobjDXE.mobjFonts.Count - 1 Then Throw New IndexOutOfRangeException()

    '        F = mobjDXE.mobjFonts(FontIndex)
    '        F.mobjDXFont.DrawText(Nothing, Text, Bounds, Format, Color)
    '        ' F.mobjDXFont.DrawText(Text,  Bounds, Format, Color)
    '    End Sub
    '#End Region

    Public Function GraphicsHaveBeenInitilized() As Boolean
        Return mblnHasBeenInit
    End Function
End Module