'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: Friday, March 18, 2005
'=============================================


Public Module AnimationHelpers
    Public Function BuildTimeKeys(ByVal StartTime As Long, ByVal KeyCount As Integer, ByVal TimeBetweenKeys As Long) As Long()
        Dim Times() As Long
        If KeyCount <= 0 Then Return Nothing
        If TimeBetweenKeys < 0 Then Return Nothing
        ReDim Times(KeyCount - 1)
        Dim idx As Integer
        For idx = 0 To Times.Length - 1
            Times(idx) = StartTime + (idx * TimeBetweenKeys)
        Next
        Return Times
    End Function

    Public Function GetTrackValue(ByVal Animation As String, ByVal Track As String, ByVal CurrentTime As Long, ByRef Value As Single) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            If .mobjTracks.ContainsKey(Track) = False Then Return False
            Dim T As Track
            T = DirectCast(.mobjTracks.Item(Track), Track)
            If T.Count = 0 Then Return False
            Value = GetTrackValue(T, CurrentTime)
        End With

        Return True
    End Function

    Public Function GetTrackValue(ByVal Animation As String, ByVal Tracks() As String, ByVal CurrentTime As Long, ByRef Values() As Single) As Boolean
        If Animation Is Nothing Then Return False
        If mobjAnimations.ContainsKey(Animation) = False Then Return False
        If Tracks Is Nothing Then Return False
        With DirectCast(mobjAnimations(Animation), Animation)
            Dim idx As Integer
            ReDim Values(Tracks.Length - 1)
            For idx = 0 To Tracks.Length - 1
                If .mobjTracks.ContainsKey(Tracks(idx)) = False Then Return False
                Dim T As Track
                T = DirectCast(.mobjTracks.Item(Tracks(idx)), Track)
                If T.Count = 0 Then Return False
                Values(idx) = GetTrackValue(T, CurrentTime)
            Next
        End With

        Return True
    End Function

    'Public Function GetTrackValue(ByVal Animation As String, ByVal Track As String, ByVal CurrentTime As Long, ByRef Value As Single) As Boolean
    '    If Animation Is Nothing Then Return False
    '    If mobjAnimations.ContainsKey(Animation) = False Then Return False
    '    With DirectCast(mobjAnimations(Animation), Animation)
    '        Dim Index As Integer = 0
    '        While Index <= .mobjTracks.Count - 1
    '            If .mobjTracks.Item(Index).Name = Track Then
    '                Value = GetTrackValue(.mobjTracks.Item(Index), CurrentTime)
    '                Return True
    '            End If

    '            Index += 1
    '        End While

    '    End With

    '    Return False
    'End Function

    Friend Function GetTrackValue(ByVal T As Track, ByVal CurrentTime As Long) As Single
        If CurrentTime > T.BaseTime + T.GetNextKey.Time Then T.CurrentKeyIndex += 1


        If T.CurrentKeyIndex > T.Count - 1 Then
            If CBool(T.PlayType And TrackPlayStyle.Once) Then
                T.CurrentKeyIndex = T.Count - 1
                Return T.GetLastKey.Value

            ElseIf CBool(T.PlayType And TrackPlayStyle.Looping) Then
                T.CurrentKeyIndex = 0
                T.BaseTime = CurrentTime
                CurrentTime = CurrentTime - T.GetLastKey.Time ' T.Track(T.Track.Count - 1).Time
            End If
        End If

        If CBool(T.PlayType And TrackPlayStyle.KeyLock) Then Return T.GetCurrentKey.Value

        ' calc ammount of transition
        Dim S As Single

        S = CSng((CurrentTime - (T.BaseTime + T.GetCurrentKey.Time)) / (T.GetNextKey.Time - T.GetCurrentKey.Time))
        If S.IsNaN(S) Then S = 0
        If S < 0 Then S = 0
        If S > 1 Then S = 1

        Return T.GetCurrentKey.Value + ((T.GetNextKey.Value - T.GetCurrentKey.Value) * S)
    End Function

End Module