' Code originally written in VB6. Converted to vb.net by -> Created by: X
' Special thanks to game_maker from which this code is based.
' Original Author: game_maker (from the http://www.vbgamer.com/ fourms)
' Real Name: Yazeed  
' Location: Ryiadh, Saudi Arabia
' HomePage: http://axdteam.com/
'--------------------------------------------------------
    Public Module Collision2D

    '// 2D Collision Detections By : Yazeed - http://axdteam.com (Version 1.0)
    '// Functions :-
    '// 01 - Collision_CircleCircle
    '// 02 - Collision_CircleCircleEx
    '// 03 - Collision_PointCircle
    '// 04 - Collision_PointCircleEx
    '// 05 - Collision_RectRect
    '// 06 - Collision_RectRectEx
    '// 07 - Collision_PointTriangle
    '// 08 - Collision_PointTriangleEx
    '// 09 - Collision_CircleTriangle
    '// 10 - Collision_LineCircle

    Public Function CircleCircle(ByVal Center1X As Single, ByVal Center1Y As Single, ByVal R1 As Single, _
                                 ByVal Center2X As Single, ByVal Center2Y As Single, ByVal R2 As Single, _
                                 Optional ByRef Distance As Single = 0) As Boolean
        ' Dim R As Single

        'Distance = (Center2X - Center1X) * (Center2X - Center1X) + (Center2Y - Center1Y) * (Center2Y - Center1Y)
        Distance = CSng(Math.Sqrt((Math.Abs(Center1X - Center2X) ^ 2) + (Math.Abs(Center1Y - Center2Y) ^ 2)))

        'D = Math.GetSLength(Center1, Center2)
        ' R = R1 + R2
        Return Distance <= (R1 * 2) + (R2 * 2) ' R * R
    End Function

    Public Function CircleCircleEx(ByVal Center1X As Single, ByVal Center1Y As Single, ByVal R1 As Single, _
                                   ByVal Center2X As Single, ByVal Center2Y As Single, ByVal R2 As Single) As Single
        Dim D, R As Single
        D = (Center2X - Center1X) * (Center2X - Center1X) + (Center2Y - Center1Y) * (Center2Y - Center1Y)
        'D = Math.GetLength(Center1, Center2)
        R = R1 + R2
        Return D / R
    End Function

    Public Function PointCircle(ByVal PointX As Single, ByVal PointY As Single, ByVal CenterX As Single, _
                                ByVal CenterY As Single, ByVal R As Single) As Boolean
        Dim D As Single
        ' D = Math.GetSLength(Center, Point)
        D = (PointX - CenterX) * (PointX - CenterX) + (PointY - CenterY) * (PointY - CenterY)
        Return D <= R * R
    End Function

    Public Function PointCircleEx(ByVal PointX As Single, ByVal PointY As Single, ByVal CenterX As Single, _
                                ByVal CenterY As Single, ByVal R As Single) As Single
        Dim D As Single
        D = (PointX - CenterX) * (PointX - CenterX) + (PointY - CenterY) * (PointY - CenterY)
        '  D = Math.GetLength(Center, Point)
        Return D / R
    End Function

    Public Function PointRect(ByVal xRect As Drawing.RectangleF, ByVal X As Single, ByVal Y As Single) As Boolean
        Return X >= xRect.Left And Y >= xRect.Top And X <= xRect.Right And Y <= xRect.Bottom
    End Function

    Public Function PointRect(ByVal Left As Single, ByVal Top As Single, ByVal Right As Single, ByVal Bottom As Single, ByVal X As Single, ByVal Y As Single) As Boolean
        Return X >= Left And Y >= Top And X <= Right And Y <= Bottom
    End Function

    Public Function RectRect(ByRef xRect1 As Drawing.RectangleF, ByRef xRect2 As Drawing.RectangleF) As Boolean
        Return RectRectEx(xRect1, xRect2) = 15
    End Function

    Public Function RectRect(ByRef R1Left As Single, ByVal R1Top As Single, ByVal R1Right As Single, ByVal R1Bottom As Single, _
                             ByVal R2Left As Single, ByVal R2Top As Single, ByVal R2Right As Single, ByVal R2Bottom As Single) As Boolean
        Return RectRectEx(R1Left, R1Top, R1Right, R1Bottom, R2Left, R2Top, R2Right, R2Bottom) = 15
    End Function

    Public Function RectRectEx(ByRef R1Left As Single, ByVal R1Top As Single, ByVal R1Right As Single, ByVal R1Bottom As Single, _
                               ByVal R2Left As Single, ByVal R2Top As Single, ByVal R2Right As Single, ByVal R2Bottom As Single) As Byte

        Dim UpColl, RightColl, LeftColl, DownColl As Byte

        If R2Right >= R1Left Then RightColl = 1
        If R2Left <= R1Right Then LeftColl = 2
        If R2Bottom >= R1Top Then UpColl = 4
        If R2Top <= R1Bottom Then DownColl = 8

        Return RightColl Or LeftColl Or UpColl Or DownColl
    End Function

    Public Function RectRectEx(ByRef R1 As Drawing.RectangleF, ByRef R2 As Drawing.RectangleF) As Byte

        Dim UpColl, RightColl, LeftColl, DownColl As Byte

        With R1

            If R2.Right >= .Left Then RightColl = 1
            If R2.Left <= .Right Then LeftColl = 2
            If R2.Bottom >= .Top Then UpColl = 4
            If R2.Top <= .Bottom Then DownColl = 8

        End With

        Return RightColl Or LeftColl Or UpColl Or DownColl
    End Function

    Public Function PointTriangle(ByRef P As PointF, ByRef A As PointF, ByRef B As PointF, ByRef C As PointF) As Boolean
        Return PointTriangleEx(P, A, B, C) = 7
    End Function

    Public Function PointTriangleEx(ByRef P As PointF, ByRef A As PointF, ByRef B As PointF, ByRef C As PointF) As Byte
        Dim A2, A1, A3 As Byte
        If MathFunctions.SameSide(P, A, B, C) Then A1 = 1
        If MathFunctions.SameSide(P, B, C, A) Then A2 = 2
        If MathFunctions.SameSide(P, C, A, B) Then A3 = 4
        Return A1 Or A2 Or A3
    End Function

    Public Function CircleTriangle(ByRef A As PointF, ByRef B As PointF, ByRef C As PointF, ByRef Center As PointF, ByRef R As Single, ByRef Accuracy As Integer) As Boolean

        Dim X() As Single
        Dim Y() As Single
        Dim Theta As Double
        Dim Tx As Double

        If PointCircle(A.X, A.Y, Center.X, Center.Y, R) Then Return True : Exit Function
        If PointCircle(B.X, B.Y, Center.X, Center.Y, R) Then Return True : Exit Function
        If PointCircle(C.X, C.Y, Center.X, Center.Y, R) Then Return True : Exit Function

        Tx = System.Math.PI * 2 / Accuracy

        Accuracy = Accuracy - 1

        ReDim X(Accuracy)
        ReDim Y(Accuracy)

        Dim I As Integer
        For I = 0 To Accuracy
            Theta = I * Tx
            X(I) = Center.X + Convert.ToSingle(System.Math.Cos(Theta)) * R
            Y(I) = Center.Y + Convert.ToSingle(System.Math.Sin((2 * System.Math.PI) - Theta)) * R
        Next I

        For I = 0 To Accuracy
            If PointTriangle(New PointF(X(I), Y(I)), A, B, C) Then
                CircleTriangle = True
                Exit For
            End If
        Next I

    End Function

    Public Function LineCircle(ByRef P1 As PointF, ByRef P2 As PointF, ByRef C As PointF, ByRef R As Single) As Boolean
        Dim M As Single
        Dim P As PointF

        M = (P2.Y - P1.Y)
        If P2.X = P1.X Then M *= 0 Else M *= 1 / (P2.X - P1.X)

        P.Y = (M * (M * C.Y + C.X - P2.X) + P2.Y) / (1 + M * M)
        P.X = C.X + M * (C.Y - P.Y)

        If (P.X >= P1.X And P.X <= P2.X) Or (P.X < P1.X And P.X > P2.X) Then
            If R * R >= MathFunctions.GetSLength(C, P) Then Return True
        ElseIf PointCircle(P1.X, P1.Y, C.X, C.Y, R) Then
            LineCircle = True
        ElseIf PointCircle(P2.X, P2.Y, C.X, C.Y, R) Then
            LineCircle = True
        End If

    End Function



    '---------------------------------------------------
    ' The fallowing code was added by me Created by: X
    '---------------------------------------------------



    Public Sub IntersectLines(ByVal x0 As Single, ByVal y0 As Single, ByVal x1 As Single, ByVal y1 As Single, _
ByVal x2 As Single, ByVal y2 As Single, ByVal x3 As Single, ByVal y3 As Single, _
ByRef xi As Single, ByRef yi As Single)

        '// this function computes the intersection of the sent lines
        '// and returns the intersection point, note that the function assumes
        '// the lines intersect. the function can handle vertical as well
        '// as horizontal lines. note the function isn't very clever, it simply
        '//applies the math, but we don't need speed since this is a
        '//pre-processing step

        Dim a1, b1, c1 As Single '// constants of linear equations
        Dim a2, b2, c2 As Single
        Dim det_inv As Single  '  // the inverse of the determinant of the coefficient

        Dim m1, m2 As Single          ';    // the slopes of each line

        '// compute slopes, note the cludge for infinity, however, this will
        '// be close enough

        If (x1 - x0) <> 0 Then
            m1 = (y1 - y0) / (x1 - x0)
        Else
            m1 = 1.0E+15 '  // close enough to infinity
        End If

        If (x3 - x2) <> 0 Then
            m2 = (y3 - y2) / (x3 - x2)
        Else
            m2 = 1.0E+15 ' // close enough to infinity
        End If

        '// compute constants

        a1 = m1
        a2 = m2

        b1 = -1
        b2 = -1

        c1 = (y0 - m1 * x0)
        c2 = (y2 - m2 * x2)

        '// compute the inverse of the determinate

        det_inv = 1 / (a1 * b2 - a2 * b1)

        '// use Kramers rule to compute xi and yi

        xi = ((b1 * c2 - b2 * c1) * det_inv)
        yi = ((a2 * c1 - a1 * c2) * det_inv)

    End Sub ' // end Intersect_Lines

    Public Function LineRect(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, _
       ByVal Left As Single, ByVal Top As Single, ByVal Right As Single, ByVal Bottom As Single, ByRef X As Single, ByRef Y As Single) As Boolean


        If PointRect(Left, Top, Right, Bottom, X1, Y1) Then
            X = X1
            Y = Y1
            Return True
        End If

        Dim Ret As Boolean = False

        ' line starts above
        If Y1 < Top + ((Bottom - Top) / 2) Then
            If HLineIntersect(X1, Y1, X2, Y2, Top, Left, Right, X) Then
                Y = Top
                Ret = True
            End If
        Else ' line starts below
            If HLineIntersect(X1, Y1, X2, Y2, Bottom, Left, Right, X) Then
                Y = Bottom
                Ret = True
            End If
        End If

        ' line starts from the left
        If X1 < Left + ((Right - Left) / 2) Then
            If VLineIntersect(X1, Y1, X2, Y2, Left, Top, Bottom, Y) Then
                X = Left
                Ret = True
            End If
        Else ' line starts from the right
            If VLineIntersect(X1, Y1, X2, Y2, Right, Top, Bottom, Y) Then
                X = Right
                Ret = True
            End If
        End If

        Return Ret
    End Function

    Public Function VLineIntersect(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, _
                                  ByVal LineX As Single, ByVal Top As Single, ByVal Bottom As Single, ByRef Value As Single) As Boolean
        ' check if lines cross
        If (X1 < LineX And X2 < LineX) Or (X1 > LineX And X2 > LineX) Then Return False

        Dim TY, BY As Single
        ' get top and bottm values for vert line
        If Top > Bottom Then
            TY = Bottom
            BY = Top
        Else
            TY = Top
            BY = Bottom
        End If

        ' check if lines are both vertical and overlap
        If X1 = X2 And X1 = LineX Then
            ' check if start point of line is inside vert line
            If Y1 >= TY And Y1 <= BY Then
                Value = Y1
                Return True
            End If

            ' get top and bottom values for the line
            If Y1 > Y2 Then
                If Y1 >= BY And Y2 <= BY Then
                    Value = BY
                    Return True
                End If
                If Y1 > BY Then Return False
            Else
                If Y1 <= TY And Y2 >= TY Then
                    Value = TY
                    Return True
                End If
                If Y2 < TY Then Return False
            End If
        End If

        Dim YPos As Single

        YPos = Y1 + ((LineX - X1) * (Y2 - Y1) / (X2 - X1))

        If YPos >= TY And YPos <= BY Then
            Value = YPos
            Return True
        End If

        Return False
    End Function

    Public Function HLineIntersect(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, _
                                   ByVal LineY As Single, ByVal Left As Single, ByVal Right As Single, ByRef Value As Single) As Boolean
        ' check if lines cross
        If (Y1 < LineY And Y2 < LineY) Or (Y1 > LineY And Y2 > LineY) Then Return False

        Dim LX, RX As Single
        ' get top and bottm values for vert line
        If Left > Right Then
            LX = Right
            RX = Left
        Else
            LX = Left
            RX = Right
        End If

        ' check if lines are both vertical and overlap
        If Y1 = Y2 And Y1 = LineY Then
            ' check if start point of line is inside vert line
            If X1 >= LX And X1 <= RX Then
                Value = X1
                Return True
            End If

            ' get top and bottom values for the line
            If X1 > X2 Then
                If X1 >= RX And X2 <= RX Then
                    Value = RX
                    Return True
                End If
                If X1 > RX Then Return False
            Else
                If X1 <= LX And X2 >= LX Then
                    Value = LX
                    Return True
                End If
                If X2 < LX Then Return False
            End If
        End If

        Dim XPos As Single

        XPos = X1 + ((LineY - Y1) * (X2 - X1) / (Y2 - Y1))

        If XPos >= LX And XPos <= RX Then
            Value = XPos
            Return True
        End If

        Return False
    End Function

End Module