'Created by: X
'Copyright: Created by: X
'Web: http://www.createdbyx.com/
'Date: Tuesday, April 05, 2005
'=============================================


Imports Microsoft.DirectX.Direct3D.Geometry

''' <summary>
''' Contains a methods to assist in lighting related functionality.
''' </summary>
Public module LightHelpers
    'TODO: add more light creation overloads

    Public Function CreateDirectionalLight(ByVal X As Single, ByVal Y As Single, ByVal Z As Single, _
    ByVal DirectionX As Single, ByVal DirectionY As Single, ByVal DirectionZ As Single, ByVal Color As Color) As Direct3D.Light
        Return CreateDirectionalLight(New Vector3(X, Y, Z), New Vector3(DirectionX, DirectionY, DirectionZ), Color)
    End Function

    ''' <summary>
    ''' Creates a directional light.
    ''' </summary>
    ''' <param name="Color">The color of the light.</param>
    ''' <param name="Orient">The lights orientation.</param>
    ''' <returns>Returns a reference to a Direct3D.Light type.</returns>
    Public Function CreateDirectionalLight(ByVal Position As Vector3, ByVal Direction As Vector3, ByVal Color As Color) As Direct3D.Light
        Dim L As Direct3D.Light

        L = New Direct3D.Light()
        L.Type = Direct3D.LightType.Directional
        L.Position = Position
        L.Direction = Direction
        L.Ambient = Color
        L.Diffuse = L.Ambient
        L.Range = 1000000
        Return L
    End Function

    ''' <summary>
    ''' Creates a point light.
    ''' </summary>
    ''' <param name="Color">The color of the light.</param>
    ''' <param name="Position">The lights position.</param>
    ''' <param name="Range">The range the light will illuminate.</param>
    ''' <returns>Returns a reference to a Direct3D.Light type.</returns>
    Public Function CreatePointLight(ByVal Color As Color, ByVal Position As Vector3, ByVal Range As Single) As Direct3D.Light
        Dim L As Direct3D.Light

        L = New Direct3D.Light()
        L.Type = Direct3D.LightType.Point
        L.Position = Position
        L.Attenuation0 = 1
        L.Attenuation1 = 0
        L.Range = Range
        L.Ambient = Color
        L.Diffuse = L.Ambient

        Return L
    End Function
End Module
