'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@yahoo.com
'Web: http://www.createdbyx.com/
'Date: August 6, 2003
'=============================================

Imports Microsoft.DirectX.Direct3D.Geometry

''' <summary>
''' Contains a methods to assist with math related functionality.
''' </summary>
Public Module MathHelpers2
    ''' <summary>
    ''' Linear interpolates between the values of 2 matricies.
    ''' </summary>
    ''' <param name="M1">A source Matrix type.</param>
    ''' <param name="M2">A destination Matrix type.</param>
    ''' <param name="S">Value to linearly interpolate between the matrix values.</param>
    ''' <returns>Returns a reference to a Matrix type.</returns>
    Public Function LerpMatrix(ByVal M1 As Matrix, ByVal M2 As Matrix, ByVal S As Single) As Matrix
        Dim Ret As Matrix

        Ret.M11 = M1.M11 + (S * (M2.M11 - M1.M11))
        Ret.M12 = M1.M12 + (S * (M2.M12 - M1.M12))
        Ret.M13 = M1.M13 + (S * (M2.M13 - M1.M13))
        Ret.M14 = M1.M14 + (S * (M2.M14 - M1.M14))

        Ret.M21 = M1.M21 + (S * (M2.M21 - M1.M21))
        Ret.M22 = M1.M22 + (S * (M2.M22 - M1.M22))
        Ret.M23 = M1.M23 + (S * (M2.M23 - M1.M23))
        Ret.M24 = M1.M24 + (S * (M2.M24 - M1.M24))

        Ret.M31 = M1.M31 + (S * (M2.M31 - M1.M31))
        Ret.M32 = M1.M32 + (S * (M2.M32 - M1.M32))
        Ret.M33 = M1.M33 + (S * (M2.M33 - M1.M33))
        Ret.M34 = M1.M34 + (S * (M2.M34 - M1.M34))

        Ret.M41 = M1.M41 + (S * (M2.M41 - M1.M41))
        Ret.M42 = M1.M42 + (S * (M2.M42 - M1.M42))
        Ret.M43 = M1.M43 + (S * (M2.M43 - M1.M43))
        Ret.M44 = M1.M44 + (S * (M2.M44 - M1.M44))

        Return Ret
    End Function

    '''' <summary>
    '''' Calculates the length of a right triangles side.
    '''' </summary>
    '''' <param name="Length">The length of the triangles opposite side.</param>
    '''' <param name="Angle">The angle specifing the hypotenuse.</param>
    '''' <returns>Returns the length of the right triangles side.</returns>
    'public Function TriangleSideLength(ByVal Length As Single, ByVal Angle As Single) As Single
    '    Return CSng((Length / 2) / System.Math.Tan(Angle))
    'End Function

    ''' <summary>
    ''' Moves a position using an angle and speed value.
    ''' </summary>
    ''' <param name="X">The start X position.</param>
    ''' <param name="Y">The start Y position.</param>
    ''' <param name="Speed">The speed (distance) to move the position.</param>
    ''' <param name="Angle">The angle that the position will be moved along.</param>
    ''' <param name="NewX">Will be set to the move position.</param>
    ''' <param name="NewY">Will be set to the move position.</param>
    Public Sub Displacement(ByVal X As Single, ByVal Y As Single, ByVal Distance As Single, ByVal Angle As Single, _
                                   ByRef NewX As Single, ByRef NewY As Single)
        NewX = CSng(X + (System.Math.Cos(Angle) * Distance))
        NewY = CSng(Y + (System.Math.Sin(Angle) * Distance))
    End Sub

    Public Function Distance(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single) As Single
        Return CSng(Math.Sqrt((Math.Abs(X1 - X2) ^ 2) + (Math.Abs(Y1 - Y2) ^ 2)))
    End Function

    Public Function GetRotationInRadians(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single) As Single
        Dim Rot As Single
        Rot = CSng(Math.Atan2(Y2 - Y1, X2 - X1))
        If Rot < 0 Then Rot += CSng(2.0F * Math.PI)
        Return Rot
    End Function

    Public Function GetRotationInDegrees(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single) As Single
        Dim Rot As Single
        Rot = CSng(Math.Atan2(Y2 - Y1, X2 - X1))
        If Rot < 0 Then Rot += CSng(2.0F * Math.PI)
        Rot = Rot * CSng(180 / Math.PI)
        Return Rot
    End Function
End Module
