﻿Public Interface ILockOnTarget
    Property TargetPosition() As Vector3
End Interface

Public Class LockOnTargetPosition
    Implements ILockOnTarget

    Protected Friend mobjPosition As Vector3

    Public Overridable Property TargetPosition() As Microsoft.DirectX.Vector3 Implements ILockOnTarget.TargetPosition
        Get
            Return mobjPosition
        End Get
        Set(ByVal value As Microsoft.DirectX.Vector3)
            mobjPosition = value
        End Set
    End Property
End Class

Public Class LockOnTargetRelative
    Inherits LockOnTargetPosition

    Protected Friend mobjRelative As Vector3


    Public Overridable Property Relative() As Vector3
        Get
            Return mobjRelative
        End Get
        Set(ByVal value As Vector3)
            mobjRelative = value
        End Set
    End Property

    Public Overrides Property TargetPosition() As Microsoft.DirectX.Vector3
        Get
            Return Vector3.Subtract(mobjPosition, mobjRelative)
        End Get
        Set(ByVal value As Microsoft.DirectX.Vector3)
            mobjPosition = value
        End Set
    End Property
End Class

Public Module LockOnTarget

    Public Class LOT
        Public Parent As String
        Public Child As String
    End Class

    Public Enum LockOnType
        Camera
        CameraTarget
        Mesh
        Point
    End Enum

    Friend mobjLockOnTargets As New Collections.ArrayList() ' .Generic.Collection(Of ILockOnTarget)

End Module