﻿'Friend NotInheritable Class Material
'    Friend mstrName As String
'    Public Material As Direct3D.Material
'    ' Friend mobjMaterialsCollectionReference As Collections.Generic.Dictionary(Of String, Material)

'    Public Property Name() As String
'        Get
'            Return mstrName
'        End Get
'        Set(ByVal value As String)
'            If value.Trim = String.Empty Then Throw New ArgumentNullException("Value")
'            If mobjMaterials Is Nothing = False Then
'                If mobjMaterials.ContainsKey(mstrName) Then mobjMaterials.Remove(mstrName)
'            End If
'            mstrName = value
'            If mobjMaterials Is Nothing = False Then
'                mobjMaterials.Add(mstrName, Me)
'            End If
'        End Set
'    End Property
'End Class

Public Module Materials

    Friend mobjMaterials As New Collections.Hashtable() ' .Generic.Dictionary(Of String, Material)
    Friend mstrCurrentMaterial As String = String.Empty
    Public Const CURRENTMATERIAL As String = "{F87014B2-BE03-4282-A7FF-24033E9F60C9}"


    Public Function SetCurrentMaterial(ByVal Material As Direct3D.Material) As Boolean
        If mblnHasBeenInit = False Then Return False
        mobjDevice.Material = Material
        Return True
    End Function

    Public Function ChangeMaterialName(ByRef Name As String, ByVal Value As String) As Boolean
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) Then Return False
        If mobjMaterials.ContainsKey(Value) Then Return False
        Dim Item As Direct3D.Material
        Item = DirectCast(mobjMaterials(Name), Direct3D.Material)
        mobjMaterials.Remove(Name)
        mobjMaterials.Add(Value, Item)

        Return True
    End Function

    Public Function GetMaterialNames(ByRef Names() As String) As Boolean
        Erase Names
        ReDim Names(mobjMaterials.Count - 1)
        mobjMaterials.Keys.CopyTo(Names, 0)

        Return True
    End Function

    Public Function GetCurrentMaterial() As String
        If mobjViewports.ContainsKey(mstrCurrentMaterial) = False Then Return Nothing
        Return mstrCurrentMaterial 'DirectCast(mobjMaterials(mstrCurrentMaterial), Material)
    End Function

    Public Function SetCurrentMaterial(ByVal Name As String, Optional ByVal ApplyMaterial As Boolean = True) As Boolean
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) = False Then Return False
        mstrCurrentMaterial = Name
        If ApplyMaterial Then
            If mblnHasBeenInit = False Then
                SpecifyError(, "Graphics have not been init!")
                Return False
            End If
            mobjDevice.Material = DirectCast(mobjMaterials(Name), Direct3D.Material)
        End If
        Return True
    End Function

    Public Function ApplyMaterial(ByVal Name As String) As Boolean
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) = False Then Return False
        mobjDevice.Material = DirectCast(mobjMaterials(Name), Direct3D.Material)
        Return True
    End Function

    Public Function ApplyMaterial(ByVal Color As Color) As Boolean
        If mblnHasBeenInit = False Then Return False
        Dim Mat As New Direct3D.Material()
        Mat.Ambient = Color
        Mat.Diffuse = Color
        mobjDevice.Material = Mat
        Return True
    End Function

    Public Function GetNumberOfMaterials() As Integer
        Return mobjMaterials.Count
    End Function

    Public Sub RemoveAllMaterials()
        mobjMaterials.Clear()
    End Sub

    Public Function RemoveMaterial(ByVal Name As String) As Boolean
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) = False Then Return False
        If Name = mstrCurrentMaterial Then mstrCurrentMaterial = String.Empty
        ' mobjMaterials(Name).mobjMaterialsCollectionReference = Nothing
        mobjMaterials.Remove(Name)
        Return True
    End Function

    Public Function AddMaterial(ByVal Name As String, ByVal Material As Direct3D.Material, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        '  Dim Value As New Material()
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) Then Return False
        ' Value.mobjMaterialsCollectionReference = mobjMaterials
        ' Value.mstrName = Name
        ' Value.Material = Material
        mobjMaterials.Add(Name, Material)
        If mstrCurrentMaterial = String.Empty Then mstrCurrentMaterial = Name
        If SetAsCurrent Then mstrCurrentMaterial = Name
        Return True
    End Function

    Public Function AddMaterial(ByVal Name As String, ByVal Diffuse As Color, ByVal Ambient As Color, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        Dim Value As New Direct3D.Material()
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) Then Return False
        Value.Diffuse = Diffuse
        Value.Ambient = Ambient
        Value.Emissive = Color.White
        Value.Specular = Color.White
        Value.SpecularSharpness = 1 'SpecularSharpness

        mobjMaterials.Add(Name, Value)
        If mstrCurrentMaterial = String.Empty Then mstrCurrentMaterial = Name
        If SetAsCurrent Then mstrCurrentMaterial = Name
        Return True
    End Function

    Public Function AddMaterial(ByVal Name As String, ByVal Diffuse As Color, ByVal Ambient As Color, ByVal Emmisive As Color, ByVal Specular As Color, ByVal SpecularSharpness As Single, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        Dim Value As New Direct3D.Material()
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) Then Return False
        Value.Diffuse = Diffuse
        Value.Ambient = Ambient
        Value.Emissive = Emmisive
        Value.Specular = Specular
        Value.SpecularSharpness = SpecularSharpness
        mobjMaterials.Add(Name, Value)
        If mstrCurrentMaterial = String.Empty Then mstrCurrentMaterial = Name
        If SetAsCurrent Then mstrCurrentMaterial = Name
        Return True
    End Function

    Public Function GetMaterial(ByVal Name As String, ByRef Value As Direct3D.Material) As Boolean
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) = False Then Return False
        Value = DirectCast(mobjMaterials(Name), Direct3D.Material)
        Return True
    End Function

    Public Function SetMaterial(ByVal Name As String, ByVal Value As Direct3D.Material) As Boolean
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) = False Then Return False
        mobjMaterials(Name) = Value
        Return True
    End Function

    Public Function SetMaterial(ByVal Name As String, ByVal Diffuse As Color, ByVal Ambient As Color, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        Dim Value As New Direct3D.Material()
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) Then Return False
        Value = DirectCast(mobjMaterials(Name), Direct3D.Material)
        Value.Diffuse = Diffuse
        Value.Ambient = Ambient

        mobjMaterials(Name) = Value
        ' If mstrCurrentMaterial = String.Empty Then mstrCurrentMaterial = Name
        If SetAsCurrent Then mstrCurrentMaterial = Name
        Return True
    End Function

    Public Function SetMaterial(ByVal Name As String, ByVal Diffuse As Color, ByVal Ambient As Color, ByVal Emmisive As Color, ByVal Specular As Color, ByVal SpecularSharpness As Single, Optional ByVal SetAsCurrent As Boolean = False) As Boolean
        Dim Value As New Direct3D.Material()
        If Name = CURRENTMATERIAL Then Name = mstrCurrentViewport
        If mobjMaterials.ContainsKey(Name) Then Return False
        Value = DirectCast(mobjMaterials(Name), Direct3D.Material)
        Value.Diffuse = Diffuse
        Value.Ambient = Ambient
        Value.Emissive = Emmisive
        Value.Specular = Specular
        Value.SpecularSharpness = SpecularSharpness
        mobjMaterials(Name) = Value
        ' If mstrCurrentMaterial = String.Empty Then mstrCurrentMaterial = Name
        If SetAsCurrent Then mstrCurrentMaterial = Name
        Return True
    End Function

    Public Function GetDeviceMaterial(ByRef Value As Direct3D.Material) As Boolean
        If mblnHasBeenInit = False Then Return False
        Value = mobjDevice.Material
        Return True
    End Function
End Module
