﻿Public Module MathHelpers
    ''' <summary>
    ''' Rotates a position around a specified avis.
    ''' </summary>
    ''' <param name="Axis">The point in 3D space that the Position will be rotated around.</param>
    ''' <param name="Position">The starting position you want to rotate.</param>
    ''' <param name="Rotation">The XYZ rotation value to rotate.</param>
    ''' <returns></returns>
    Public Function RotateAroundAxis(ByVal Axis As Vector3, ByVal Position As Vector3, ByVal Rotation As Vector3, _
    Optional ByVal YawPitchRoll As Boolean = True) As Vector3
        Dim Tmp As Vector3
        Dim M As Matrix = Matrix.Identity

        ' TODO: this needs to be re-written (current method works but is too slow)

        Tmp = Vector3.Subtract(Position, Axis)
        M.Multiply(Matrix.Translation(Tmp))
        If YawPitchRoll Then
            M.Multiply(Matrix.RotationYawPitchRoll(Rotation.X, Rotation.Y, Rotation.Z))
        Else
            M.Multiply(Matrix.RotationX(Rotation.X))
            M.Multiply(Matrix.RotationY(Rotation.Y))
            M.Multiply(Matrix.RotationZ(Rotation.Z))
        End If

        Return New Vector3(Axis.X + M.M41, Axis.Y + M.M42, Axis.Z + M.M43)
    End Function

    Public Function RotateAroundAxis(ByVal Axis As Vector3, ByVal Position As Vector3, ByVal Rotation As Quaternion, _
   Optional ByVal YawPitchRoll As Boolean = True) As Vector3
        Dim Tmp As Vector3
        Dim M As Matrix = Matrix.Identity

        ' TODO: this needs to be re-written (current method works but is too slow)

        Tmp = Vector3.Subtract(Position, Axis)
        M.Multiply(Matrix.Translation(Tmp))
        If YawPitchRoll Then
            M.Multiply(Matrix.RotationQuaternion(Quaternion.RotationYawPitchRoll(Rotation.X, Rotation.Y, Rotation.Z)))
        Else
            M.Multiply(Matrix.RotationX(Rotation.X))
            M.Multiply(Matrix.RotationY(Rotation.Y))
            M.Multiply(Matrix.RotationZ(Rotation.Z))
        End If

        Return New Vector3(Axis.X + M.M41, Axis.Y + M.M42, Axis.Z + M.M43)
    End Function
End Module
