﻿Public Module RenderToSurfaces

    Friend mobjRTS As New Collections.Hashtable() ' .Generic.Dictionary(Of String, Direct3D.RenderToSurface)


    Public Function ChangeRenderToSurfaceName(ByRef Name As String, ByVal Value As String) As Boolean
        If mobjRTS.ContainsKey(Name) Then Return False
        If mobjRTS.ContainsKey(Value) Then Return False
        Dim Item As Direct3D.RenderToSurface
        Item = DirectCast(mobjRTS(Name), Direct3D.RenderToSurface)
        mobjRTS.Remove(Name)
        mobjRTS.Add(Value, Item)

        Return True
    End Function

    Public Function GetRenderToSurfaceNames(ByRef Names() As String) As Boolean
        Erase Names
        ReDim Names(mobjRTS.Count - 1)
        mobjRTS.Keys.CopyTo(Names, 0)

        Return True
    End Function

    Public Function GetNumberOfRenderToSurfaces() As Integer
        Return mobjRTS.Count
    End Function

    Public Sub RemoveAllRenderToSurface(Optional ByVal CallDispose As Boolean = True)
        If CallDispose Then
            With mobjRTS.GetEnumerator
                ' .Reset()
                While .MoveNext
                    If .Value Is Nothing = False Then
                        DirectCast(.Value, Direct3D.RenderToSurface).Dispose()
                    End If
                End While
            End With
        End If

        mobjRTS.Clear()
    End Sub

    Public Function RemoveRenderToSurface(ByVal Name As String) As Boolean
        If mobjRTS.ContainsKey(Name) = False Then Return False
        mobjRTS.Remove(Name)
        Return True
    End Function

    Public Function AddRenderToSurface(ByVal Name As String, ByVal Value As Direct3D.RenderToSurface) As Boolean
        If mobjRTS.ContainsKey(Name) Then Return False
        mobjRTS.Add(Name, Value)
        Return True
    End Function

    Public Function CreateRenderToSurface(ByVal Name As String, ByVal Width As Integer, ByVal Height As Integer, _
    Optional ByVal DepthStencil As Boolean = False, Optional ByVal DepthFormat As Direct3D.DepthFormat = Direct3D.DepthFormat.D16) As Boolean
        If mblnHasBeenInit = False Then Return False
        If mobjRTS.ContainsKey(Name) Then Return False

        Dim Value As Direct3D.RenderToSurface
        Value = New Direct3D.RenderToSurface(mobjDevice, Width, Height, mobjDevice.DisplayMode.Format, DepthStencil, DepthFormat)
        mobjRTS.Add(Name, Value)
        Return True
    End Function

    Public Function RenderToSurfaceExists(ByVal Name As String) As Boolean
        Return mobjRTS.ContainsKey(Name)
    End Function

    Public Function GetRenderToSurface(ByVal Name As String, ByRef Value As Direct3D.RenderToSurface) As Boolean
        If mobjRTS.ContainsKey(Name) = False Then Return False
        Value = DirectCast(mobjRTS(Name), Direct3D.RenderToSurface)
        Return True
    End Function
End Module
