﻿
Public Module Sprites

    Friend mobj2DSprites As New Collections.ArrayList() ' .Generic.Collection(Of Sprite2D)
    Friend mobj3DSprites As New Collections.ArrayList() ' .Generic.Collection(Of Sprite3D)


    Public Sub RemoveAll2DSprites()
        mobj2DSprites.Clear()
    End Sub

    Public Sub RemoveAll3DSprites()
        mobj3DSprites.Clear()
    End Sub

    Public Sub RemoveAllSprites()
        mobj2DSprites.Clear()
        mobj3DSprites.Clear()
    End Sub

    Public Function GetNumberOf2DSprites() As Integer
        Return mobj2DSprites.Count
    End Function

    Public Function GetNumberOf3DSprites() As Integer
        Return mobj3DSprites.Count
    End Function

    Public Function Remove2DSprite(ByVal Index As Integer) As Boolean
        If Index < 0 Then Return False
        If Index > mobj2DSprites.Count - 1 Then Return False
        mobj2DSprites.Removeat(Index)
        Return True
    End Function

    Public Function AddSprite(ByVal Value As Sprite2D, Optional ByRef Index As Integer = -1) As Boolean
        Index = mobj2DSprites.Add(Value)
        Return True
    End Function

    Public Function AddSprite(ByVal Value As Sprite3D, Optional ByRef Index As Integer = -1) As Boolean
        Index = mobj3DSprites.Add(Value)
        Return True
    End Function

    Public Function SetSprite(ByVal Index As Integer, ByVal Value As Sprite2D) As Boolean
        If Index < 0 Then Return False
        If Index > mobj2DSprites.Count - 1 Then Return False
        mobj2DSprites(Index) = Value
        Return True
    End Function

    Public Function SetSprite(ByVal Index As Integer, ByVal Value As Sprite3D) As Boolean
        If Index < 0 Then Return False
        If Index > mobj3DSprites.Count - 1 Then Return False
        mobj3DSprites(Index) = Value
        Return True
    End Function

    Public Function GetSprite(ByVal Index As Integer, ByRef Value As Sprite2D) As Boolean
        If Index < 0 Then Return False
        If Index > mobj2DSprites.Count - 1 Then Return False
        Value = DirectCast(mobj2DSprites(Index), Sprite2D)
        Return True
    End Function

    Public Function GetSprite(ByVal Index As Integer, ByRef Value As Sprite3D) As Boolean
        If Index < 0 Then Return False
        If Index > mobj3DSprites.Count - 1 Then Return False
        Value = DirectCast(mobj3DSprites(Index), Sprite3D)
        Return True
    End Function
End Module
