﻿Public Class IntervalUpdate
    Implements IDisposable

    Public Event IntervalEllapsed()

    Protected Friend mintPreviousTime As Long
    Protected Friend mintCapturedTime As Long
    Protected Friend mintInterval As Long = 1
    Protected Friend mobjTimer As ITimer
    Protected Friend mblnRaiseExceptions As Boolean = False



    Public Overridable Property RaiseExceptions() As Boolean
        Get
            Return Me.mblnRaiseExceptions
        End Get
        Set(ByVal value As Boolean)
            Me.mblnRaiseExceptions = value
        End Set
    End Property

    Public Overridable Sub Update()
        If Me.disposed Then Exit Sub
        ' get the currwnt time
        Me.mintCapturedTime = Me.mobjtimer.GetTimeInfo(TimeInformation.SystemTime)
        ' check if time to fire event
        If Me.mintCapturedTime > Me.mintPreviousTime + (Me.mobjTimer.GetTimeInfo(TimeInformation.Frequency) / Me.mintInterval) Then
            Try
                RaiseEvent IntervalEllapsed()
            Catch ex As Exception
                If Me.mblnRaiseExceptions Then Throw ex
            End Try
            Me.mintPreviousTime = Me.mintCapturedTime
        End If
    End Sub

    Public ReadOnly Property CapturedTime() As Long
        Get
            Return mintCapturedTime
        End Get
    End Property

    Public ReadOnly Property PreviousTime() As Long
        Get
            Return mintPreviousTime
        End Get
    End Property

    Public Overridable Property Interval() As Long
        Get
            Return mintInterval
        End Get
        Set(ByVal value As Long)
            mintInterval = value
        End Set
    End Property

    Public Sub New(ByVal Timer As ITimer, Optional ByVal Interval As Long = 1)
        Me.mobjTimer = Timer
        Me.mintInterval = Interval
    End Sub


    Public Sub New(Optional ByVal Interval As Long = 1)
        Me.mobjTimer = New Timer()
        Me.mintInterval = Interval
    End Sub

#Region " IDisposable Support "
    Private disposed As Boolean = False

    ' IDisposable
    Private Overloads Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposed Then
            If disposing Then
                Me.mobjTimer = Nothing
            End If

            ' TODO: put code to free unmanaged resources here
        End If
        Me.disposed = True
    End Sub

    ' This code added by Visual Basic to correctly implement the disposable pattern.
    Public Overloads Sub Dispose() Implements IDisposable.Dispose
        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Protected Overrides Sub Finalize()
        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
        Dispose(False)
        MyBase.Finalize()
    End Sub
#End Region

End Class
