'Created by: X
'Copyright: Created by: X
'E-Mail: mailto:createdbyx@gmail.com
'Web: http://www.createdbyx.com/
'Date: July 1, 2004
'=============================================


Public Enum TimeInformation As Integer
    CapturedTime = 0
    PreviousCapturedTime = 1
    SystemTime = 2
    Duration = 3
    DurationSincePreviousCapture = 4
    DurationSinceStart = 5
    Frequency = 6
    StartTime = 7
End Enum

''' <summary>
''' The GameTimer class is used to represent time.
''' </summary>
Public Class Timer
    Implements ICloneable, ITimer

    Protected Friend mlngLastCapturedTime As Long
    Protected Friend mlngCapturedTime As Long
    Protected Friend mlngFrequency As Long = TimeSpan.FromSeconds(1).Ticks
    Protected Friend mlngStartTime As Long


    ''' <summary>
    ''' Creates a new instance of the class.
    ''' </summary>
    Public Sub New()
        Me.CaptureTime()
        Me.mlngStartTime = mlngCapturedTime
    End Sub

    Public Overridable Function CaptureTime() As Long Implements ITimer.CaptureTime
        mlngLastCapturedTime = mlngCapturedTime
        mlngCapturedTime = Now.Ticks
        Return mlngCapturedTime
    End Function

    Public Overridable Function GetTimeInfo(ByVal Info As TimeInformation) As Long Implements ITimer.GetTimeInfo
        Select Case Info
            Case TimeInformation.CapturedTime
                Return mlngCapturedTime

            Case TimeInformation.Duration
                Return Now.Ticks - mlngCapturedTime

            Case TimeInformation.DurationSincePreviousCapture
                Return Now.Ticks - mlngLastCapturedTime

            Case TimeInformation.Frequency
                Return mlngFrequency

            Case TimeInformation.PreviousCapturedTime
                Return Me.mlngLastCapturedTime

            Case TimeInformation.SystemTime
                Return Now.Ticks

            Case TimeInformation.StartTime
                Return mlngStartTime

            Case TimeInformation.DurationSinceStart
                Return Now.Ticks - mlngStartTime
        End Select
    End Function

    Public Overridable Function Clone() As Object Implements System.ICloneable.Clone
        Dim Tmp As New Timer()
        Tmp.mlngCapturedTime = Me.mlngCapturedTime
        Tmp.mlngFrequency = Me.mlngFrequency
        Tmp.mlngLastCapturedTime = Me.mlngLastCapturedTime
        Tmp.mlngStartTime = Me.mlngStartTime
        Return Tmp
    End Function
End Class
